import { makeInner as C, normalizeToArray as R } from "../util/model.mjs";
import { keys as T, reduce as O, each as Y, extend as A, hasOwn as E, indexOf as F, isArrayLike as G, bind as U, assert as P, eqNaN as X } from "../../../zrender/lib/core/util.mjs";
import { cloneValue as j } from "../../../zrender/lib/animation/Animator.mjs";
import q from "../../../zrender/lib/graphic/Displayable.mjs";
import { getAnimationConfig as z } from "./basicTransition.mjs";
import "../util/graphic.mjs";
import { warn as M } from "../util/log.mjs";
import { TRANSFORMABLE_PROPS as D } from "../../../zrender/lib/core/Transformable.mjs";
import H from "../../../zrender/lib/graphic/Path.mjs";
var w = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
}, V = T(w), N = O(D, function(r, n) {
  return r[n] = 1, r;
}, {}), I = D.join(", "), x = ["", "style", "shape", "extra"], m = C();
function _(r, n, a, t, s) {
  var e = r + "Animation", i = z(r, t, s) || {}, o = m(n).userDuring;
  return i.duration > 0 && (i.during = o ? U(K, {
    el: n,
    userDuring: o
  }) : null, i.setToFinal = !0, i.scope = r), A(i, a[e]), i;
}
function lr(r, n, a, t) {
  t = t || {};
  var s = t.dataIndex, e = t.isInit, i = t.clearStyle, o = a.isAnimationEnabled(), h = m(r), u = n.style;
  h.userDuring = n.during;
  var v = {}, f = {};
  if (rr(r, n, f), L("shape", n, f), L("extra", n, f), !e && o && (k(r, n, v), b("shape", r, n, v), b("extra", r, n, v), nr(r, n, u, v)), f.style = u, Q(r, f, i), Z(r, n), o)
    if (e) {
      var c = {};
      Y(x, function(l) {
        var y = l ? n[l] : n;
        y && y.enterFrom && (l && (c[l] = c[l] || {}), A(l ? c[l] : c, y.enterFrom));
      });
      var g = _("enter", r, n, a, s);
      g.duration > 0 && r.animateFrom(c, g);
    } else
      W(r, n, s || 0, a, v);
  J(r, n), u ? r.dirty() : r.markRedraw();
}
function J(r, n) {
  for (var a = m(r).leaveToProps, t = 0; t < x.length; t++) {
    var s = x[t], e = s ? n[s] : n;
    e && e.leaveTo && (a || (a = m(r).leaveToProps = {}), s && (a[s] = a[s] || {}), A(s ? a[s] : a, e.leaveTo));
  }
}
function dr(r, n, a, t) {
  if (r) {
    var s = r.parent, e = m(r).leaveToProps;
    if (e) {
      var i = _("update", r, n, a, 0);
      i.done = function() {
        s.remove(r);
      }, r.animateTo(e, i);
    } else
      s.remove(r);
  }
}
function p(r) {
  return r === "all";
}
function Q(r, n, a) {
  var t = n.style;
  if (!r.isGroup && t) {
    if (a) {
      r.useStyle({});
      for (var s = r.animators, e = 0; e < s.length; e++) {
        var i = s[e];
        i.targetName === "style" && i.changeTarget(r.style);
      }
    }
    r.setStyle(t);
  }
  n && (n.style = null, n && r.attr(n), n.style = t);
}
function W(r, n, a, t, s) {
  if (s) {
    var e = _("update", r, n, t, a);
    e.duration > 0 && r.animateFrom(s, e);
  }
}
function Z(r, n) {
  E(n, "silent") && (r.silent = n.silent), E(n, "ignore") && (r.ignore = n.ignore), r instanceof q && E(n, "invisible") && (r.invisible = n.invisible), r instanceof H && E(n, "autoBatch") && (r.autoBatch = n.autoBatch);
}
var d = {}, $ = {
  // Usually other props do not need to be changed in animation during.
  setTransform: function(r, n) {
    return process.env.NODE_ENV !== "production" && P(E(N, r), "Only " + I + " available in `setTransform`."), d.el[r] = n, this;
  },
  getTransform: function(r) {
    return process.env.NODE_ENV !== "production" && P(E(N, r), "Only " + I + " available in `getTransform`."), d.el[r];
  },
  setShape: function(r, n) {
    process.env.NODE_ENV !== "production" && S(r);
    var a = d.el, t = a.shape || (a.shape = {});
    return t[r] = n, a.dirtyShape && a.dirtyShape(), this;
  },
  getShape: function(r) {
    process.env.NODE_ENV !== "production" && S(r);
    var n = d.el.shape;
    if (n)
      return n[r];
  },
  setStyle: function(r, n) {
    process.env.NODE_ENV !== "production" && S(r);
    var a = d.el, t = a.style;
    return t && (process.env.NODE_ENV !== "production" && X(n) && M("style." + r + " must not be assigned with NaN."), t[r] = n, a.dirtyStyle && a.dirtyStyle()), this;
  },
  getStyle: function(r) {
    process.env.NODE_ENV !== "production" && S(r);
    var n = d.el.style;
    if (n)
      return n[r];
  },
  setExtra: function(r, n) {
    process.env.NODE_ENV !== "production" && S(r);
    var a = d.el.extra || (d.el.extra = {});
    return a[r] = n, this;
  },
  getExtra: function(r) {
    process.env.NODE_ENV !== "production" && S(r);
    var n = d.el.extra;
    if (n)
      return n[r];
  }
};
function S(r) {
  if (process.env.NODE_ENV !== "production" && (r === "transition" || r === "enterFrom" || r === "leaveTo"))
    throw new Error('key must not be "' + r + '"');
}
function K() {
  var r = this, n = r.el;
  if (n) {
    var a = m(n).userDuring, t = r.userDuring;
    if (a !== t) {
      r.el = r.userDuring = null;
      return;
    }
    d.el = n, t($);
  }
}
function b(r, n, a, t) {
  var s = a[r];
  if (s) {
    var e = n[r], i;
    if (e) {
      var o = a.transition, h = s.transition;
      if (h)
        if (!i && (i = t[r] = {}), p(h))
          A(i, e);
        else
          for (var u = R(h), v = 0; v < u.length; v++) {
            var f = u[v], c = e[f];
            i[f] = c;
          }
      else if (p(o) || F(o, r) >= 0) {
        !i && (i = t[r] = {});
        for (var g = T(e), v = 0; v < g.length; v++) {
          var f = g[v], c = e[f];
          tr(s[f], c) && (i[f] = c);
        }
      }
    }
  }
}
function L(r, n, a) {
  var t = n[r];
  if (t)
    for (var s = a[r] = {}, e = T(t), i = 0; i < e.length; i++) {
      var o = e[i];
      s[o] = j(t[o]);
    }
}
function k(r, n, a) {
  for (var t = n.transition, s = p(t) ? D : R(t || []), e = 0; e < s.length; e++) {
    var i = s[e];
    if (!(i === "style" || i === "shape" || i === "extra")) {
      var o = r[i];
      process.env.NODE_ENV !== "production" && B(i, "el.transition"), a[i] = o;
    }
  }
}
function rr(r, n, a) {
  for (var t = 0; t < V.length; t++) {
    var s = V[t], e = w[s], i = n[s];
    i && (a[e[0]] = i[0], a[e[1]] = i[1]);
  }
  for (var t = 0; t < D.length; t++) {
    var o = D[t];
    n[o] != null && (a[o] = n[o]);
  }
}
function nr(r, n, a, t) {
  if (a) {
    var s = r.style, e;
    if (s) {
      var i = a.transition, o = n.transition;
      if (i && !p(i)) {
        var h = R(i);
        !e && (e = t.style = {});
        for (var u = 0; u < h.length; u++) {
          var v = h[u], f = s[v];
          e[v] = f;
        }
      } else if (r.getAnimationStyleProps && (p(o) || p(i) || F(o, "style") >= 0)) {
        var c = r.getAnimationStyleProps(), g = c ? c.style : null;
        if (g) {
          !e && (e = t.style = {});
          for (var l = T(a), u = 0; u < l.length; u++) {
            var v = l[u];
            if (g[v]) {
              var f = s[v];
              e[v] = f;
            }
          }
        }
      }
    }
  }
}
function tr(r, n) {
  return G(r) ? r !== n : r != null && isFinite(r);
}
var B;
process.env.NODE_ENV !== "production" && (B = function(r, n) {
  E(N, r) || M("Prop `" + r + "` is not a permitted in `" + n + "`. Only `" + T(N).join("`, `") + "` are permitted.");
});
export {
  x as ELEMENT_ANIMATABLE_PROPS,
  dr as applyLeaveTransition,
  lr as applyUpdateTransition,
  p as isTransitionAll,
  J as updateLeaveTo
};
//# sourceMappingURL=customGraphicTransition.mjs.map
