import { __extends as ee } from "../../../node_modules/tslib/tslib.es6.mjs";
import pe from "../../../../zrender/lib/graphic/Path.mjs";
import ue from "../../../../zrender/lib/graphic/Group.mjs";
import { map as ge, extend as te, each as de } from "../../../../zrender/lib/core/util.mjs";
import { traverseElements as fe } from "../../util/graphic.mjs";
import { getECData as B } from "../../util/innerStore.mjs";
import { toggleHoverEmphasis as ce, setStatesStylesFromModel as le } from "../../util/states.mjs";
import { labelInner as ve, getLabelStatesModels as me, setLabelStyle as _e, setLabelValueAnimation as be } from "../../label/labelStyle.mjs";
import { throttle as Ae } from "../../util/throttle.mjs";
import { createClipPath as ye } from "../helper/createClipPathFromCoordSys.mjs";
import z from "../../util/shape/sausage.mjs";
import xe from "../../view/Chart.mjs";
import { isCoordinateSystemType as re } from "../../coord/CoordinateSystem.mjs";
import { getDefaultLabel as we, getDefaultInterpolatedLabel as Se } from "../helper/labelHelper.mjs";
import { warn as W } from "../../util/log.mjs";
import { createSectorCalculateTextPosition as De, setSectorTextRotation as Le } from "../../label/sectorLabel.mjs";
import { initProps as P, updateProps as L, saveOldStyle as Ce, removeElementWithFadeOut as U } from "../../animation/basicTransition.mjs";
import { getSectorCornerRadius as Ie } from "../helper/sectorHelper.mjs";
import ae from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import ie from "../../../../zrender/lib/graphic/shape/Sector.mjs";
var E = Math.max, R = Math.min;
function Pe(i, r) {
  var e = i.getArea && i.getArea();
  if (re(i, "cartesian2d")) {
    var t = i.getBaseAxis();
    if (t.type !== "category" || !t.onBand) {
      var a = r.getLayout("bandWidth");
      t.isHorizontal() ? (e.x -= a, e.width += a * 2) : (e.y -= a, e.height += a * 2);
    }
  }
  return e;
}
var it = (
  /** @class */
  function(i) {
    ee(r, i);
    function r() {
      var e = i.call(this) || this;
      return e.type = r.type, e._isFirstFrame = !0, e;
    }
    return r.prototype.render = function(e, t, a, n) {
      this._model = e, this._removeOnRenderedListener(a), this._updateDrawMode(e);
      var o = e.get("coordinateSystem");
      o === "cartesian2d" || o === "polar" ? (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e, t, a) : this._renderNormal(e, t, a, n)) : process.env.NODE_ENV !== "production" && W("Only cartesian2d and polar supported for bar.");
    }, r.prototype.incrementalPrepareRender = function(e) {
      this._clear(), this._updateDrawMode(e), this._updateLargeClip(e);
    }, r.prototype.incrementalRender = function(e, t) {
      this._progressiveEls = [], this._incrementalRenderLarge(e, t);
    }, r.prototype.eachRendered = function(e) {
      fe(this._progressiveEls || this.group, e);
    }, r.prototype._updateDrawMode = function(e) {
      var t = e.pipelineContext.large;
      (this._isLargeDraw == null || t !== this._isLargeDraw) && (this._isLargeDraw = t, this._clear());
    }, r.prototype._renderNormal = function(e, t, a, n) {
      var o = this.group, s = e.getData(), u = this._data, h = e.coordinateSystem, p = h.getBaseAxis(), g;
      h.type === "cartesian2d" ? g = p.isHorizontal() : h.type === "polar" && (g = p.dim === "angle");
      var m = e.isAnimationEnabled() ? e : null, f = ke(e, h);
      f && this._enableRealtimeSort(f, s, a);
      var y = e.get("clip", !0) || f, S = Pe(h, s);
      o.removeClipPath();
      var x = e.get("roundCap", !0), w = e.get("showBackground", !0), A = e.getModel("backgroundStyle"), C = A.get("borderRadius") || 0, D = [], F = this._backgroundEls, G = n && n.isInitSort, T = n && n.type === "changeAxisOrder";
      function M(d) {
        var _ = I[h.type](s, d), c = Be(h, g, _);
        return c.useStyle(A.getItemStyle()), h.type === "cartesian2d" ? c.setShape("r", C) : c.setShape("cornerRadius", C), D[d] = c, c;
      }
      s.diff(u).add(function(d) {
        var _ = s.getItemModel(d), c = I[h.type](s, d, _);
        if (w && M(d), !(!s.hasValue(d) || !J[h.type](c))) {
          var b = !1;
          y && (b = Y[h.type](S, c));
          var l = Z[h.type](e, s, d, c, g, m, p.model, !1, x);
          f && (l.forceLabelAnimation = !0), K(l, s, d, _, c, e, g, h.type === "polar"), G ? l.attr({
            shape: c
          }) : f ? j(f, m, l, c, d, g, !1, !1) : P(l, {
            shape: c
          }, e, d), s.setItemGraphicEl(d, l), o.add(l), l.ignore = b;
        }
      }).update(function(d, _) {
        var c = s.getItemModel(d), b = I[h.type](s, d, c);
        if (w) {
          var l = void 0;
          F.length === 0 ? l = M(_) : (l = F[_], l.useStyle(A.getItemStyle()), h.type === "cartesian2d" ? l.setShape("r", C) : l.setShape("cornerRadius", C), D[d] = l);
          var oe = I[h.type](s, d), he = se(g, oe, h);
          L(l, {
            shape: he
          }, m, d);
        }
        var v = u.getItemGraphicEl(_);
        if (!s.hasValue(d) || !J[h.type](b)) {
          o.remove(v);
          return;
        }
        var N = !1;
        if (y && (N = Y[h.type](S, b), N && o.remove(v)), v ? Ce(v) : v = Z[h.type](e, s, d, b, g, m, p.model, !!v, x), f && (v.forceLabelAnimation = !0), T) {
          var X = v.getTextContent();
          if (X) {
            var O = ve(X);
            O.prevValue != null && (O.prevValue = O.value);
          }
        } else
          K(v, s, d, c, b, e, g, h.type === "polar");
        G ? v.attr({
          shape: b
        }) : f ? j(f, m, v, b, d, g, !0, T) : L(v, {
          shape: b
        }, e, d, null), s.setItemGraphicEl(d, v), v.ignore = N, o.add(v);
      }).remove(function(d) {
        var _ = u.getItemGraphicEl(d);
        _ && U(_, e, d);
      }).execute();
      var k = this._backgroundGroup || (this._backgroundGroup = new ue());
      k.removeAll();
      for (var V = 0; V < D.length; ++V)
        k.add(D[V]);
      o.add(k), this._backgroundEls = D, this._data = s;
    }, r.prototype._renderLarge = function(e, t, a) {
      this._clear(), $(e, this.group), this._updateLargeClip(e);
    }, r.prototype._incrementalRenderLarge = function(e, t) {
      this._removeBackground(), $(t, this.group, this._progressiveEls, !0);
    }, r.prototype._updateLargeClip = function(e) {
      var t = e.get("clip", !0) && ye(e.coordinateSystem, !1, e), a = this.group;
      t ? a.setClipPath(t) : a.removeClipPath();
    }, r.prototype._enableRealtimeSort = function(e, t, a) {
      var n = this;
      if (t.count()) {
        var o = e.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(t, e, a), this._isFirstFrame = !1;
        else {
          var s = function(u) {
            var h = t.getItemGraphicEl(u), p = h && h.shape;
            return p && // The result should be consistent with the initial sort by data value.
            // Do not support the case that both positive and negative exist.
            Math.abs(o.isHorizontal() ? p.height : p.width) || 0;
          };
          this._onRendered = function() {
            n._updateSortWithinSameData(t, s, o, a);
          }, a.getZr().on("rendered", this._onRendered);
        }
      }
    }, r.prototype._dataSort = function(e, t, a) {
      var n = [];
      return e.each(e.mapDimension(t.dim), function(o, s) {
        var u = a(s);
        u = u ?? NaN, n.push({
          dataIndex: s,
          mappedValue: u,
          ordinalNumber: o
        });
      }), n.sort(function(o, s) {
        return s.mappedValue - o.mappedValue;
      }), {
        ordinalNumbers: ge(n, function(o) {
          return o.ordinalNumber;
        })
      };
    }, r.prototype._isOrderChangedWithinSameData = function(e, t, a) {
      for (var n = a.scale, o = e.mapDimension(a.dim), s = Number.MAX_VALUE, u = 0, h = n.getOrdinalMeta().categories.length; u < h; ++u) {
        var p = e.rawIndexOf(o, n.getRawOrdinalNumber(u)), g = p < 0 ? Number.MIN_VALUE : t(e.indexOfRawIndex(p));
        if (g > s)
          return !0;
        s = g;
      }
      return !1;
    }, r.prototype._isOrderDifferentInView = function(e, t) {
      for (var a = t.scale, n = a.getExtent(), o = Math.max(0, n[0]), s = Math.min(n[1], a.getOrdinalMeta().categories.length - 1); o <= s; ++o)
        if (e.ordinalNumbers[o] !== a.getRawOrdinalNumber(o))
          return !0;
    }, r.prototype._updateSortWithinSameData = function(e, t, a, n) {
      if (this._isOrderChangedWithinSameData(e, t, a)) {
        var o = this._dataSort(e, a, t);
        this._isOrderDifferentInView(o, a) && (this._removeOnRenderedListener(n), n.dispatchAction({
          type: "changeAxisOrder",
          componentType: a.dim + "Axis",
          axisId: a.index,
          sortInfo: o
        }));
      }
    }, r.prototype._dispatchInitSort = function(e, t, a) {
      var n = t.baseAxis, o = this._dataSort(e, n, function(s) {
        return e.get(e.mapDimension(t.otherAxis.dim), s);
      });
      a.dispatchAction({
        type: "changeAxisOrder",
        componentType: n.dim + "Axis",
        isInitSort: !0,
        axisId: n.index,
        sortInfo: o
      });
    }, r.prototype.remove = function(e, t) {
      this._clear(this._model), this._removeOnRenderedListener(t);
    }, r.prototype.dispose = function(e, t) {
      this._removeOnRenderedListener(t);
    }, r.prototype._removeOnRenderedListener = function(e) {
      this._onRendered && (e.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, r.prototype._clear = function(e) {
      var t = this.group, a = this._data;
      e && e.isAnimationEnabled() && a && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], a.eachItemGraphicEl(function(n) {
        U(n, e, B(n).dataIndex);
      })) : t.removeAll(), this._data = null, this._isFirstFrame = !0;
    }, r.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, r.type = "bar", r;
  }(xe)
), Y = {
  cartesian2d: function(i, r) {
    var e = r.width < 0 ? -1 : 1, t = r.height < 0 ? -1 : 1;
    e < 0 && (r.x += r.width, r.width = -r.width), t < 0 && (r.y += r.height, r.height = -r.height);
    var a = i.x + i.width, n = i.y + i.height, o = E(r.x, i.x), s = R(r.x + r.width, a), u = E(r.y, i.y), h = R(r.y + r.height, n), p = s < o, g = h < u;
    return r.x = p && o > a ? s : o, r.y = g && u > n ? h : u, r.width = p ? 0 : s - o, r.height = g ? 0 : h - u, e < 0 && (r.x += r.width, r.width = -r.width), t < 0 && (r.y += r.height, r.height = -r.height), p || g;
  },
  polar: function(i, r) {
    var e = r.r0 <= r.r ? 1 : -1;
    if (e < 0) {
      var t = r.r;
      r.r = r.r0, r.r0 = t;
    }
    var a = R(r.r, i.r), n = E(r.r0, i.r0);
    r.r = a, r.r0 = n;
    var o = a - n < 0;
    if (e < 0) {
      var t = r.r;
      r.r = r.r0, r.r0 = t;
    }
    return o;
  }
}, Z = {
  cartesian2d: function(i, r, e, t, a, n, o, s, u) {
    var h = new ae({
      shape: te({}, t),
      z2: 1
    });
    if (h.__dataIndex = e, h.name = "item", n) {
      var p = h.shape, g = a ? "height" : "width";
      p[g] = 0;
    }
    return h;
  },
  polar: function(i, r, e, t, a, n, o, s, u) {
    var h = !a && u ? z : ie, p = new h({
      shape: t,
      z2: 1
    });
    p.name = "item";
    var g = ne(a);
    if (p.calculateTextPosition = De(g, {
      isRoundCap: h === z
    }), n) {
      var m = p.shape, f = a ? "r" : "endAngle", y = {};
      m[f] = a ? t.r0 : t.startAngle, y[f] = t[f], (s ? L : P)(p, {
        shape: y
        // __value: typeof dataValue === 'string' ? parseInt(dataValue, 10) : dataValue
      }, n);
    }
    return p;
  }
};
function ke(i, r) {
  var e = i.get("realtimeSort", !0), t = r.getBaseAxis();
  if (process.env.NODE_ENV !== "production" && e && (t.type !== "category" && W("`realtimeSort` will not work because this bar series is not based on a category axis."), r.type !== "cartesian2d" && W("`realtimeSort` will not work because this bar series is not on cartesian2d.")), e && t.type === "category" && r.type === "cartesian2d")
    return {
      baseAxis: t,
      otherAxis: r.getOtherAxis(t)
    };
}
function j(i, r, e, t, a, n, o, s) {
  var u, h;
  n ? (h = {
    x: t.x,
    width: t.width
  }, u = {
    y: t.y,
    height: t.height
  }) : (h = {
    y: t.y,
    height: t.height
  }, u = {
    x: t.x,
    width: t.width
  }), s || (o ? L : P)(e, {
    shape: u
  }, r, a, null);
  var p = r ? i.baseAxis.model : null;
  (o ? L : P)(e, {
    shape: h
  }, p, a);
}
function q(i, r) {
  for (var e = 0; e < r.length; e++)
    if (!isFinite(i[r[e]]))
      return !0;
  return !1;
}
var Ve = ["x", "y", "width", "height"], Ne = ["cx", "cy", "r", "startAngle", "endAngle"], J = {
  cartesian2d: function(i) {
    return !q(i, Ve);
  },
  polar: function(i) {
    return !q(i, Ne);
  }
}, I = {
  // itemModel is only used to get borderWidth, which is not needed
  // when calculating bar background layout.
  cartesian2d: function(i, r, e) {
    var t = i.getItemLayout(r), a = e ? Ee(e, t) : 0, n = t.width > 0 ? 1 : -1, o = t.height > 0 ? 1 : -1;
    return {
      x: t.x + n * a / 2,
      y: t.y + o * a / 2,
      width: t.width - n * a,
      height: t.height - o * a
    };
  },
  polar: function(i, r, e) {
    var t = i.getItemLayout(r);
    return {
      cx: t.cx,
      cy: t.cy,
      r0: t.r0,
      r: t.r,
      startAngle: t.startAngle,
      endAngle: t.endAngle,
      clockwise: t.clockwise
    };
  }
};
function Oe(i) {
  return i.startAngle != null && i.endAngle != null && i.startAngle === i.endAngle;
}
function ne(i) {
  return /* @__PURE__ */ function(r) {
    var e = r ? "Arc" : "Angle";
    return function(t) {
      switch (t) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return t + e;
        default:
          return t;
      }
    };
  }(i);
}
function K(i, r, e, t, a, n, o, s) {
  var u = r.getItemVisual(e, "style");
  if (s) {
    if (!n.get("roundCap")) {
      var p = i.shape, g = Ie(t.getModel("itemStyle"), p, !0);
      te(p, g), i.setShape(p);
    }
  } else {
    var h = t.get(["itemStyle", "borderRadius"]) || 0;
    i.setShape("r", h);
  }
  i.useStyle(u);
  var m = t.getShallow("cursor");
  m && i.attr("cursor", m);
  var f = s ? o ? a.r >= a.r0 ? "endArc" : "startArc" : a.endAngle >= a.startAngle ? "endAngle" : "startAngle" : o ? a.height >= 0 ? "bottom" : "top" : a.width >= 0 ? "right" : "left", y = me(t);
  _e(i, y, {
    labelFetcher: n,
    labelDataIndex: e,
    defaultText: we(n.getData(), e),
    inheritColor: u.fill,
    defaultOpacity: u.opacity,
    defaultOutsidePosition: f
  });
  var S = i.getTextContent();
  if (s && S) {
    var x = t.get(["label", "position"]);
    i.textConfig.inside = x === "middle" ? !0 : null, Le(i, x === "outside" ? f : x, ne(o), t.get(["label", "rotate"]));
  }
  be(S, y, n.getRawValue(e), function(A) {
    return Se(r, A);
  });
  var w = t.getModel(["emphasis"]);
  ce(i, w.get("focus"), w.get("blurScope"), w.get("disabled")), le(i, t), Oe(a) && (i.style.fill = "none", i.style.stroke = "none", de(i.states, function(A) {
    A.style && (A.style.fill = A.style.stroke = "none");
  }));
}
function Ee(i, r) {
  var e = i.get(["itemStyle", "borderColor"]);
  if (!e || e === "none")
    return 0;
  var t = i.get(["itemStyle", "borderWidth"]) || 0, a = isNaN(r.width) ? Number.MAX_VALUE : Math.abs(r.width), n = isNaN(r.height) ? Number.MAX_VALUE : Math.abs(r.height);
  return Math.min(t, a, n);
}
var Re = (
  /** @class */
  /* @__PURE__ */ function() {
    function i() {
    }
    return i;
  }()
), Q = (
  /** @class */
  function(i) {
    ee(r, i);
    function r(e) {
      var t = i.call(this, e) || this;
      return t.type = "largeBar", t;
    }
    return r.prototype.getDefaultShape = function() {
      return new Re();
    }, r.prototype.buildPath = function(e, t) {
      for (var a = t.points, n = this.baseDimIdx, o = 1 - this.baseDimIdx, s = [], u = [], h = this.barWidth, p = 0; p < a.length; p += 3)
        u[n] = h, u[o] = a[p + 2], s[n] = a[p + n], s[o] = a[p + o], e.rect(s[0], s[1], u[0], u[1]);
    }, r;
  }(pe)
);
function $(i, r, e, t) {
  var a = i.getData(), n = a.getLayout("valueAxisHorizontal") ? 1 : 0, o = a.getLayout("largeDataIndices"), s = a.getLayout("size"), u = i.getModel("backgroundStyle"), h = a.getLayout("largeBackgroundPoints");
  if (h) {
    var p = new Q({
      shape: {
        points: h
      },
      incremental: !!t,
      silent: !0,
      z2: 0
    });
    p.baseDimIdx = n, p.largeDataIndices = o, p.barWidth = s, p.useStyle(u.getItemStyle()), r.add(p), e && e.push(p);
  }
  var g = new Q({
    shape: {
      points: a.getLayout("largePoints")
    },
    incremental: !!t,
    ignoreCoarsePointer: !0,
    z2: 1
  });
  g.baseDimIdx = n, g.largeDataIndices = o, g.barWidth = s, r.add(g), g.useStyle(a.getVisual("style")), B(g).seriesIndex = i.seriesIndex, i.get("silent") || (g.on("mousedown", H), g.on("mousemove", H)), e && e.push(g);
}
var H = Ae(function(i) {
  var r = this, e = We(r, i.offsetX, i.offsetY);
  B(r).dataIndex = e >= 0 ? e : null;
}, 30, !1);
function We(i, r, e) {
  for (var t = i.baseDimIdx, a = 1 - t, n = i.shape.points, o = i.largeDataIndices, s = [], u = [], h = i.barWidth, p = 0, g = n.length / 3; p < g; p++) {
    var m = p * 3;
    if (u[t] = h, u[a] = n[m + 2], s[t] = n[m + t], s[a] = n[m + a], u[a] < 0 && (s[a] += u[a], u[a] = -u[a]), r >= s[0] && r <= s[0] + u[0] && e >= s[1] && e <= s[1] + u[1])
      return o[p];
  }
  return -1;
}
function se(i, r, e) {
  if (re(e, "cartesian2d")) {
    var t = r, a = e.getArea();
    return {
      x: i ? t.x : a.x,
      y: i ? a.y : t.y,
      width: i ? t.width : a.width,
      height: i ? a.height : t.height
    };
  } else {
    var a = e.getArea(), n = r;
    return {
      cx: a.cx,
      cy: a.cy,
      r0: i ? a.r0 : n.r0,
      r: i ? a.r : n.r,
      startAngle: i ? n.startAngle : 0,
      endAngle: i ? n.endAngle : Math.PI * 2
    };
  }
}
function Be(i, r, e) {
  var t = i.type === "polar" ? ie : ae;
  return new t({
    shape: se(r, e, i),
    silent: !0,
    z2: 0
  });
}
export {
  it as default
};
//# sourceMappingURL=BarView.mjs.map
