import { __extends as re } from "../../../node_modules/tslib/tslib.es6.mjs";
import { isArray as Q, retrieve as te, extend as z, each as U } from "../../../../zrender/lib/core/util.mjs";
import * as Z from "../../util/graphic.mjs";
import { toggleHoverEmphasis as ae } from "../../util/states.mjs";
import { normalizeSymbolOffset as ne, createSymbol as oe } from "../../util/symbol.mjs";
import { parsePercent as L, isNumeric as le } from "../../util/number.mjs";
import ce from "../../view/Chart.mjs";
import { getDefaultLabel as se } from "../helper/labelHelper.mjs";
import { setLabelStyle as ve, getLabelStatesModels as ue } from "../../label/labelStyle.mjs";
import pe from "../../../../zrender/lib/graphic/Image.mjs";
import { getECData as he } from "../../util/innerStore.mjs";
import { createClipPath as de } from "../helper/createClipPathFromCoordSys.mjs";
import fe from "../../../../zrender/lib/graphic/shape/Circle.mjs";
import X from "../../../../zrender/lib/graphic/Group.mjs";
import q from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import { updateProps as F, removeElement as me } from "../../animation/basicTransition.mjs";
var ge = ["itemStyle", "borderWidth"], V = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}], B = new fe(), He = (
  /** @class */
  function(i) {
    re(r, i);
    function r() {
      var e = i !== null && i.apply(this, arguments) || this;
      return e.type = r.type, e;
    }
    return r.prototype.render = function(e, n, a) {
      var t = this.group, o = e.getData(), m = this._data, d = e.coordinateSystem, f = d.getBaseAxis(), v = f.isHorizontal(), p = d.master.getRect(), l = {
        ecSize: {
          width: a.getWidth(),
          height: a.getHeight()
        },
        seriesModel: e,
        coordSys: d,
        coordSysExtent: [[p.x, p.x + p.width], [p.y, p.y + p.height]],
        isHorizontal: v,
        valueDim: V[+v],
        categoryDim: V[1 - +v]
      };
      o.diff(m).add(function(c) {
        if (o.hasValue(c)) {
          var s = G(o, c), h = W(o, c, s, l), g = H(o, l, h);
          o.setItemGraphicEl(c, g), t.add(g), k(g, l, h);
        }
      }).update(function(c, s) {
        var h = m.getItemGraphicEl(s);
        if (!o.hasValue(c)) {
          t.remove(h);
          return;
        }
        var g = G(o, c), S = W(o, c, g, l), _ = ee(o, S);
        h && _ !== h.__pictorialShapeStr && (t.remove(h), o.setItemGraphicEl(c, null), h = null), h ? Re(h, l, S) : h = H(o, l, S, !0), o.setItemGraphicEl(c, h), h.__pictorialSymbolMeta = S, t.add(h), k(h, l, S);
      }).remove(function(c) {
        var s = m.getItemGraphicEl(c);
        s && b(m, c, s.__pictorialSymbolMeta.animationModel, s);
      }).execute();
      var u = e.get("clip", !0) ? de(e.coordinateSystem, !1, e) : null;
      return u ? t.setClipPath(u) : t.removeClipPath(), this._data = o, this.group;
    }, r.prototype.remove = function(e, n) {
      var a = this.group, t = this._data;
      e.get("animation") ? t && t.eachItemGraphicEl(function(o) {
        b(t, he(o).dataIndex, e, o);
      }) : a.removeAll();
    }, r.type = "pictorialBar", r;
  }(ce)
);
function W(i, r, e, n) {
  var a = i.getItemLayout(r), t = e.get("symbolRepeat"), o = e.get("symbolClip"), m = e.get("symbolPosition") || "start", d = e.get("symbolRotate"), f = (d || 0) * Math.PI / 180 || 0, v = e.get("symbolPatternSize") || 2, p = e.isAnimationEnabled(), l = {
    dataIndex: r,
    layout: a,
    itemModel: e,
    symbolType: i.getItemVisual(r, "symbol") || "circle",
    style: i.getItemVisual(r, "style"),
    symbolClip: o,
    symbolRepeat: t,
    symbolRepeatDirection: e.get("symbolRepeatDirection"),
    symbolPatternSize: v,
    rotation: f,
    animationModel: p ? e : null,
    hoverScale: p && e.get(["emphasis", "scale"]),
    z2: e.getShallow("z", !0) || 0
  };
  Se(e, t, a, n, l), _e(i, r, a, t, o, l.boundingLength, l.pxSign, v, n, l), xe(e, l.symbolScale, f, n, l);
  var u = l.symbolSize, c = ne(e.get("symbolOffset"), u);
  return Pe(e, u, a, t, o, c, m, l.valueLineWidth, l.boundingLength, l.repeatCutLength, n, l), l;
}
function Se(i, r, e, n, a) {
  var t = n.valueDim, o = i.get("symbolBoundingData"), m = n.coordSys.getOtherAxis(n.coordSys.getBaseAxis()), d = m.toGlobalCoord(m.dataToCoord(0)), f = 1 - +(e[t.wh] <= 0), v;
  if (Q(o)) {
    var p = [A(m, o[0]) - d, A(m, o[1]) - d];
    p[1] < p[0] && p.reverse(), v = p[f];
  } else
    o != null ? v = A(m, o) - d : r ? v = n.coordSysExtent[t.index][f] - d : v = e[t.wh];
  a.boundingLength = v, r && (a.repeatCutLength = e[t.wh]), a.pxSign = v > 0 ? 1 : -1;
}
function A(i, r) {
  return i.toGlobalCoord(i.dataToCoord(i.scale.parse(r)));
}
function _e(i, r, e, n, a, t, o, m, d, f) {
  var v = d.valueDim, p = d.categoryDim, l = Math.abs(e[p.wh]), u = i.getItemVisual(r, "symbolSize"), c;
  Q(u) ? c = u.slice() : u == null ? c = ["100%", "100%"] : c = [u, u], c[p.index] = L(c[p.index], l), c[v.index] = L(c[v.index], n ? l : Math.abs(t)), f.symbolSize = c;
  var s = f.symbolScale = [c[0] / m, c[1] / m];
  s[v.index] *= (d.isHorizontal ? -1 : 1) * o;
}
function xe(i, r, e, n, a) {
  var t = i.get(ge) || 0;
  t && (B.attr({
    scaleX: r[0],
    scaleY: r[1],
    rotation: e
  }), B.updateTransform(), t /= B.getLineScale(), t *= r[n.valueDim.index]), a.valueLineWidth = t || 0;
}
function Pe(i, r, e, n, a, t, o, m, d, f, v, p) {
  var l = v.categoryDim, u = v.valueDim, c = p.pxSign, s = Math.max(r[u.index] + m, 0), h = s;
  if (n) {
    var g = Math.abs(d), S = te(i.get("symbolMargin"), "15%") + "", _ = !1;
    S.lastIndexOf("!") === S.length - 1 && (_ = !0, S = S.slice(0, S.length - 1));
    var x = L(S, r[u.index]), R = Math.max(s + x * 2, 0), w = _ ? 0 : x * 2, Y = le(n), P = Y ? n : j((g + w) / R), ie = g - P * s;
    x = ie / 2 / (_ ? P : Math.max(P - 1, 1)), R = s + x * 2, w = _ ? 0 : x * 2, !Y && n !== "fixed" && (P = f ? j((Math.abs(f) + w) / R) : 0), h = P * R - w, p.repeatTimes = P, p.symbolMargin = x;
  }
  var I = c * (h / 2), D = p.pathPosition = [];
  D[l.index] = e[l.wh] / 2, D[u.index] = o === "start" ? I : o === "end" ? d - I : d / 2, t && (D[0] += t[0], D[1] += t[1]);
  var E = p.bundlePosition = [];
  E[l.index] = e[l.xy], E[u.index] = e[u.xy];
  var O = p.barRectShape = z({}, e);
  O[u.wh] = c * Math.max(Math.abs(e[u.wh]), Math.abs(D[u.index] + I)), O[l.wh] = e[l.wh];
  var C = p.clipShape = {};
  C[l.xy] = -e[l.xy], C[l.wh] = v.ecSize[l.wh], C[u.xy] = 0, C[u.wh] = e[u.wh];
}
function J(i) {
  var r = i.symbolPatternSize, e = oe(
    // Consider texture img, make a big size.
    i.symbolType,
    -r / 2,
    -r / 2,
    r,
    r
  );
  return e.attr({
    culling: !0
  }), e.type !== "image" && e.setStyle({
    strokeNoScale: !0
  }), e;
}
function K(i, r, e, n) {
  var a = i.__pictorialBundle, t = e.symbolSize, o = e.valueLineWidth, m = e.pathPosition, d = r.valueDim, f = e.repeatTimes || 0, v = 0, p = t[r.valueDim.index] + o + e.symbolMargin * 2;
  for (T(i, function(s) {
    s.__pictorialAnimationIndex = v, s.__pictorialRepeatTimes = f, v < f ? y(s, null, c(v), e, n) : y(s, null, {
      scaleX: 0,
      scaleY: 0
    }, e, n, function() {
      a.remove(s);
    }), v++;
  }); v < f; v++) {
    var l = J(e);
    l.__pictorialAnimationIndex = v, l.__pictorialRepeatTimes = f, a.add(l);
    var u = c(v);
    y(l, {
      x: u.x,
      y: u.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: u.scaleX,
      scaleY: u.scaleY,
      rotation: u.rotation
    }, e, n);
  }
  function c(s) {
    var h = m.slice(), g = e.pxSign, S = s;
    return (e.symbolRepeatDirection === "start" ? g > 0 : g < 0) && (S = f - 1 - s), h[d.index] = p * (S - f / 2 + 0.5) + m[d.index], {
      x: h[0],
      y: h[1],
      scaleX: e.symbolScale[0],
      scaleY: e.symbolScale[1],
      rotation: e.rotation
    };
  }
}
function $(i, r, e, n) {
  var a = i.__pictorialBundle, t = i.__pictorialMainPath;
  t ? y(t, null, {
    x: e.pathPosition[0],
    y: e.pathPosition[1],
    scaleX: e.symbolScale[0],
    scaleY: e.symbolScale[1],
    rotation: e.rotation
  }, e, n) : (t = i.__pictorialMainPath = J(e), a.add(t), y(t, {
    x: e.pathPosition[0],
    y: e.pathPosition[1],
    scaleX: 0,
    scaleY: 0,
    rotation: e.rotation
  }, {
    scaleX: e.symbolScale[0],
    scaleY: e.symbolScale[1]
  }, e, n));
}
function N(i, r, e) {
  var n = z({}, r.barRectShape), a = i.__pictorialBarRect;
  a ? y(a, null, {
    shape: n
  }, r, e) : (a = i.__pictorialBarRect = new q({
    z2: 2,
    shape: n,
    silent: !0,
    style: {
      stroke: "transparent",
      fill: "transparent",
      lineWidth: 0
    }
  }), a.disableMorphing = !0, i.add(a));
}
function M(i, r, e, n) {
  if (e.symbolClip) {
    var a = i.__pictorialClipPath, t = z({}, e.clipShape), o = r.valueDim, m = e.animationModel, d = e.dataIndex;
    if (a)
      F(a, {
        shape: t
      }, m, d);
    else {
      t[o.wh] = 0, a = new q({
        shape: t
      }), i.__pictorialBundle.setClipPath(a), i.__pictorialClipPath = a;
      var f = {};
      f[o.wh] = e.clipShape[o.wh], Z[n ? "updateProps" : "initProps"](a, {
        shape: f
      }, m, d);
    }
  }
}
function G(i, r) {
  var e = i.getItemModel(r);
  return e.getAnimationDelayParams = ye, e.isAnimationEnabled = De, e;
}
function ye(i) {
  return {
    index: i.__pictorialAnimationIndex,
    count: i.__pictorialRepeatTimes
  };
}
function De() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function H(i, r, e, n) {
  var a = new X(), t = new X();
  return a.add(t), a.__pictorialBundle = t, t.x = e.bundlePosition[0], t.y = e.bundlePosition[1], e.symbolRepeat ? K(a, r, e) : $(a, r, e), N(a, e, n), M(a, r, e, n), a.__pictorialShapeStr = ee(i, e), a.__pictorialSymbolMeta = e, a;
}
function Re(i, r, e) {
  var n = e.animationModel, a = e.dataIndex, t = i.__pictorialBundle;
  F(t, {
    x: e.bundlePosition[0],
    y: e.bundlePosition[1]
  }, n, a), e.symbolRepeat ? K(i, r, e, !0) : $(i, r, e, !0), N(i, e, !0), M(i, r, e, !0);
}
function b(i, r, e, n) {
  var a = n.__pictorialBarRect;
  a && a.removeTextContent();
  var t = [];
  T(n, function(o) {
    t.push(o);
  }), n.__pictorialMainPath && t.push(n.__pictorialMainPath), n.__pictorialClipPath && (e = null), U(t, function(o) {
    me(o, {
      scaleX: 0,
      scaleY: 0
    }, e, r, function() {
      n.parent && n.parent.remove(n);
    });
  }), i.setItemGraphicEl(r, null);
}
function ee(i, r) {
  return [i.getItemVisual(r.dataIndex, "symbol") || "none", !!r.symbolRepeat, !!r.symbolClip].join(":");
}
function T(i, r, e) {
  U(i.__pictorialBundle.children(), function(n) {
    n !== i.__pictorialBarRect && r.call(e, n);
  });
}
function y(i, r, e, n, a, t) {
  r && i.attr(r), n.symbolClip && !a ? e && i.attr(e) : e && Z[a ? "updateProps" : "initProps"](i, e, n.animationModel, n.dataIndex, t);
}
function k(i, r, e) {
  var n = e.dataIndex, a = e.itemModel, t = a.getModel("emphasis"), o = t.getModel("itemStyle").getItemStyle(), m = a.getModel(["blur", "itemStyle"]).getItemStyle(), d = a.getModel(["select", "itemStyle"]).getItemStyle(), f = a.getShallow("cursor"), v = t.get("focus"), p = t.get("blurScope"), l = t.get("scale");
  T(i, function(s) {
    if (s instanceof pe) {
      var h = s.style;
      s.useStyle(z({
        // TODO other properties like dx, dy ?
        image: h.image,
        x: h.x,
        y: h.y,
        width: h.width,
        height: h.height
      }, e.style));
    } else
      s.useStyle(e.style);
    var g = s.ensureState("emphasis");
    g.style = o, l && (g.scaleX = s.scaleX * 1.1, g.scaleY = s.scaleY * 1.1), s.ensureState("blur").style = m, s.ensureState("select").style = d, f && (s.cursor = f), s.z2 = e.z2;
  });
  var u = r.valueDim.posDesc[+(e.boundingLength > 0)], c = i.__pictorialBarRect;
  c.ignoreClip = !0, ve(c, ue(a), {
    labelFetcher: r.seriesModel,
    labelDataIndex: n,
    defaultText: se(r.seriesModel.getData(), n),
    inheritColor: e.style.fill,
    defaultOpacity: e.style.opacity,
    defaultOutsidePosition: u
  }), ae(i, v, p, t.get("disabled"));
}
function j(i) {
  var r = Math.round(i);
  return Math.abs(i - r) < 1e-4 ? r : Math.ceil(i);
}
export {
  He as default
};
//# sourceMappingURL=PictorialBarView.mjs.map
