import { __extends as De } from "../../../node_modules/tslib/tslib.es6.mjs";
import { assert as w, defaults as V, retrieve2 as Pe, retrieve3 as be, hasOwn as S, each as Ee, indexOf as Le, isString as _e } from "../../../../zrender/lib/core/util.mjs";
import { traverseElements as we, makePath as Ae, getShapeClass as Te } from "../../util/graphic.mjs";
import { toggleHoverEmphasis as Fe, setDefaultStateProxy as Re } from "../../util/states.mjs";
import { createTextStyle as j, createTextConfig as I, getFont as Me } from "../../label/labelStyle.mjs";
import { getDefaultLabel as ee } from "../helper/labelHelper.mjs";
import { getLayoutOnAxis as Ne } from "../../layout/barGrid.mjs";
import Ve from "../../data/DataDiffer.mjs";
import Ue from "../../view/Chart.mjs";
import { createClipPath as ze } from "../helper/createClipPathFromCoordSys.mjs";
import Ge from "../../coord/cartesian/prepareCustom.mjs";
import Ze from "../../coord/geo/prepareCustom.mjs";
import He from "../../coord/single/prepareCustom.mjs";
import ke from "../../coord/polar/prepareCustom.mjs";
import Be from "../../coord/calendar/prepareCustom.mjs";
import Ye from "../../../../zrender/lib/graphic/Displayable.mjs";
import { warnDeprecated as re, convertToEC4StyleForCustomSerise as te, isEC4CompatibleStyle as Ke, convertFromEC4CompatibleStyle as Oe } from "../../util/styleCompat.mjs";
import { throwError as xe } from "../../util/log.mjs";
import { createOrUpdatePatternFromDecal as We } from "../../util/decal.mjs";
import { customInnerStore as E, STYLE_VISUAL_TYPE as ne, NON_STYLE_VISUAL_PROPS as qe } from "./CustomSeries.mjs";
import { applyLeaveTransition as H, applyUpdateTransition as Xe } from "../../animation/customGraphicTransition.mjs";
import { stopPreviousKeyframeAnimationAndRestore as $e, applyKeyframeAnimation as Je } from "../../animation/customGraphicKeyframeAnimation.mjs";
import Qe from "../../../../zrender/lib/graphic/Path.mjs";
import je from "../../../../zrender/lib/graphic/Image.mjs";
import Ie from "../../../../zrender/lib/graphic/Text.mjs";
import er from "../../../../zrender/lib/graphic/Group.mjs";
var D = "emphasis", b = "normal", k = "blur", B = "select", L = [b, D, k, B], U = {
  normal: ["itemStyle"],
  emphasis: [D, "itemStyle"],
  blur: [k, "itemStyle"],
  select: [B, "itemStyle"]
}, z = {
  normal: ["label"],
  emphasis: [D, "label"],
  blur: [k, "label"],
  select: [B, "label"]
}, rr = ["x", "y"], tr = "e\0\0", C = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
}, oe = {
  cartesian2d: Ge,
  geo: Ze,
  single: He,
  polar: ke,
  calendar: Be
};
function F(r) {
  return r instanceof Qe;
}
function Z(r) {
  return r instanceof Ye;
}
function nr(r, e) {
  e.copyTransform(r), Z(e) && Z(r) && (e.setStyle(r.style), e.z = r.z, e.z2 = r.z2, e.zlevel = r.zlevel, e.invisible = r.invisible, e.ignore = r.ignore, F(e) && F(r) && e.setShape(r.shape));
}
var kr = (
  /** @class */
  function(r) {
    De(e, r);
    function e() {
      var n = r !== null && r.apply(this, arguments) || this;
      return n.type = e.type, n;
    }
    return e.prototype.render = function(n, t, l, o) {
      this._progressiveEls = null;
      var i = this._data, v = n.getData(), p = this.group, u = ie(n, v, t, l);
      i || p.removeAll(), v.diff(i).add(function(c) {
        G(l, null, c, u(c, o), n, p, v);
      }).remove(function(c) {
        var s = i.getItemGraphicEl(c);
        s && H(s, E(s).option, n);
      }).update(function(c, s) {
        var y = i.getItemGraphicEl(s);
        G(l, y, c, u(c, o), n, p, v);
      }).execute();
      var m = n.get("clip", !0) ? ze(n.coordinateSystem, !1, n) : null;
      m ? p.setClipPath(m) : p.removeClipPath(), this._data = v;
    }, e.prototype.incrementalPrepareRender = function(n, t, l) {
      this.group.removeAll(), this._data = null;
    }, e.prototype.incrementalRender = function(n, t, l, o, i) {
      var v = t.getData(), p = ie(t, v, l, o), u = this._progressiveEls = [];
      function m(y) {
        y.isGroup || (y.incremental = !0, y.ensureState("emphasis").hoverLayer = !0);
      }
      for (var c = n.start; c < n.end; c++) {
        var s = G(null, null, c, p(c, i), t, this.group, v);
        s && (s.traverse(m), u.push(s));
      }
    }, e.prototype.eachRendered = function(n) {
      we(this._progressiveEls || this.group, n);
    }, e.prototype.filterForExposedEvent = function(n, t, l, o) {
      var i = t.element;
      if (i == null || l.name === i)
        return !0;
      for (; (l = l.__hostTarget || l.parent) && l !== this.group; )
        if (l.name === i)
          return !0;
      return !1;
    }, e.type = "custom", e;
  }(Ue)
);
function Y(r) {
  var e = r.type, n;
  if (e === "path") {
    var t = r.shape, l = t.width != null && t.height != null ? {
      x: t.x || 0,
      y: t.y || 0,
      width: t.width,
      height: t.height
    } : null, o = me(t);
    n = Ae(o, null, l, t.layout || "center"), E(n).customPathData = o;
  } else if (e === "image")
    n = new je({}), E(n).customImagePath = r.style.image;
  else if (e === "text")
    n = new Ie({});
  else if (e === "group")
    n = new er();
  else {
    if (e === "compoundPath")
      throw new Error('"compoundPath" is not supported yet.');
    var i = Te(e);
    if (!i) {
      var v = "";
      process.env.NODE_ENV !== "production" && (v = 'graphic type "' + e + '" can not be found.'), xe(v);
    }
    n = new i();
  }
  return E(n).customGraphicType = e, n.name = r.name, n.z2EmphasisLift = 1, n.z2SelectLift = 1, n;
}
function K(r, e, n, t, l, o, i) {
  $e(e);
  var v = l && l.normal.cfg;
  v && e.setTextConfig(v), t && t.transition == null && (t.transition = rr);
  var p = t && t.style;
  if (p) {
    if (e.type === "text") {
      var u = p;
      S(u, "textFill") && (u.fill = u.textFill), S(u, "textStroke") && (u.stroke = u.textStroke);
    }
    var m = void 0, c = F(e) ? p.decal : null;
    r && c && (c.dirty = !0, m = We(c, r)), p.__decalPattern = m;
  }
  if (Z(e) && p) {
    var m = p.__decalPattern;
    m && (p.decal = m);
  }
  Xe(e, t, o, {
    dataIndex: n,
    isInit: i,
    clearStyle: !0
  }), Je(e, t.keyframeAnimation, o);
}
function fe(r, e, n, t, l) {
  var o = e.isGroup ? null : e, i = l && l[r].cfg;
  if (o) {
    var v = o.ensureState(r);
    if (t === !1) {
      var p = o.getState(r);
      p && (p.style = null);
    } else
      v.style = t || null;
    i && (v.textConfig = i), Re(o);
  }
}
function or(r, e, n) {
  if (!r.isGroup) {
    var t = r, l = n.currentZ, o = n.currentZLevel;
    t.z = l, t.zlevel = o;
    var i = e.z2;
    i != null && (t.z2 = i || 0);
    for (var v = 0; v < L.length; v++)
      ir(t, e, L[v]);
  }
}
function ir(r, e, n) {
  var t = n === b, l = t ? e : R(e, n), o = l ? l.z2 : null, i;
  o != null && (i = t ? r : r.ensureState(n), i.z2 = o || 0);
}
function ie(r, e, n, t) {
  var l = r.get("renderItem"), o = r.coordinateSystem, i = {};
  o && (process.env.NODE_ENV !== "production" && (w(l, "series.render is required."), w(o.prepareCustoms || oe[o.type], "This coordSys does not support custom series.")), i = o.prepareCustoms ? o.prepareCustoms(o) : oe[o.type](o));
  for (var v = V({
    getWidth: t.getWidth,
    getHeight: t.getHeight,
    getZr: t.getZr,
    getDevicePixelRatio: t.getDevicePixelRatio,
    value: pe,
    style: se,
    ordinalRawValue: ce,
    styleEmphasis: ge,
    visual: ye,
    barLayout: he,
    currentSeriesIndices: Ce,
    font: de
  }, i.api || {}), p = {
    // The life cycle of context: current round of rendering.
    // The global life cycle is probably not necessary, because
    // user can store global status by themselves.
    context: {},
    seriesId: r.id,
    seriesName: r.name,
    seriesIndex: r.seriesIndex,
    coordSys: i.coordSys,
    dataInsideLength: e.count(),
    encode: lr(r.getData())
  }, u, m, c = {}, s = {}, y = {}, _ = {}, M = 0; M < L.length; M++) {
    var A = L[M];
    y[A] = r.getModel(U[A]), _[A] = r.getModel(z[A]);
  }
  function T(f) {
    return f === u ? m || (m = e.getItemModel(f)) : e.getItemModel(f);
  }
  function W(f, a) {
    return e.hasItemOption ? f === u ? c[a] || (c[a] = T(f).getModel(U[a])) : T(f).getModel(U[a]) : y[a];
  }
  function q(f, a) {
    return e.hasItemOption ? f === u ? s[a] || (s[a] = T(f).getModel(z[a])) : T(f).getModel(z[a]) : _[a];
  }
  return function(f, a) {
    return u = f, m = null, c = {}, s = {}, l && l(V({
      dataIndexInside: f,
      dataIndex: e.getRawIndex(f),
      // Can be used for optimization when zoom or roam.
      actionType: a ? a.type : null
    }, p), v);
  };
  function pe(f, a) {
    return a == null && (a = u), e.getStore().get(e.getDimensionIndex(f || 0), a);
  }
  function ce(f, a) {
    a == null && (a = u), f = f || 0;
    var g = e.getDimensionInfo(f);
    if (!g) {
      var d = e.getDimensionIndex(f);
      return d >= 0 ? e.getStore().get(d, a) : void 0;
    }
    var P = e.get(g.name, a), h = g && g.ordinalMeta;
    return h ? h.categories[P] : P;
  }
  function se(f, a) {
    process.env.NODE_ENV !== "production" && re("api.style", "Please write literal style directly instead."), a == null && (a = u);
    var g = e.getItemVisual(a, "style"), d = g && g.fill, P = g && g.opacity, h = W(a, b).getItemStyle();
    d != null && (h.fill = d), P != null && (h.opacity = P);
    var J = {
      inheritColor: _e(d) ? d : "#000"
    }, N = q(a, b), Q = j(N, null, J, !1, !0);
    Q.text = N.getShallow("show") ? Pe(r.getFormattedLabel(a, b), ee(e, a)) : null;
    var Se = I(N, J, !1);
    return $(f, h), h = te(h, Q, Se), f && X(h, f), h.legacy = !0, h;
  }
  function ge(f, a) {
    process.env.NODE_ENV !== "production" && re("api.styleEmphasis", "Please write literal style directly instead."), a == null && (a = u);
    var g = W(a, D).getItemStyle(), d = q(a, D), P = j(d, null, null, !0, !0);
    P.text = d.getShallow("show") ? be(r.getFormattedLabel(a, D), r.getFormattedLabel(a, b), ee(e, a)) : null;
    var h = I(d, null, !0);
    return $(f, g), g = te(g, P, h), f && X(g, f), g.legacy = !0, g;
  }
  function X(f, a) {
    for (var g in a)
      S(a, g) && (f[g] = a[g]);
  }
  function $(f, a) {
    f && (f.textFill && (a.textFill = f.textFill), f.textPosition && (a.textPosition = f.textPosition));
  }
  function ye(f, a) {
    if (a == null && (a = u), S(ne, f)) {
      var g = e.getItemVisual(a, "style");
      return g ? g[ne[f]] : null;
    }
    if (S(qe, f))
      return e.getItemVisual(a, f);
  }
  function he(f) {
    if (o.type === "cartesian2d") {
      var a = o.getBaseAxis();
      return Ne(V({
        axis: a
      }, f));
    }
  }
  function Ce() {
    return n.getCurrentSeriesIndices();
  }
  function de(f) {
    return Me(f, n);
  }
}
function lr(r) {
  var e = {};
  return Ee(r.dimensions, function(n) {
    var t = r.getDimensionInfo(n);
    if (!t.isExtraCoord) {
      var l = t.coordDim, o = e[l] = e[l] || [];
      o[t.coordDimIndex] = r.getDimensionIndex(n);
    }
  }), e;
}
function G(r, e, n, t, l, o, i) {
  if (!t) {
    o.remove(e);
    return;
  }
  var v = O(r, e, n, t, l, o);
  return v && i.setItemGraphicEl(n, v), v && Fe(v, t.focus, t.blurScope, t.emphasisDisabled), v;
}
function O(r, e, n, t, l, o) {
  process.env.NODE_ENV !== "production" && w(t, "should not have an null/undefined element setting");
  var i = -1, v = e;
  e && ve(e, t, l) && (i = Le(o.childrenRef(), e), e = null);
  var p = !e, u = e;
  u ? u.clearStates() : (u = Y(t), v && nr(v, u)), t.morph === !1 ? u.disableMorphing = !0 : u.disableMorphing && (u.disableMorphing = !1), C.normal.cfg = C.normal.conOpt = C.emphasis.cfg = C.emphasis.conOpt = C.blur.cfg = C.blur.conOpt = C.select.cfg = C.select.conOpt = null, C.isLegacy = !1, ur(u, n, t, l, p, C), ar(u, n, t, l, p), K(r, u, n, t, C, l, p), S(t, "info") && (E(u).info = t.info);
  for (var m = 0; m < L.length; m++) {
    var c = L[m];
    if (c !== b) {
      var s = R(t, c), y = x(t, s, c);
      fe(c, u, s, y, C);
    }
  }
  return or(u, t, l), t.type === "group" && fr(r, u, n, t, l), i >= 0 ? o.replaceAt(u, i) : o.add(u), u;
}
function ve(r, e, n) {
  var t = E(r), l = e.type, o = e.shape, i = e.style;
  return (
    // Always create new if universal transition is enabled.
    // Because we do transition after render. It needs to know what old element is. Replacement will loose it.
    n.isUniversalTransitionEnabled() || l != null && l !== t.customGraphicType || l === "path" && cr(o) && me(o) !== t.customPathData || l === "image" && S(i, "image") && i.image !== t.customImagePath
  );
}
function ar(r, e, n, t, l) {
  var o = n.clipPath;
  if (o === !1)
    r && r.getClipPath() && r.removeClipPath();
  else if (o) {
    var i = r.getClipPath();
    i && ve(i, o, t) && (i = null), i || (i = Y(o), process.env.NODE_ENV !== "production" && w(F(i), "Only any type of `path` can be used in `clipPath`, rather than " + i.type + "."), r.setClipPath(i)), K(null, i, e, o, null, t, l);
  }
}
function ur(r, e, n, t, l, o) {
  if (!r.isGroup) {
    le(n, null, o), le(n, D, o);
    var i = o.normal.conOpt, v = o.emphasis.conOpt, p = o.blur.conOpt, u = o.select.conOpt;
    if (i != null || v != null || u != null || p != null) {
      var m = r.getTextContent();
      if (i === !1)
        m && r.removeTextContent();
      else {
        i = o.normal.conOpt = i || {
          type: "text"
        }, m ? m.clearStates() : (m = Y(i), r.setTextContent(m)), K(null, m, e, i, null, t, l);
        for (var c = i && i.style, s = 0; s < L.length; s++) {
          var y = L[s];
          if (y !== b) {
            var _ = o[y].conOpt;
            fe(y, m, _, x(i, _, y), null);
          }
        }
        c ? m.dirty() : m.markRedraw();
      }
    }
  }
}
function le(r, e, n) {
  var t = e ? R(r, e) : r, l = e ? x(r, t, D) : r.style, o = r.type, i = t ? t.textConfig : null, v = r.textContent, p = v ? e ? R(v, e) : v : null;
  if (l && // Because emphasis style has little info to detect legacy,
  // if normal is legacy, emphasis is trade as legacy.
  (n.isLegacy || Ke(l, o, !!i, !!p))) {
    n.isLegacy = !0;
    var u = Oe(l, o, !e);
    !i && u.textConfig && (i = u.textConfig), !p && u.textContent && (p = u.textContent);
  }
  if (!e && p) {
    var m = p;
    !m.type && (m.type = "text"), process.env.NODE_ENV !== "production" && w(m.type === "text", 'textContent.type must be "text"');
  }
  var c = e ? n[e] : n.normal;
  c.cfg = i, c.conOpt = p;
}
function R(r, e) {
  return e ? r ? r[e] : null : r;
}
function x(r, e, n) {
  var t = e && e.style;
  return t == null && n === D && r && (t = r.styleEmphasis), t;
}
function fr(r, e, n, t, l) {
  var o = t.children, i = o ? o.length : 0, v = t.$mergeChildren, p = v === "byName" || t.diffChildrenByName, u = v === !1;
  if (!(!i && !p && !u)) {
    if (p) {
      mr({
        api: r,
        oldChildren: e.children() || [],
        newChildren: o || [],
        dataIndex: n,
        seriesModel: l,
        group: e
      });
      return;
    }
    u && e.removeAll();
    for (var m = 0; m < i; m++) {
      var c = o[m], s = e.childAt(m);
      c ? (c.ignore == null && (c.ignore = !1), O(r, s, n, c, l, e)) : (process.env.NODE_ENV !== "production" && w(s, "renderItem should not return a group containing elements as null/undefined/{} if they do not exist before."), s.ignore = !0);
    }
    for (var y = e.childCount() - 1; y >= m; y--) {
      var _ = e.childAt(y);
      vr(e, _, l);
    }
  }
}
function vr(r, e, n) {
  e && H(e, E(r).option, n);
}
function mr(r) {
  new Ve(r.oldChildren, r.newChildren, ae, ae, r).add(ue).update(ue).remove(pr).execute();
}
function ae(r, e) {
  var n = r && r.name;
  return n ?? tr + e;
}
function ue(r, e) {
  var n = this.context, t = r != null ? n.newChildren[r] : null, l = e != null ? n.oldChildren[e] : null;
  O(n.api, l, n.dataIndex, t, n.seriesModel, n.group);
}
function pr(r) {
  var e = this.context, n = e.oldChildren[r];
  n && H(n, E(n).option, e.seriesModel);
}
function me(r) {
  return r && (r.pathData || r.d);
}
function cr(r) {
  return r && (S(r, "pathData") || S(r, "d"));
}
export {
  kr as default
};
//# sourceMappingURL=CustomView.mjs.map
