import { getLayoutRect as q } from "../../util/layout.mjs";
import { parsePercent as D, linearMap as Y } from "../../util/number.mjs";
import { isFunction as C } from "../../../../zrender/lib/core/util.mjs";
function G(u, m) {
  return q(u.getBoxLayoutParams(), {
    width: m.getWidth(),
    height: m.getHeight()
  });
}
function H(u, m) {
  for (var r = u.mapDimension("value"), c = u.mapArray(r, function(g) {
    return g;
  }), h = [], z = m === "ascending", e = 0, p = u.count(); e < p; e++)
    h[e] = e;
  return C(m) ? h.sort(m) : m !== "none" && h.sort(function(g, t) {
    return z ? c[g] - c[t] : c[t] - c[g];
  }), h;
}
function J(u) {
  var m = u.hostModel, r = m.get("orient");
  u.each(function(c) {
    var h = u.getItemModel(c), z = h.getModel("label"), e = z.get("position"), p = h.getModel("labelLine"), g = u.getItemLayout(c), t = g.points, d = e === "inner" || e === "inside" || e === "center" || e === "insideLeft" || e === "insideRight", i, v, s, P;
    if (d)
      e === "insideLeft" ? (v = (t[0][0] + t[3][0]) / 2 + 5, s = (t[0][1] + t[3][1]) / 2, i = "left") : e === "insideRight" ? (v = (t[1][0] + t[2][0]) / 2 - 5, s = (t[1][1] + t[2][1]) / 2, i = "right") : (v = (t[0][0] + t[1][0] + t[2][0] + t[3][0]) / 4, s = (t[0][1] + t[1][1] + t[2][1] + t[3][1]) / 4, i = "center"), P = [[v, s], [v, s]];
    else {
      var o = void 0, n = void 0, l = void 0, a = void 0, f = p.get("length");
      process.env.NODE_ENV !== "production" && (r === "vertical" && ["top", "bottom"].indexOf(e) > -1 && (e = "left", console.warn("Position error: Funnel chart on vertical orient dose not support top and bottom.")), r === "horizontal" && ["left", "right"].indexOf(e) > -1 && (e = "bottom", console.warn("Position error: Funnel chart on horizontal orient dose not support left and right."))), e === "left" ? (o = (t[3][0] + t[0][0]) / 2, n = (t[3][1] + t[0][1]) / 2, l = o - f, v = l - 5, i = "right") : e === "right" ? (o = (t[1][0] + t[2][0]) / 2, n = (t[1][1] + t[2][1]) / 2, l = o + f, v = l + 5, i = "left") : e === "top" ? (o = (t[3][0] + t[0][0]) / 2, n = (t[3][1] + t[0][1]) / 2, a = n - f, s = a - 5, i = "center") : e === "bottom" ? (o = (t[1][0] + t[2][0]) / 2, n = (t[1][1] + t[2][1]) / 2, a = n + f, s = a + 5, i = "center") : e === "rightTop" ? (o = r === "horizontal" ? t[3][0] : t[1][0], n = r === "horizontal" ? t[3][1] : t[1][1], r === "horizontal" ? (a = n - f, s = a - 5, i = "center") : (l = o + f, v = l + 5, i = "top")) : e === "rightBottom" ? (o = t[2][0], n = t[2][1], r === "horizontal" ? (a = n + f, s = a + 5, i = "center") : (l = o + f, v = l + 5, i = "bottom")) : e === "leftTop" ? (o = t[0][0], n = r === "horizontal" ? t[0][1] : t[1][1], r === "horizontal" ? (a = n - f, s = a - 5, i = "center") : (l = o - f, v = l - 5, i = "right")) : e === "leftBottom" ? (o = r === "horizontal" ? t[1][0] : t[3][0], n = r === "horizontal" ? t[1][1] : t[2][1], r === "horizontal" ? (a = n + f, s = a + 5, i = "center") : (l = o - f, v = l - 5, i = "right")) : (o = (t[1][0] + t[2][0]) / 2, n = (t[1][1] + t[2][1]) / 2, r === "horizontal" ? (a = n + f, s = a + 5, i = "center") : (l = o + f, v = l + 5, i = "left")), r === "horizontal" ? (l = o, v = l) : (a = n, s = a), P = [[o, n], [l, a]];
    }
    g.label = {
      linePoints: P,
      x: v,
      y: s,
      verticalAlign: "middle",
      textAlign: i,
      inside: d
    };
  });
}
function Z(u, m) {
  u.eachSeriesByType("funnel", function(r) {
    var c = r.getData(), h = c.mapDimension("value"), z = r.get("sort"), e = G(r, m), p = r.get("orient"), g = e.width, t = e.height, d = H(c, z), i = e.x, v = e.y, s = p === "horizontal" ? [D(r.get("minSize"), t), D(r.get("maxSize"), t)] : [D(r.get("minSize"), g), D(r.get("maxSize"), g)], P = c.getDataExtent(h), o = r.get("min"), n = r.get("max");
    o == null && (o = Math.min(P[0], 0)), n == null && (n = P[1]);
    var l = r.get("funnelAlign"), a = r.get("gap"), f = p === "horizontal" ? g : t, w = (f - a * (c.count() - 1)) / c.count(), E = function(X, B) {
      if (p === "horizontal") {
        var _ = c.get(h, X) || 0, T = Y(_, [o, n], s, !0), k = void 0;
        switch (l) {
          case "top":
            k = v;
            break;
          case "center":
            k = v + (t - T) / 2;
            break;
          case "bottom":
            k = v + (t - T);
            break;
        }
        return [[B, k], [B, k + T]];
      }
      var j = c.get(h, X) || 0, W = Y(j, [o, n], s, !0), I;
      switch (l) {
        case "left":
          I = i;
          break;
        case "center":
          I = i + (g - W) / 2;
          break;
        case "right":
          I = i + g - W;
          break;
      }
      return [[I, B], [I + W, B]];
    };
    z === "ascending" && (w = -w, a = -a, p === "horizontal" ? i += g : v += t, d = d.reverse());
    for (var R = 0; R < d.length; R++) {
      var b = d[R], N = d[R + 1], V = c.getItemModel(b);
      if (p === "horizontal") {
        var S = V.get(["itemStyle", "width"]);
        S == null ? S = w : (S = D(S, g), z === "ascending" && (S = -S));
        var F = E(b, i), O = E(N, i + S);
        i += S + a, c.setItemLayout(b, {
          points: F.concat(O.slice().reverse())
        });
      } else {
        var A = V.get(["itemStyle", "height"]);
        A == null ? A = w : (A = D(A, t), z === "ascending" && (A = -A));
        var F = E(b, v), O = E(N, v + A);
        v += A + a, c.setItemLayout(b, {
          points: F.concat(O.slice().reverse())
        });
      }
    }
    J(c);
  });
}
export {
  Z as default
};
//# sourceMappingURL=funnelLayout.mjs.map
