import { __extends as v } from "../../../node_modules/tslib/tslib.es6.mjs";
import M from "../../data/SeriesData.mjs";
import { each as b, map as D, extend as S } from "../../../../zrender/lib/core/util.mjs";
import { defaultEmphasis as L } from "../../util/model.mjs";
import x from "../../model/Model.mjs";
import w from "../helper/createGraphFromNodeEdge.mjs";
import C from "../../visual/LegendVisualProvider.mjs";
import I from "../../model/Series.mjs";
import { createTooltipMarkup as k } from "../../component/tooltip/tooltipMarkup.mjs";
import { defaultSeriesFormatTooltip as E } from "../../component/tooltip/seriesFormatTooltip.mjs";
import { initCurvenessList as G, createEdgeMapForCurveness as P } from "../helper/multipleGraphEdgeHelper.mjs";
var Z = (
  /** @class */
  function(n) {
    v(t, n);
    function t() {
      var e = n !== null && n.apply(this, arguments) || this;
      return e.type = t.type, e.hasSymbolVisual = !0, e;
    }
    return t.prototype.init = function(e) {
      n.prototype.init.apply(this, arguments);
      var r = this;
      function a() {
        return r._categoriesData;
      }
      this.legendVisualProvider = new C(a, a), this.fillDataTextStyle(e.edges || e.links), this._updateCategoriesData();
    }, t.prototype.mergeOption = function(e) {
      n.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(e.edges || e.links), this._updateCategoriesData();
    }, t.prototype.mergeDefaultAndTheme = function(e) {
      n.prototype.mergeDefaultAndTheme.apply(this, arguments), L(e, "edgeLabel", ["show"]);
    }, t.prototype.getInitialData = function(e, r) {
      var a = e.edges || e.links || [], s = e.data || e.nodes || [], d = this;
      if (s && a) {
        G(this);
        var u = w(s, a, this, !0, g);
        return b(u.edges, function(i) {
          P(i.node1, i.node2, this, i.dataIndex);
        }, this), u.data;
      }
      function g(i, p) {
        i.wrapMethod("getItemModel", function(o) {
          var l = d._categoriesModels, f = o.getShallow("category"), m = l[f];
          return m && (m.parentModel = o.parentModel, o.parentModel = m), o;
        });
        var c = x.prototype.getModel;
        function y(o, l) {
          var f = c.call(this, o, l);
          return f.resolveParentPath = h, f;
        }
        p.wrapMethod("getItemModel", function(o) {
          return o.resolveParentPath = h, o.getModel = y, o;
        });
        function h(o) {
          if (o && (o[0] === "label" || o[1] === "label")) {
            var l = o.slice();
            return o[0] === "label" ? l[0] = "edgeLabel" : o[1] === "label" && (l[1] = "edgeLabel"), l;
          }
          return o;
        }
      }
    }, t.prototype.getGraph = function() {
      return this.getData().graph;
    }, t.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, t.prototype.getCategoriesData = function() {
      return this._categoriesData;
    }, t.prototype.formatTooltip = function(e, r, a) {
      if (a === "edge") {
        var s = this.getData(), d = this.getDataParams(e, a), u = s.graph.getEdgeByIndex(e), g = s.getName(u.node1.dataIndex), i = s.getName(u.node2.dataIndex), p = [];
        return g != null && p.push(g), i != null && p.push(i), k("nameValue", {
          name: p.join(" > "),
          value: d.value,
          noValue: d.value == null
        });
      }
      var c = E({
        series: this,
        dataIndex: e,
        multipleSeries: r
      });
      return c;
    }, t.prototype._updateCategoriesData = function() {
      var e = D(this.option.categories || [], function(a) {
        return a.value != null ? a : S({
          value: 0
        }, a);
      }), r = new M(["value"], this);
      r.initData(e), this._categoriesData = r, this._categoriesModels = r.mapArray(function(a) {
        return r.getItemModel(a);
      });
    }, t.prototype.setZoom = function(e) {
      this.option.zoom = e;
    }, t.prototype.setCenter = function(e) {
      this.option.center = e;
    }, t.prototype.isAnimationEnabled = function() {
      return n.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
    }, t.type = "series.graph", t.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], t.defaultOption = {
      // zlevel: 0,
      z: 2,
      coordinateSystem: "view",
      // Default option for all coordinate systems
      // xAxisIndex: 0,
      // yAxisIndex: 0,
      // polarIndex: 0,
      // geoIndex: 0,
      legendHoverLink: !0,
      layout: null,
      // Configuration of circular layout
      circular: {
        rotateLabel: !1
      },
      // Configuration of force directed layout
      force: {
        initLayout: null,
        // Node repulsion. Can be an array to represent range.
        repulsion: [0, 50],
        gravity: 0.1,
        // Initial friction
        friction: 0.6,
        // Edge length. Can be an array to represent range.
        edgeLength: 30,
        layoutAnimation: !0
      },
      left: "center",
      top: "center",
      // right: null,
      // bottom: null,
      // width: '80%',
      // height: '80%',
      symbol: "circle",
      symbolSize: 10,
      edgeSymbol: ["none", "none"],
      edgeSymbolSize: 10,
      edgeLabel: {
        position: "middle",
        distance: 5
      },
      draggable: !1,
      roam: !1,
      // Default on center of graph
      center: null,
      zoom: 1,
      // Symbol size scale ratio in roam
      nodeScaleRatio: 0.6,
      // cursor: null,
      // categories: [],
      // data: []
      // Or
      // nodes: []
      //
      // links: []
      // Or
      // edges: []
      label: {
        show: !1,
        formatter: "{b}"
      },
      itemStyle: {},
      lineStyle: {
        color: "#aaa",
        width: 1,
        opacity: 0.5
      },
      emphasis: {
        scale: !0,
        label: {
          show: !0
        }
      },
      select: {
        itemStyle: {
          borderColor: "#212121"
        }
      }
    }, t;
  }(I)
);
export {
  Z as default
};
//# sourceMappingURL=GraphSeries.mjs.map
