import { __extends as W } from "../../../node_modules/tslib/tslib.es6.mjs";
import { traverseElements as k } from "../../util/graphic.mjs";
import { toggleHoverEmphasis as F } from "../../util/states.mjs";
import Z from "./HeatmapLayer.mjs";
import { map as j } from "../../../../zrender/lib/core/util.mjs";
import q from "../../view/Chart.mjs";
import { isCoordinateSystemType as J } from "../../coord/CoordinateSystem.mjs";
import { getLabelStatesModels as B, setLabelStyle as K } from "../../label/labelStyle.mjs";
import L from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import Q from "../../../../zrender/lib/graphic/Image.mjs";
function U(p, e, t) {
  var n = p[1] - p[0];
  e = j(e, function(r) {
    return {
      interval: [(r.interval[0] - p[0]) / n, (r.interval[1] - p[0]) / n]
    };
  });
  var i = e.length, s = 0;
  return function(r) {
    var a;
    for (a = s; a < i; a++) {
      var m = e[a].interval;
      if (m[0] <= r && r <= m[1]) {
        s = a;
        break;
      }
    }
    if (a === i)
      for (a = s - 1; a >= 0; a--) {
        var m = e[a].interval;
        if (m[0] <= r && r <= m[1]) {
          s = a;
          break;
        }
      }
    return a >= 0 && a < i && t[a];
  };
}
function $(p, e) {
  var t = p[1] - p[0];
  return e = [(e[0] - p[0]) / t, (e[1] - p[0]) / t], function(n) {
    return n >= e[0] && n <= e[1];
  };
}
function x(p) {
  var e = p.dimensions;
  return e[0] === "lng" && e[1] === "lat";
}
var st = (
  /** @class */
  function(p) {
    W(e, p);
    function e() {
      var t = p !== null && p.apply(this, arguments) || this;
      return t.type = e.type, t;
    }
    return e.prototype.render = function(t, n, i) {
      var s;
      if (n.eachComponent("visualMap", function(a) {
        a.eachTargetSeries(function(m) {
          m === t && (s = a);
        });
      }), process.env.NODE_ENV !== "production" && !s)
        throw new Error("Heatmap must use with visualMap");
      this._progressiveEls = null, this.group.removeAll();
      var r = t.coordinateSystem;
      r.type === "cartesian2d" || r.type === "calendar" ? this._renderOnCartesianAndCalendar(t, i, 0, t.getData().count()) : x(r) && this._renderOnGeo(r, t, s, i);
    }, e.prototype.incrementalPrepareRender = function(t, n, i) {
      this.group.removeAll();
    }, e.prototype.incrementalRender = function(t, n, i, s) {
      var r = n.coordinateSystem;
      r && (x(r) ? this.render(n, i, s) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(n, s, t.start, t.end, !0)));
    }, e.prototype.eachRendered = function(t) {
      k(this._progressiveEls || this.group, t);
    }, e.prototype._renderOnCartesianAndCalendar = function(t, n, i, s, r) {
      var a = t.coordinateSystem, m = J(a, "cartesian2d"), v, u, S, f;
      if (m) {
        var y = a.getAxis("x"), c = a.getAxis("y");
        if (process.env.NODE_ENV !== "production") {
          if (!(y.type === "category" && c.type === "category"))
            throw new Error("Heatmap on cartesian must have two category axes");
          if (!(y.onBand && c.onBand))
            throw new Error("Heatmap on cartesian must have two axes with boundaryGap true");
        }
        v = y.getBandWidth() + 0.5, u = c.getBandWidth() + 0.5, S = y.scale.getExtent(), f = c.scale.getExtent();
      }
      for (var H = this.group, o = t.getData(), d = t.getModel(["emphasis", "itemStyle"]).getItemStyle(), I = t.getModel(["blur", "itemStyle"]).getItemStyle(), O = t.getModel(["select", "itemStyle"]).getItemStyle(), b = t.get(["itemStyle", "borderRadius"]), E = B(t), w = t.getModel("emphasis"), C = w.get("focus"), N = w.get("blurScope"), _ = w.get("disabled"), h = m ? [o.mapDimension("x"), o.mapDimension("y"), o.mapDimension("value")] : [o.mapDimension("time"), o.mapDimension("value")], l = i; l < s; l++) {
        var g = void 0, z = o.getItemVisual(l, "style");
        if (m) {
          var D = o.get(h[0], l), V = o.get(h[1], l);
          if (isNaN(o.get(h[2], l)) || isNaN(D) || isNaN(V) || D < S[0] || D > S[1] || V < f[0] || V > f[1])
            continue;
          var P = a.dataToPoint([D, V]);
          g = new L({
            shape: {
              x: P[0] - v / 2,
              y: P[1] - u / 2,
              width: v,
              height: u
            },
            style: z
          });
        } else {
          if (isNaN(o.get(h[1], l)))
            continue;
          g = new L({
            z2: 1,
            shape: a.dataToRect([o.get(h[0], l)]).contentShape,
            style: z
          });
        }
        if (o.hasItemOption) {
          var R = o.getItemModel(l), T = R.getModel("emphasis");
          d = T.getModel("itemStyle").getItemStyle(), I = R.getModel(["blur", "itemStyle"]).getItemStyle(), O = R.getModel(["select", "itemStyle"]).getItemStyle(), b = R.get(["itemStyle", "borderRadius"]), C = T.get("focus"), N = T.get("blurScope"), _ = T.get("disabled"), E = B(R);
        }
        g.shape.r = b;
        var G = t.getRawValue(l), A = "-";
        G && G[2] != null && (A = G[2] + ""), K(g, E, {
          labelFetcher: t,
          labelDataIndex: l,
          defaultOpacity: z.opacity,
          defaultText: A
        }), g.ensureState("emphasis").style = d, g.ensureState("blur").style = I, g.ensureState("select").style = O, F(g, C, N, _), g.incremental = r, r && (g.states.emphasis.hoverLayer = !0), H.add(g), o.setItemGraphicEl(l, g), this._progressiveEls && this._progressiveEls.push(g);
      }
    }, e.prototype._renderOnGeo = function(t, n, i, s) {
      var r = i.targetVisuals.inRange, a = i.targetVisuals.outOfRange, m = n.getData(), v = this._hmLayer || this._hmLayer || new Z();
      v.blurSize = n.get("blurSize"), v.pointSize = n.get("pointSize"), v.minOpacity = n.get("minOpacity"), v.maxOpacity = n.get("maxOpacity");
      var u = t.getViewRect().clone(), S = t.getRoamTransform();
      u.applyTransform(S);
      var f = Math.max(u.x, 0), y = Math.max(u.y, 0), c = Math.min(u.width + u.x, s.getWidth()), H = Math.min(u.height + u.y, s.getHeight()), o = c - f, d = H - y, I = [m.mapDimension("lng"), m.mapDimension("lat"), m.mapDimension("value")], O = m.mapArray(I, function(C, N, _) {
        var h = t.dataToPoint([C, N]);
        return h[0] -= f, h[1] -= y, h.push(_), h;
      }), b = i.getExtent(), E = i.type === "visualMap.continuous" ? $(b, i.option.range) : U(b, i.getPieceList(), i.option.selected);
      v.update(O, o, d, r.color.getNormalizer(), {
        inRange: r.color.getColorMapper(),
        outOfRange: a.color.getColorMapper()
      }, E);
      var w = new Q({
        style: {
          width: o,
          height: d,
          x: f,
          y,
          image: v.canvas
        },
        silent: !0
      });
      this.group.add(w);
    }, e.type = "heatmap", e;
  }(q)
);
export {
  st as default
};
//# sourceMappingURL=HeatmapView.mjs.map
