import { __extends as ht } from "../../../node_modules/tslib/tslib.es6.mjs";
import { defaults as q, isFunction as T, isNumber as ft, map as pt, each as ot } from "../../../../zrender/lib/core/util.mjs";
import gt from "../helper/SymbolDraw.mjs";
import lt from "../helper/Symbol.mjs";
import mt from "./lineAnimationDiff.mjs";
import { queryDataIndex as $, interpolateRawValues as ct } from "../../util/model.mjs";
import { ECPolyline as yt, ECPolygon as dt } from "./poly.mjs";
import V from "../../view/Chart.mjs";
import { prepareDataCoordInfo as _t, getStackedOnPoint as bt } from "./helper.mjs";
import { createGridClipPath as St, createPolarClipPath as xt } from "../helper/createClipPathFromCoordSys.mjs";
import { isCoordinateSystemType as wt } from "../../coord/CoordinateSystem.mjs";
import { setStatesStylesFromModel as j, toggleHoverEmphasis as K, setStatesFlag as Q, SPECIAL_STATES as Y } from "../../util/states.mjs";
import { setLabelStyle as It, getLabelStatesModels as Dt, labelInner as Lt } from "../../label/labelStyle.mjs";
import { getDefaultInterpolatedLabel as Pt, getDefaultLabel as Nt } from "../helper/labelHelper.mjs";
import { getECData as F } from "../../util/innerStore.mjs";
import { createFloat32Array as At } from "../../util/vendor.mjs";
import { convertToColorString as M } from "../../util/format.mjs";
import { lerp as Et } from "../../../../zrender/lib/tool/color.mjs";
import Ct from "../../../../zrender/lib/graphic/Group.mjs";
import Ot from "../../../../zrender/lib/graphic/Text.mjs";
import kt from "../../../../zrender/lib/graphic/LinearGradient.mjs";
import { initProps as Gt, updateProps as tt } from "../../animation/basicTransition.mjs";
function et(v, o) {
  if (v.length === o.length) {
    for (var t = 0; t < v.length; t++)
      if (v[t] !== o[t])
        return;
    return !0;
  }
}
function at(v) {
  for (var o = 1 / 0, t = 1 / 0, n = -1 / 0, r = -1 / 0, a = 0; a < v.length; ) {
    var e = v[a++], l = v[a++];
    isNaN(e) || (o = Math.min(e, o), n = Math.max(e, n)), isNaN(l) || (t = Math.min(l, t), r = Math.max(l, r));
  }
  return [[o, t], [n, r]];
}
function rt(v, o) {
  var t = at(v), n = t[0], r = t[1], a = at(o), e = a[0], l = a[1];
  return Math.max(Math.abs(n[0] - e[0]), Math.abs(n[1] - e[1]), Math.abs(r[0] - l[0]), Math.abs(r[1] - l[1]));
}
function nt(v) {
  return ft(v) ? v : v ? 0.5 : 0;
}
function Tt(v, o, t) {
  if (!t.valueDim)
    return [];
  for (var n = o.count(), r = At(n * 2), a = 0; a < n; a++) {
    var e = bt(t, v, o, a);
    r[a * 2] = e[0], r[a * 2 + 1] = e[1];
  }
  return r;
}
function E(v, o, t, n) {
  var r = o.getBaseAxis(), a = r.dim === "x" || r.dim === "radius" ? 0 : 1, e = [], l = 0, s = [], i = [], h = [], u = [];
  if (n) {
    for (l = 0; l < v.length; l += 2)
      !isNaN(v[l]) && !isNaN(v[l + 1]) && u.push(v[l], v[l + 1]);
    v = u;
  }
  for (l = 0; l < v.length - 2; l += 2)
    switch (h[0] = v[l + 2], h[1] = v[l + 3], i[0] = v[l], i[1] = v[l + 1], e.push(i[0], i[1]), t) {
      case "end":
        s[a] = h[a], s[1 - a] = i[1 - a], e.push(s[0], s[1]);
        break;
      case "middle":
        var f = (i[a] + h[a]) / 2, p = [];
        s[a] = p[a] = f, s[1 - a] = i[1 - a], p[1 - a] = h[1 - a], e.push(s[0], s[1]), e.push(p[0], p[1]);
        break;
      default:
        s[a] = i[a], s[1 - a] = h[1 - a], e.push(s[0], s[1]);
    }
  return e.push(v[l++], v[l++]), e;
}
function Vt(v, o) {
  var t = [], n = v.length, r, a;
  function e(h, u, f) {
    var p = h.coord, _ = (f - p) / (u.coord - p), g = Et(_, [h.color, u.color]);
    return {
      coord: f,
      color: g
    };
  }
  for (var l = 0; l < n; l++) {
    var s = v[l], i = s.coord;
    if (i < 0)
      r = s;
    else if (i > o) {
      a ? t.push(e(a, s, o)) : r && t.push(e(r, s, 0), e(r, s, o));
      break;
    } else
      r && (t.push(e(r, s, 0)), r = null), t.push(s), a = s;
  }
  return t;
}
function Ft(v, o, t) {
  var n = v.getVisual("visualMeta");
  if (!(!n || !n.length || !v.count())) {
    if (o.type !== "cartesian2d") {
      process.env.NODE_ENV !== "production" && console.warn("Visual map on line style is only supported on cartesian2d.");
      return;
    }
    for (var r, a, e = n.length - 1; e >= 0; e--) {
      var l = v.getDimensionInfo(n[e].dimension);
      if (r = l && l.coordDim, r === "x" || r === "y") {
        a = n[e];
        break;
      }
    }
    if (!a) {
      process.env.NODE_ENV !== "production" && console.warn("Visual map on line style only support x or y dimension.");
      return;
    }
    var s = o.getAxis(r), i = pt(a.stops, function(c) {
      return {
        coord: s.toGlobalCoord(s.dataToCoord(c.value)),
        color: c.color
      };
    }), h = i.length, u = a.outerColors.slice();
    h && i[0].coord > i[h - 1].coord && (i.reverse(), u.reverse());
    var f = Vt(i, r === "x" ? t.getWidth() : t.getHeight()), p = f.length;
    if (!p && h)
      return i[0].coord < 0 ? u[1] ? u[1] : i[h - 1].color : u[0] ? u[0] : i[0].color;
    var _ = 10, g = f[0].coord - _, m = f[p - 1].coord + _, y = m - g;
    if (y < 1e-3)
      return "transparent";
    ot(f, function(c) {
      c.offset = (c.coord - g) / y;
    }), f.push({
      // NOTE: inRangeStopLen may still be 0 if stoplen is zero.
      offset: p ? f[p - 1].offset : 0.5,
      color: u[1] || "transparent"
    }), f.unshift({
      offset: p ? f[0].offset : 0.5,
      color: u[0] || "transparent"
    });
    var S = new kt(0, 0, 0, 0, f, !0);
    return S[r] = g, S[r + "2"] = m, S;
  }
}
function Ht(v, o, t) {
  var n = v.get("showAllSymbol"), r = n === "auto";
  if (!(n && !r)) {
    var a = t.getAxesByScale("ordinal")[0];
    if (a && !(r && zt(a, o))) {
      var e = o.mapDimension(a.dim), l = {};
      return ot(a.getViewLabels(), function(s) {
        var i = a.scale.getRawOrdinalNumber(s.tickValue);
        l[i] = 1;
      }), function(s) {
        return !l.hasOwnProperty(o.get(e, s));
      };
    }
  }
}
function zt(v, o) {
  var t = v.getExtent(), n = Math.abs(t[1] - t[0]) / v.scale.count();
  isNaN(n) && (n = 0);
  for (var r = o.count(), a = Math.max(1, Math.round(r / 5)), e = 0; e < r; e += a)
    if (lt.getSymbolSize(
      o,
      e
      // Only for cartesian, where `isHorizontal` exists.
    )[v.isHorizontal() ? 1 : 0] * 1.5 > n)
      return !1;
  return !0;
}
function Bt(v, o) {
  return isNaN(v) || isNaN(o);
}
function Rt(v) {
  for (var o = v.length / 2; o > 0 && Bt(v[o * 2 - 2], v[o * 2 - 1]); o--)
    ;
  return o - 1;
}
function it(v, o) {
  return [v[o * 2], v[o * 2 + 1]];
}
function Xt(v, o, t) {
  for (var n = v.length / 2, r = t === "x" ? 0 : 1, a, e, l = 0, s = -1, i = 0; i < n; i++)
    if (e = v[i * 2 + r], !(isNaN(e) || isNaN(v[i * 2 + 1 - r]))) {
      if (i === 0) {
        a = e;
        continue;
      }
      if (a <= o && e >= o || a >= o && e <= o) {
        s = i;
        break;
      }
      l = i, a = e;
    }
  return {
    range: [l, s],
    t: (o - a) / (e - a)
  };
}
function st(v) {
  if (v.get(["endLabel", "show"]))
    return !0;
  for (var o = 0; o < Y.length; o++)
    if (v.get([Y[o], "endLabel", "show"]))
      return !0;
  return !1;
}
function H(v, o, t, n) {
  if (wt(o, "cartesian2d")) {
    var r = n.getModel("endLabel"), a = r.get("valueAnimation"), e = n.getData(), l = {
      lastFrameIndex: 0
    }, s = st(n) ? function(p, _) {
      v._endLabelOnDuring(p, _, e, l, a, r, o);
    } : null, i = o.getBaseAxis().isHorizontal(), h = St(o, t, n, function() {
      var p = v._endLabel;
      p && t && l.originalX != null && p.attr({
        x: l.originalX,
        y: l.originalY
      });
    }, s);
    if (!n.get("clip", !0)) {
      var u = h.shape, f = Math.max(u.width, u.height);
      i ? (u.y -= f, u.height += f * 2) : (u.x -= f, u.width += f * 2);
    }
    return s && s(1, h), h;
  } else
    return process.env.NODE_ENV !== "production" && n.get(["endLabel", "show"]) && console.warn("endLabel is not supported for lines in polar systems."), xt(o, t, n);
}
function Ut(v, o) {
  var t = o.getBaseAxis(), n = t.isHorizontal(), r = t.inverse, a = n ? r ? "right" : "left" : "center", e = n ? "middle" : r ? "top" : "bottom";
  return {
    normal: {
      align: v.get("align") || a,
      verticalAlign: v.get("verticalAlign") || e
    }
  };
}
var fe = (
  /** @class */
  function(v) {
    ht(o, v);
    function o() {
      return v !== null && v.apply(this, arguments) || this;
    }
    return o.prototype.init = function() {
      var t = new Ct(), n = new gt();
      this.group.add(n.group), this._symbolDraw = n, this._lineGroup = t;
    }, o.prototype.render = function(t, n, r) {
      var a = this, e = t.coordinateSystem, l = this.group, s = t.getData(), i = t.getModel("lineStyle"), h = t.getModel("areaStyle"), u = s.getLayout("points") || [], f = e.type === "polar", p = this._coordSys, _ = this._symbolDraw, g = this._polyline, m = this._polygon, y = this._lineGroup, S = !n.ssr && t.get("animation"), c = !h.isEmpty(), I = h.get("origin"), A = _t(e, s, I), d = c && Tt(e, s, A), D = t.get("showSymbol"), x = t.get("connectNulls"), w = D && !f && Ht(t, s, e), N = this._data;
      N && N.eachItemGraphicEl(function(P, ut) {
        P.__temp && (l.remove(P), N.setItemGraphicEl(ut, null));
      }), D || _.remove(), l.add(y);
      var L = f ? !1 : t.get("step"), b;
      e && e.getArea && t.get("clip", !0) && (b = e.getArea(), b.width != null ? (b.x -= 0.1, b.y -= 0.1, b.width += 0.2, b.height += 0.2) : b.r0 && (b.r0 -= 0.5, b.r += 0.5)), this._clipShapeForSymbol = b;
      var C = Ft(s, e, r) || s.getVisual("style")[s.getVisual("drawType")];
      if (!(g && p.type === e.type && L === this._step))
        D && _.updateData(s, {
          isIgnore: w,
          clipShape: b,
          disableAnimation: !0,
          getSymbolPoint: function(P) {
            return [u[P * 2], u[P * 2 + 1]];
          }
        }), S && this._initSymbolLabelAnimation(s, e, b), L && (u = E(u, e, L, x), d && (d = E(d, e, L, x))), g = this._newPolyline(u), c ? m = this._newPolygon(u, d) : m && (y.remove(m), m = this._polygon = null), f || this._initOrUpdateEndLabel(t, e, M(C)), y.setClipPath(H(this, e, !0, t));
      else {
        c && !m ? m = this._newPolygon(u, d) : m && !c && (y.remove(m), m = this._polygon = null), f || this._initOrUpdateEndLabel(t, e, M(C));
        var k = y.getClipPath();
        if (k) {
          var G = H(this, e, !1, t);
          Gt(k, {
            shape: G.shape
          }, t);
        } else
          y.setClipPath(H(this, e, !0, t));
        D && _.updateData(s, {
          isIgnore: w,
          clipShape: b,
          disableAnimation: !0,
          getSymbolPoint: function(P) {
            return [u[P * 2], u[P * 2 + 1]];
          }
        }), (!et(this._stackedOnPoints, d) || !et(this._points, u)) && (S ? this._doUpdateAnimation(s, d, e, r, L, I, x) : (L && (u = E(u, e, L, x), d && (d = E(d, e, L, x))), g.setShape({
          points: u
        }), m && m.setShape({
          points: u,
          stackedOnPoints: d
        })));
      }
      var O = t.getModel("emphasis"), z = O.get("focus"), B = O.get("blurScope"), R = O.get("disabled");
      if (g.useStyle(q(
        // Use color in lineStyle first
        i.getLineStyle(),
        {
          fill: "none",
          stroke: C,
          lineJoin: "bevel"
        }
      )), j(g, t, "lineStyle"), g.style.lineWidth > 0 && t.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var vt = g.getState("emphasis").style;
        vt.lineWidth = +g.style.lineWidth + 1;
      }
      F(g).seriesIndex = t.seriesIndex, K(g, z, B, R);
      var X = nt(t.get("smooth")), U = t.get("smoothMonotone");
      if (g.setShape({
        smooth: X,
        smoothMonotone: U,
        connectNulls: x
      }), m) {
        var W = s.getCalculationInfo("stackedOnSeries"), J = 0;
        m.useStyle(q(h.getAreaStyle(), {
          fill: C,
          opacity: 0.7,
          lineJoin: "bevel",
          decal: s.getVisual("style").decal
        })), W && (J = nt(W.get("smooth"))), m.setShape({
          smooth: X,
          stackedOnSmooth: J,
          smoothMonotone: U,
          connectNulls: x
        }), j(m, t, "areaStyle"), F(m).seriesIndex = t.seriesIndex, K(m, z, B, R);
      }
      var Z = function(P) {
        a._changePolyState(P);
      };
      s.eachItemGraphicEl(function(P) {
        P && (P.onHoverStateChange = Z);
      }), this._polyline.onHoverStateChange = Z, this._data = s, this._coordSys = e, this._stackedOnPoints = d, this._points = u, this._step = L, this._valueOrigin = I, t.get("triggerLineEvent") && (this.packEventData(t, g), m && this.packEventData(t, m));
    }, o.prototype.packEventData = function(t, n) {
      F(n).eventData = {
        componentType: "series",
        componentSubType: "line",
        componentIndex: t.componentIndex,
        seriesIndex: t.seriesIndex,
        seriesName: t.name,
        seriesType: "line"
      };
    }, o.prototype.highlight = function(t, n, r, a) {
      var e = t.getData(), l = $(e, a);
      if (this._changePolyState("emphasis"), !(l instanceof Array) && l != null && l >= 0) {
        var s = e.getLayout("points"), i = e.getItemGraphicEl(l);
        if (!i) {
          var h = s[l * 2], u = s[l * 2 + 1];
          if (isNaN(h) || isNaN(u) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(h, u))
            return;
          var f = t.get("zlevel") || 0, p = t.get("z") || 0;
          i = new lt(e, l), i.x = h, i.y = u, i.setZ(f, p);
          var _ = i.getSymbolPath().getTextContent();
          _ && (_.zlevel = f, _.z = p, _.z2 = this._polyline.z2 + 1), i.__temp = !0, e.setItemGraphicEl(l, i), i.stopSymbolAnimation(!0), this.group.add(i);
        }
        i.highlight();
      } else
        V.prototype.highlight.call(this, t, n, r, a);
    }, o.prototype.downplay = function(t, n, r, a) {
      var e = t.getData(), l = $(e, a);
      if (this._changePolyState("normal"), l != null && l >= 0) {
        var s = e.getItemGraphicEl(l);
        s && (s.__temp ? (e.setItemGraphicEl(l, null), this.group.remove(s)) : s.downplay());
      } else
        V.prototype.downplay.call(this, t, n, r, a);
    }, o.prototype._changePolyState = function(t) {
      var n = this._polygon;
      Q(this._polyline, t), n && Q(n, t);
    }, o.prototype._newPolyline = function(t) {
      var n = this._polyline;
      return n && this._lineGroup.remove(n), n = new yt({
        shape: {
          points: t
        },
        segmentIgnoreThreshold: 2,
        z2: 10
      }), this._lineGroup.add(n), this._polyline = n, n;
    }, o.prototype._newPolygon = function(t, n) {
      var r = this._polygon;
      return r && this._lineGroup.remove(r), r = new dt({
        shape: {
          points: t,
          stackedOnPoints: n
        },
        segmentIgnoreThreshold: 2
      }), this._lineGroup.add(r), this._polygon = r, r;
    }, o.prototype._initSymbolLabelAnimation = function(t, n, r) {
      var a, e, l = n.getBaseAxis(), s = l.inverse;
      n.type === "cartesian2d" ? (a = l.isHorizontal(), e = !1) : n.type === "polar" && (a = l.dim === "angle", e = !0);
      var i = t.hostModel, h = i.get("animationDuration");
      T(h) && (h = h(null));
      var u = i.get("animationDelay") || 0, f = T(u) ? u(null) : u;
      t.eachItemGraphicEl(function(p, _) {
        var g = p;
        if (g) {
          var m = [p.x, p.y], y = void 0, S = void 0, c = void 0;
          if (r)
            if (e) {
              var I = r, A = n.pointToCoord(m);
              a ? (y = I.startAngle, S = I.endAngle, c = -A[1] / 180 * Math.PI) : (y = I.r0, S = I.r, c = A[0]);
            } else {
              var d = r;
              a ? (y = d.x, S = d.x + d.width, c = p.x) : (y = d.y + d.height, S = d.y, c = p.y);
            }
          var D = S === y ? 0 : (c - y) / (S - y);
          s && (D = 1 - D);
          var x = T(u) ? u(_) : h * D + f, w = g.getSymbolPath(), N = w.getTextContent();
          g.attr({
            scaleX: 0,
            scaleY: 0
          }), g.animateTo({
            scaleX: 1,
            scaleY: 1
          }, {
            duration: 200,
            setToFinal: !0,
            delay: x
          }), N && N.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay: x
          }), w.disableLabelAnimation = !0;
        }
      });
    }, o.prototype._initOrUpdateEndLabel = function(t, n, r) {
      var a = t.getModel("endLabel");
      if (st(t)) {
        var e = t.getData(), l = this._polyline, s = e.getLayout("points");
        if (!s) {
          l.removeTextContent(), this._endLabel = null;
          return;
        }
        var i = this._endLabel;
        i || (i = this._endLabel = new Ot({
          z2: 200
          // should be higher than item symbol
        }), i.ignoreClip = !0, l.setTextContent(this._endLabel), l.disableLabelAnimation = !0);
        var h = Rt(s);
        h >= 0 && (It(l, Dt(t, "endLabel"), {
          inheritColor: r,
          labelFetcher: t,
          labelDataIndex: h,
          defaultText: function(u, f, p) {
            return p != null ? Pt(e, p) : Nt(e, u);
          },
          enableTextSetter: !0
        }, Ut(a, n)), l.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, o.prototype._endLabelOnDuring = function(t, n, r, a, e, l, s) {
      var i = this._endLabel, h = this._polyline;
      if (i) {
        t < 1 && a.originalX == null && (a.originalX = i.x, a.originalY = i.y);
        var u = r.getLayout("points"), f = r.hostModel, p = f.get("connectNulls"), _ = l.get("precision"), g = l.get("distance") || 0, m = s.getBaseAxis(), y = m.isHorizontal(), S = m.inverse, c = n.shape, I = S ? y ? c.x : c.y + c.height : y ? c.x + c.width : c.y, A = (y ? g : 0) * (S ? -1 : 1), d = (y ? 0 : -g) * (S ? -1 : 1), D = y ? "x" : "y", x = Xt(u, I, D), w = x.range, N = w[1] - w[0], L = void 0;
        if (N >= 1) {
          if (N > 1 && !p) {
            var b = it(u, w[0]);
            i.attr({
              x: b[0] + A,
              y: b[1] + d
            }), e && (L = f.getRawValue(w[0]));
          } else {
            var b = h.getPointOn(I, D);
            b && i.attr({
              x: b[0] + A,
              y: b[1] + d
            });
            var C = f.getRawValue(w[0]), k = f.getRawValue(w[1]);
            e && (L = ct(r, _, C, k, x.t));
          }
          a.lastFrameIndex = w[0];
        } else {
          var G = t === 1 || a.lastFrameIndex > 0 ? w[0] : 0, b = it(u, G);
          e && (L = f.getRawValue(G)), i.attr({
            x: b[0] + A,
            y: b[1] + d
          });
        }
        if (e) {
          var O = Lt(i);
          typeof O.setLabelText == "function" && O.setLabelText(L);
        }
      }
    }, o.prototype._doUpdateAnimation = function(t, n, r, a, e, l, s) {
      var i = this._polyline, h = this._polygon, u = t.hostModel, f = mt(this._data, t, this._stackedOnPoints, n, this._coordSys, r, this._valueOrigin), p = f.current, _ = f.stackedOnCurrent, g = f.next, m = f.stackedOnNext;
      if (e && (p = E(f.current, r, e, s), _ = E(f.stackedOnCurrent, r, e, s), g = E(f.next, r, e, s), m = E(f.stackedOnNext, r, e, s)), rt(p, g) > 3e3 || h && rt(_, m) > 3e3) {
        i.stopAnimation(), i.setShape({
          points: g
        }), h && (h.stopAnimation(), h.setShape({
          points: g,
          stackedOnPoints: m
        }));
        return;
      }
      i.shape.__points = f.current, i.shape.points = p;
      var y = {
        shape: {
          points: g
        }
      };
      f.current !== p && (y.shape.__points = f.next), i.stopAnimation(), tt(i, y, u), h && (h.setShape({
        // Reuse the points with polyline.
        points: p,
        stackedOnPoints: _
      }), h.stopAnimation(), tt(h, {
        shape: {
          stackedOnPoints: m
        }
      }, u), i.shape.points !== h.shape.points && (h.shape.points = i.shape.points));
      for (var S = [], c = f.status, I = 0; I < c.length; I++) {
        var A = c[I].cmd;
        if (A === "=") {
          var d = t.getItemGraphicEl(c[I].idx1);
          d && S.push({
            el: d,
            ptIdx: I
            // Index of points
          });
        }
      }
      i.animators && i.animators.length && i.animators[0].during(function() {
        h && h.dirtyShape();
        for (var D = i.shape.__points, x = 0; x < S.length; x++) {
          var w = S[x].el, N = S[x].ptIdx * 2;
          w.x = D[N], w.y = D[N + 1], w.markRedraw();
        }
      });
    }, o.prototype.remove = function(t) {
      var n = this.group, r = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(!0), r && r.eachItemGraphicEl(function(a, e) {
        a.__temp && (n.remove(a), r.setItemGraphicEl(e, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, o.type = "line", o;
  }(V)
);
export {
  fe as default
};
//# sourceMappingURL=LineView.mjs.map
