import { __extends as d } from "../../../node_modules/tslib/tslib.es6.mjs";
import { curry as f, createHashMap as y, each as h } from "../../../../zrender/lib/core/util.mjs";
import v from "../helper/createSeriesDataSimply.mjs";
import S from "../../model/Series.mjs";
import M from "../../coord/geo/geoSourceManager.mjs";
import { makeSeriesEncodeForNameBased as b } from "../../data/helper/sourceHelper.mjs";
import { createTooltipMarkup as c } from "../../component/tooltip/tooltipMarkup.mjs";
import { createSymbol as D } from "../../util/symbol.mjs";
var R = (
  /** @class */
  function(u) {
    d(o, u);
    function o() {
      var e = u !== null && u.apply(this, arguments) || this;
      return e.type = o.type, e.needsDrawMap = !1, e.seriesGroup = [], e.getTooltipPosition = function(t) {
        if (t != null) {
          var r = this.getData().getName(t), a = this.coordinateSystem, n = a.getRegion(r);
          return n && a.dataToPoint(n.getCenter());
        }
      }, e;
    }
    return o.prototype.getInitialData = function(e) {
      for (var t = v(this, {
        coordDimensions: ["value"],
        encodeDefaulter: f(b, this)
      }), r = y(), a = [], n = 0, p = t.count(); n < p; n++) {
        var l = t.getName(n);
        r.set(l, !0);
      }
      var s = M.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return h(s.regions, function(i) {
        var m = i.name;
        r.get(m) || a.push(m);
      }), t.appendValues([], a), t;
    }, o.prototype.getHostGeoModel = function() {
      var e = this.option.geoIndex;
      return e != null ? this.ecModel.getComponent("geo", e) : null;
    }, o.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, o.prototype.getRawValue = function(e) {
      var t = this.getData();
      return t.get(t.mapDimension("value"), e);
    }, o.prototype.getRegionModel = function(e) {
      var t = this.getData();
      return t.getItemModel(t.indexOfName(e));
    }, o.prototype.formatTooltip = function(e, t, r) {
      for (var a = this.getData(), n = this.getRawValue(e), p = a.getName(e), l = this.seriesGroup, s = [], i = 0; i < l.length; i++) {
        var m = l[i].originalData.indexOfName(p), g = a.mapDimension("value");
        isNaN(l[i].originalData.get(g, m)) || s.push(l[i].name);
      }
      return c("section", {
        header: s.join(", "),
        noHeader: !s.length,
        blocks: [c("nameValue", {
          name: p,
          value: n
        })]
      });
    }, o.prototype.setZoom = function(e) {
      this.option.zoom = e;
    }, o.prototype.setCenter = function(e) {
      this.option.center = e;
    }, o.prototype.getLegendIcon = function(e) {
      var t = e.icon || "roundRect", r = D(t, 0, 0, e.itemWidth, e.itemHeight, e.itemStyle.fill);
      return r.setStyle(e.itemStyle), r.style.stroke = "none", t.indexOf("empty") > -1 && (r.style.stroke = r.style.fill, r.style.fill = "#fff", r.style.lineWidth = 2), r;
    }, o.type = "series.map", o.dependencies = ["geo"], o.layoutMode = "box", o.defaultOption = {
      // 一级层叠
      // zlevel: 0,
      // 二级层叠
      z: 2,
      coordinateSystem: "geo",
      // map should be explicitly specified since ec3.
      map: "",
      // If `geoIndex` is not specified, a exclusive geo will be
      // created. Otherwise use the specified geo component, and
      // `map` and `mapType` are ignored.
      // geoIndex: 0,
      // 'center' | 'left' | 'right' | 'x%' | {number}
      left: "center",
      // 'center' | 'top' | 'bottom' | 'x%' | {number}
      top: "center",
      // right
      // bottom
      // width:
      // height
      // Aspect is width / height. Inited to be geoJson bbox aspect
      // This parameter is used for scale this aspect
      // Default value:
      // for geoSVG source: 1,
      // for geoJSON source: 0.75.
      aspectScale: null,
      // Layout with center and size
      // If you want to put map in a fixed size box with right aspect ratio
      // This two properties may be more convenient.
      // layoutCenter: [50%, 50%]
      // layoutSize: 100
      showLegendSymbol: !0,
      // Define left-top, right-bottom coords to control view
      // For example, [ [180, 90], [-180, -90] ],
      // higher priority than center and zoom
      boundingCoords: null,
      // Default on center of map
      center: null,
      zoom: 1,
      scaleLimit: null,
      selectedMode: !0,
      label: {
        show: !1,
        color: "#000"
      },
      // scaleLimit: null,
      itemStyle: {
        borderWidth: 0.5,
        borderColor: "#444",
        areaColor: "#eee"
      },
      emphasis: {
        label: {
          show: !0,
          color: "rgb(100,0,0)"
        },
        itemStyle: {
          areaColor: "rgba(255,215,0,0.8)"
        }
      },
      select: {
        label: {
          show: !0,
          color: "rgb(100,0,0)"
        },
        itemStyle: {
          color: "rgba(255,215,0,0.8)"
        }
      },
      nameProperty: "name"
    }, o;
  }(S)
);
export {
  R as default
};
//# sourceMappingURL=MapSeries.mjs.map
