import { __extends as D } from "../../../node_modules/tslib/tslib.es6.mjs";
import { map as b, extend as w, createHashMap as S, each as g, isArray as c } from "../../../../zrender/lib/core/util.mjs";
import x from "../../model/Series.mjs";
import T from "../../data/Tree.mjs";
import f from "../../model/Model.mjs";
import { wrapTreePathInfo as V } from "../helper/treeHelper.mjs";
import { normalizeToArray as v } from "../../util/model.mjs";
import { createTooltipMarkup as A } from "../../component/tooltip/tooltipMarkup.mjs";
import C from "../helper/enableAriaDecalForTree.mjs";
var U = (
  /** @class */
  function(r) {
    D(o, r);
    function o() {
      var e = r !== null && r.apply(this, arguments) || this;
      return e.type = o.type, e.preventUsingHoverLayer = !0, e;
    }
    return o.prototype.getInitialData = function(e, t) {
      var a = {
        name: e.name,
        children: e.data
      };
      y(a);
      var i = e.levels || [], l = this.designatedVisualItemStyle = {}, n = new f({
        itemStyle: l
      }, this, t);
      i = e.levels = L(i, t);
      var u = b(i || [], function(d) {
        return new f(d, n, t);
      }, this), s = T.createTree(a, this, p);
      function p(d) {
        d.wrapMethod("getItemModel", function(m, I) {
          var h = s.getNodeByDataIndex(I), M = h ? u[h.depth] : null;
          return m.parentModel = M || n, m;
        });
      }
      return s.data;
    }, o.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, o.prototype.formatTooltip = function(e, t, a) {
      var i = this.getData(), l = this.getRawValue(e), n = i.getName(e);
      return A("nameValue", {
        name: n,
        value: l
      });
    }, o.prototype.getDataParams = function(e) {
      var t = r.prototype.getDataParams.apply(this, arguments), a = this.getData().tree.getNodeByDataIndex(e);
      return t.treeAncestors = V(a, this), t.treePathInfo = t.treeAncestors, t;
    }, o.prototype.setLayoutInfo = function(e) {
      this.layoutInfo = this.layoutInfo || {}, w(this.layoutInfo, e);
    }, o.prototype.mapIdToIndex = function(e) {
      var t = this._idIndexMap;
      t || (t = this._idIndexMap = S(), this._idIndexMapCount = 0);
      var a = t.get(e);
      return a == null && t.set(e, a = this._idIndexMapCount++), a;
    }, o.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, o.prototype.resetViewRoot = function(e) {
      e ? this._viewRoot = e : e = this._viewRoot;
      var t = this.getRawData().tree.root;
      (!e || e !== t && !t.contains(e)) && (this._viewRoot = t);
    }, o.prototype.enableAriaDecal = function() {
      C(this);
    }, o.type = "series.treemap", o.layoutMode = "box", o.defaultOption = {
      // Disable progressive rendering
      progressive: 0,
      // size: ['80%', '80%'],            // deprecated, compatible with ec2.
      left: "center",
      top: "middle",
      width: "80%",
      height: "80%",
      sort: !0,
      clipWindow: "origin",
      squareRatio: 0.5 * (1 + Math.sqrt(5)),
      leafDepth: null,
      drillDownIcon: "▶",
      // to align specialized icon. ▷▶❒❐▼✚
      zoomToNodeRatio: 0.32 * 0.32,
      scaleLimit: null,
      roam: !0,
      nodeClick: "zoomToNode",
      animation: !0,
      animationDurationUpdate: 900,
      animationEasing: "quinticInOut",
      breadcrumb: {
        show: !0,
        height: 22,
        left: "center",
        top: "bottom",
        // right
        // bottom
        emptyItemWidth: 25,
        itemStyle: {
          color: "rgba(0,0,0,0.7)",
          textStyle: {
            color: "#fff"
          }
        },
        emphasis: {
          itemStyle: {
            color: "rgba(0,0,0,0.9)"
            // '#5793f3',
          }
        }
      },
      label: {
        show: !0,
        // Do not use textDistance, for ellipsis rect just the same as treemap node rect.
        distance: 0,
        padding: 5,
        position: "inside",
        // formatter: null,
        color: "#fff",
        overflow: "truncate"
        // align
        // verticalAlign
      },
      upperLabel: {
        show: !1,
        position: [0, "50%"],
        height: 20,
        // formatter: null,
        // color: '#fff',
        overflow: "truncate",
        // align: null,
        verticalAlign: "middle"
      },
      itemStyle: {
        color: null,
        colorAlpha: null,
        colorSaturation: null,
        borderWidth: 0,
        gapWidth: 0,
        borderColor: "#fff",
        borderColorSaturation: null
        // If specified, borderColor will be ineffective, and the
        // border color is evaluated by color of current node and
        // borderColorSaturation.
      },
      emphasis: {
        upperLabel: {
          show: !0,
          position: [0, "50%"],
          overflow: "truncate",
          verticalAlign: "middle"
        }
      },
      visualDimension: 0,
      visualMin: null,
      visualMax: null,
      color: [],
      // level[n].color (if necessary).
      // + Specify color list of each level. level[0].color would be global
      // color list if not specified. (see method `setDefault`).
      // + But set as a empty array to forbid fetch color from global palette
      // when using nodeModel.get('color'), otherwise nodes on deep level
      // will always has color palette set and are not able to inherit color
      // from parent node.
      // + TreemapSeries.color can not be set as 'none', otherwise effect
      // legend color fetching (see seriesColor.js).
      colorAlpha: null,
      colorSaturation: null,
      colorMappingBy: "index",
      visibleMin: 10,
      // be rendered. Only works when sort is 'asc' or 'desc'.
      childrenVisibleMin: null,
      // grandchildren will not show.
      // Why grandchildren? If not grandchildren but children,
      // some siblings show children and some not,
      // the appearance may be mess and not consistent,
      levels: []
      // Each item: {
      //     visibleMin, itemStyle, visualDimension, label
      // }
    }, o;
  }(x)
);
function y(r) {
  var o = 0;
  g(r.children, function(t) {
    y(t);
    var a = t.value;
    c(a) && (a = a[0]), o += a;
  });
  var e = r.value;
  c(e) && (e = e[0]), (e == null || isNaN(e)) && (e = o), e < 0 && (e = 0), c(r.value) ? r.value[0] = e : r.value = e;
}
function L(r, o) {
  var e = v(o.get("color")), t = v(o.get(["aria", "decal", "decals"]));
  if (e) {
    r = r || [];
    var a, i;
    g(r, function(n) {
      var u = new f(n), s = u.get("color"), p = u.get("decal");
      (u.get(["itemStyle", "color"]) || s && s !== "none") && (a = !0), (u.get(["itemStyle", "decal"]) || p && p !== "none") && (i = !0);
    });
    var l = r[0] || (r[0] = {});
    return a || (l.color = e.slice()), !i && t && (l.decal = t.slice()), r;
  }
}
export {
  U as default
};
//# sourceMappingURL=TreemapSeries.mjs.map
