import { defaults as B, extend as tt, isString as W, each as j, map as et, retrieve as D, isObject as at, retrieve2 as C, isFunction as rt, isNumber as it } from "../../../../zrender/lib/core/util.mjs";
import { subPixelOptimizeLine as z, setTooltipConfig as nt } from "../../util/graphic.mjs";
import { getECData as E } from "../../util/innerStore.mjs";
import { createTextStyle as Z } from "../../label/labelStyle.mjs";
import lt from "../../model/Model.mjs";
import { remRadian as q, isRadianAroundZero as R } from "../../util/number.mjs";
import { normalizeSymbolOffset as ot, createSymbol as st } from "../../util/symbol.mjs";
import { identity as vt, rotate as gt, mul as _ } from "../../../../zrender/lib/core/matrix.mjs";
import { applyTransform as O } from "../../../../zrender/lib/core/vector.mjs";
import { shouldShowAllLabels as ft } from "../../coord/axisHelper.mjs";
import { prepareLayoutList as ut, hideOverlap as ct } from "../../label/labelLayoutHelper.mjs";
import F from "../../../../zrender/lib/graphic/Group.mjs";
import J from "../../../../zrender/lib/graphic/shape/Line.mjs";
import K from "../../../../zrender/lib/graphic/Text.mjs";
var b = Math.PI, w = (
  /** @class */
  function() {
    function a(t, e) {
      this.group = new F(), this.opt = e, this.axisModel = t, B(e, {
        labelOffset: 0,
        nameDirection: 1,
        tickDirection: 1,
        labelDirection: 1,
        silent: !0,
        handleAutoShown: function() {
          return !0;
        }
      });
      var n = new F({
        x: e.position[0],
        y: e.position[1],
        rotation: e.rotation
      });
      n.updateTransform(), this._transformGroup = n;
    }
    return a.prototype.hasBuilder = function(t) {
      return !!G[t];
    }, a.prototype.add = function(t) {
      G[t](this.opt, this.axisModel, this.group, this._transformGroup);
    }, a.prototype.getGroup = function() {
      return this.group;
    }, a.innerTextLayout = function(t, e, n) {
      var r = q(e - t), l, i;
      return R(r) ? (i = n > 0 ? "top" : "bottom", l = "center") : R(r - b) ? (i = n > 0 ? "bottom" : "top", l = "center") : (i = "middle", r > 0 && r < b ? l = n > 0 ? "right" : "left" : l = n > 0 ? "left" : "right"), {
        rotation: r,
        textAlign: l,
        textVerticalAlign: i
      };
    }, a.makeAxisEventDataBase = function(t) {
      var e = {
        componentType: t.mainType,
        componentIndex: t.componentIndex
      };
      return e[t.mainType + "Index"] = t.componentIndex, e;
    }, a.isLabelSilent = function(t) {
      var e = t.get("tooltip");
      return t.get("silent") || !(t.get("triggerEvent") || e && e.show);
    }, a;
  }()
), G = {
  axisLine: function(a, t, e, n) {
    var r = t.get(["axisLine", "show"]);
    if (r === "auto" && a.handleAutoShown && (r = a.handleAutoShown("axisLine")), !!r) {
      var l = t.axis.getExtent(), i = n.transform, o = [l[0], 0], s = [l[1], 0], f = o[0] > s[0];
      i && (O(o, o, i), O(s, s, i));
      var v = tt({
        lineCap: "round"
      }, t.getModel(["axisLine", "lineStyle"]).getLineStyle()), u = new J({
        shape: {
          x1: o[0],
          y1: o[1],
          x2: s[0],
          y2: s[1]
        },
        style: v,
        strokeContainThreshold: a.strokeContainThreshold || 5,
        silent: !0,
        z2: 1
      });
      z(u.shape, u.style.lineWidth), u.anid = "line", e.add(u);
      var g = t.get(["axisLine", "symbol"]);
      if (g != null) {
        var c = t.get(["axisLine", "symbolSize"]);
        W(g) && (g = [g, g]), (W(c) || it(c)) && (c = [c, c]);
        var p = ot(t.get(["axisLine", "symbolOffset"]) || 0, c), d = c[0], x = c[1];
        j([{
          rotate: a.rotation + Math.PI / 2,
          offset: p[0],
          r: 0
        }, {
          rotate: a.rotation - Math.PI / 2,
          offset: p[1],
          r: Math.sqrt((o[0] - s[0]) * (o[0] - s[0]) + (o[1] - s[1]) * (o[1] - s[1]))
        }], function(L, T) {
          if (g[T] !== "none" && g[T] != null) {
            var h = st(g[T], -d / 2, -x / 2, d, x, v.stroke, !0), m = L.r + L.offset, S = f ? s : o;
            h.attr({
              rotation: L.rotate,
              x: S[0] + m * Math.cos(a.rotation),
              y: S[1] - m * Math.sin(a.rotation),
              silent: !0,
              z2: 11
            }), e.add(h);
          }
        });
      }
    }
  },
  axisTickLabel: function(a, t, e, n) {
    var r = Lt(e, n, t, a), l = xt(e, n, t, a);
    if (ht(t, l, r), pt(e, n, t, a.tickDirection), t.get(["axisLabel", "hideOverlap"])) {
      var i = ut(et(l, function(o) {
        return {
          label: o,
          priority: o.z2,
          defaultAttr: {
            ignore: o.ignore
          }
        };
      }));
      ct(i);
    }
  },
  axisName: function(a, t, e, n) {
    var r = D(a.axisName, t.get("name"));
    if (r) {
      var l = t.get("nameLocation"), i = a.nameDirection, o = t.getModel("nameTextStyle"), s = t.get("nameGap") || 0, f = t.axis.getExtent(), v = f[0] > f[1] ? -1 : 1, u = [
        l === "start" ? f[0] - v * s : l === "end" ? f[1] + v * s : (f[0] + f[1]) / 2,
        // Reuse labelOffset.
        P(l) ? a.labelOffset + i * s : 0
      ], g, c = t.get("nameRotate");
      c != null && (c = c * b / 180);
      var p;
      P(l) ? g = w.innerTextLayout(
        a.rotation,
        c ?? a.rotation,
        // Adapt to axis.
        i
      ) : (g = mt(a.rotation, l, c || 0, f), p = a.axisNameAvailableWidth, p != null && (p = Math.abs(p / Math.sin(g.rotation)), !isFinite(p) && (p = null)));
      var d = o.getFont(), x = t.get("nameTruncate", !0) || {}, L = x.ellipsis, T = D(a.nameTruncateMaxWidth, x.maxWidth, p), h = new K({
        x: u[0],
        y: u[1],
        rotation: g.rotation,
        silent: w.isLabelSilent(t),
        style: Z(o, {
          text: r,
          font: d,
          overflow: "truncate",
          width: T,
          ellipsis: L,
          fill: o.getTextColor() || t.get(["axisLine", "lineStyle", "color"]),
          align: o.get("align") || g.textAlign,
          verticalAlign: o.get("verticalAlign") || g.textVerticalAlign
        }),
        z2: 1
      });
      if (nt({
        el: h,
        componentModel: t,
        itemName: r
      }), h.__fullText = r, h.anid = "name", t.get("triggerEvent")) {
        var m = w.makeAxisEventDataBase(t);
        m.targetType = "axisName", m.name = r, E(h).eventData = m;
      }
      n.add(h), h.updateTransform(), e.add(h), h.decomposeTransform();
    }
  }
};
function mt(a, t, e, n) {
  var r = q(e - a), l, i, o = n[0] > n[1], s = t === "start" && !o || t !== "start" && o;
  return R(r - b / 2) ? (i = s ? "bottom" : "top", l = "center") : R(r - b * 1.5) ? (i = s ? "top" : "bottom", l = "center") : (i = "middle", r < b * 1.5 && r > b / 2 ? l = s ? "left" : "right" : l = s ? "right" : "left"), {
    rotation: r,
    textAlign: l,
    textVerticalAlign: i
  };
}
function ht(a, t, e) {
  if (!ft(a.axis)) {
    var n = a.get(["axisLabel", "showMinLabel"]), r = a.get(["axisLabel", "showMaxLabel"]);
    t = t || [], e = e || [];
    var l = t[0], i = t[1], o = t[t.length - 1], s = t[t.length - 2], f = e[0], v = e[1], u = e[e.length - 1], g = e[e.length - 2];
    n === !1 ? (y(l), y(f)) : I(l, i) && (n ? (y(i), y(v)) : (y(l), y(f))), r === !1 ? (y(o), y(u)) : I(s, o) && (r ? (y(s), y(g)) : (y(o), y(u)));
  }
}
function y(a) {
  a && (a.ignore = !0);
}
function I(a, t) {
  var e = a && a.getBoundingRect().clone(), n = t && t.getBoundingRect().clone();
  if (!(!e || !n)) {
    var r = vt([]);
    return gt(r, r, -a.rotation), e.applyTransform(_([], r, a.getLocalTransform())), n.applyTransform(_([], r, t.getLocalTransform())), e.intersect(n);
  }
}
function P(a) {
  return a === "middle" || a === "center";
}
function Q(a, t, e, n, r) {
  for (var l = [], i = [], o = [], s = 0; s < a.length; s++) {
    var f = a[s].coord;
    i[0] = f, i[1] = 0, o[0] = f, o[1] = e, t && (O(i, i, t), O(o, o, t));
    var v = new J({
      shape: {
        x1: i[0],
        y1: i[1],
        x2: o[0],
        y2: o[1]
      },
      style: n,
      z2: 2,
      autoBatch: !0,
      silent: !0
    });
    z(v.shape, v.style.lineWidth), v.anid = r + "_" + a[s].tickValue, l.push(v);
  }
  return l;
}
function Lt(a, t, e, n) {
  var r = e.axis, l = e.getModel("axisTick"), i = l.get("show");
  if (i === "auto" && n.handleAutoShown && (i = n.handleAutoShown("axisTick")), !(!i || r.scale.isBlank())) {
    for (var o = l.getModel("lineStyle"), s = n.tickDirection * l.get("length"), f = r.getTicksCoords(), v = Q(f, t.transform, s, B(o.getLineStyle(), {
      stroke: e.get(["axisLine", "lineStyle", "color"])
    }), "ticks"), u = 0; u < v.length; u++)
      a.add(v[u]);
    return v;
  }
}
function pt(a, t, e, n) {
  var r = e.axis, l = e.getModel("minorTick");
  if (!(!l.get("show") || r.scale.isBlank())) {
    var i = r.getMinorTicksCoords();
    if (i.length)
      for (var o = l.getModel("lineStyle"), s = n * l.get("length"), f = B(o.getLineStyle(), B(e.getModel("axisTick").getLineStyle(), {
        stroke: e.get(["axisLine", "lineStyle", "color"])
      })), v = 0; v < i.length; v++)
        for (var u = Q(i[v], t.transform, s, f, "minorticks_" + v), g = 0; g < u.length; g++)
          a.add(u[g]);
  }
}
function xt(a, t, e, n) {
  var r = e.axis, l = D(n.axisLabelShow, e.get(["axisLabel", "show"]));
  if (!(!l || r.scale.isBlank())) {
    var i = e.getModel("axisLabel"), o = i.get("margin"), s = r.getViewLabels(), f = (D(n.labelRotate, i.get("rotate")) || 0) * b / 180, v = w.innerTextLayout(n.rotation, f, n.labelDirection), u = e.getCategories && e.getCategories(!0), g = [], c = w.isLabelSilent(e), p = e.get("triggerEvent");
    return j(s, function(d, x) {
      var L = r.scale.type === "ordinal" ? r.scale.getRawOrdinalNumber(d.tickValue) : d.tickValue, T = d.formattedLabel, h = d.rawLabel, m = i;
      if (u && u[L]) {
        var S = u[L];
        at(S) && S.textStyle && (m = new lt(S.textStyle, i, e.ecModel));
      }
      var V = m.getTextColor() || e.get(["axisLine", "lineStyle", "color"]), U = r.dataToCoord(L), N = m.getShallow("align", !0) || v.textAlign, X = C(m.getShallow("alignMinLabel", !0), N), Y = C(m.getShallow("alignMaxLabel", !0), N), M = m.getShallow("verticalAlign", !0) || m.getShallow("baseline", !0) || v.textVerticalAlign, $ = C(m.getShallow("verticalAlignMinLabel", !0), M), H = C(m.getShallow("verticalAlignMaxLabel", !0), M), A = new K({
        x: U,
        y: n.labelOffset + n.labelDirection * o,
        rotation: v.rotation,
        silent: c,
        z2: 10 + (d.level || 0),
        style: Z(m, {
          text: T,
          align: x === 0 ? X : x === s.length - 1 ? Y : N,
          verticalAlign: x === 0 ? $ : x === s.length - 1 ? H : M,
          fill: rt(V) ? V(
            // (1) In category axis with data zoom, tick is not the original
            // index of axis.data. So tick should not be exposed to user
            // in category axis.
            // (2) Compatible with previous version, which always use formatted label as
            // input. But in interval scale the formatted label is like '223,445', which
            // maked user replace ','. So we modify it to return original val but remain
            // it as 'string' to avoid error in replacing.
            r.type === "category" ? h : r.type === "value" ? L + "" : L,
            x
          ) : V
        })
      });
      if (A.anid = "label_" + L, p) {
        var k = w.makeAxisEventDataBase(e);
        k.targetType = "axisLabel", k.value = h, k.tickIndex = x, r.type === "category" && (k.dataIndex = L), E(A).eventData = k;
      }
      t.add(A), A.updateTransform(), g.push(A), a.add(A), A.decomposeTransform();
    }), g;
  }
}
export {
  w as default
};
//# sourceMappingURL=AxisBuilder.mjs.map
