import { __extends as k } from "../../../node_modules/tslib/tslib.es6.mjs";
import { isString as S, isFunction as N, extend as T, map as O } from "../../../../zrender/lib/core/util.mjs";
import { createTextStyle as w } from "../../label/labelStyle.mjs";
import { formatTplSimple as z } from "../../util/format.mjs";
import { parsePercent as W } from "../../util/number.mjs";
import R from "../../view/Component.mjs";
import { getLocaleModel as L } from "../../core/locale.mjs";
import A from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import I from "../../../../zrender/lib/graphic/shape/Polyline.mjs";
import P from "../../../../zrender/lib/graphic/Text.mjs";
var G = (
  /** @class */
  function(x) {
    k(f, x);
    function f() {
      var e = x !== null && x.apply(this, arguments) || this;
      return e.type = f.type, e;
    }
    return f.prototype.render = function(e, r, l) {
      var i = this.group;
      i.removeAll();
      var t = e.coordinateSystem, n = t.getRangeInfo(), o = t.getOrient(), a = r.getLocaleModel();
      this._renderDayRect(e, n, i), this._renderLines(e, n, o, i), this._renderYearText(e, n, o, i), this._renderMonthText(e, a, o, i), this._renderWeekText(e, a, n, o, i);
    }, f.prototype._renderDayRect = function(e, r, l) {
      for (var i = e.coordinateSystem, t = e.getModel("itemStyle").getItemStyle(), n = i.getCellWidth(), o = i.getCellHeight(), a = r.start.time; a <= r.end.time; a = i.getNextNDay(a, 1).time) {
        var s = i.dataToRect([a], !1).tl, v = new A({
          shape: {
            x: s[0],
            y: s[1],
            width: n,
            height: o
          },
          cursor: "default",
          style: t
        });
        l.add(v);
      }
    }, f.prototype._renderLines = function(e, r, l, i) {
      var t = this, n = e.coordinateSystem, o = e.getModel(["splitLine", "lineStyle"]).getLineStyle(), a = e.get(["splitLine", "show"]), s = o.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var v = r.start, p = 0; v.time <= r.end.time; p++) {
        m(v.formatedDate), p === 0 && (v = n.getDateInfo(r.start.y + "-" + r.start.m));
        var g = v.date;
        g.setMonth(g.getMonth() + 1), v = n.getDateInfo(g);
      }
      m(n.getNextNDay(r.end.time, 1).formatedDate);
      function m(y) {
        t._firstDayOfMonth.push(n.getDateInfo(y)), t._firstDayPoints.push(n.dataToRect([y], !1).tl);
        var h = t._getLinePointsOfOneWeek(e, y, l);
        t._tlpoints.push(h[0]), t._blpoints.push(h[h.length - 1]), a && t._drawSplitline(h, o, i);
      }
      a && this._drawSplitline(t._getEdgesPoints(t._tlpoints, s, l), o, i), a && this._drawSplitline(t._getEdgesPoints(t._blpoints, s, l), o, i);
    }, f.prototype._getEdgesPoints = function(e, r, l) {
      var i = [e[0].slice(), e[e.length - 1].slice()], t = l === "horizontal" ? 0 : 1;
      return i[0][t] = i[0][t] - r / 2, i[1][t] = i[1][t] + r / 2, i;
    }, f.prototype._drawSplitline = function(e, r, l) {
      var i = new I({
        z2: 20,
        shape: {
          points: e
        },
        style: r
      });
      l.add(i);
    }, f.prototype._getLinePointsOfOneWeek = function(e, r, l) {
      for (var i = e.coordinateSystem, t = i.getDateInfo(r), n = [], o = 0; o < 7; o++) {
        var a = i.getNextNDay(t.time, o), s = i.dataToRect([a.time], !1);
        n[2 * a.day] = s.tl, n[2 * a.day + 1] = s[l === "horizontal" ? "bl" : "tr"];
      }
      return n;
    }, f.prototype._formatterLabel = function(e, r) {
      return S(e) && e ? z(e, r) : N(e) ? e(r) : r.nameMap;
    }, f.prototype._yearTextPositionControl = function(e, r, l, i, t) {
      var n = r[0], o = r[1], a = ["center", "bottom"];
      i === "bottom" ? (o += t, a = ["center", "top"]) : i === "left" ? n -= t : i === "right" ? (n += t, a = ["center", "top"]) : o -= t;
      var s = 0;
      return (i === "left" || i === "right") && (s = Math.PI / 2), {
        rotation: s,
        x: n,
        y: o,
        style: {
          align: a[0],
          verticalAlign: a[1]
        }
      };
    }, f.prototype._renderYearText = function(e, r, l, i) {
      var t = e.getModel("yearLabel");
      if (t.get("show")) {
        var n = t.get("margin"), o = t.get("position");
        o || (o = l !== "horizontal" ? "top" : "left");
        var a = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], s = (a[0][0] + a[1][0]) / 2, v = (a[0][1] + a[1][1]) / 2, p = l === "horizontal" ? 0 : 1, g = {
          top: [s, a[p][1]],
          bottom: [s, a[1 - p][1]],
          left: [a[1 - p][0], v],
          right: [a[p][0], v]
        }, m = r.start.y;
        +r.end.y > +r.start.y && (m = m + "-" + r.end.y);
        var y = t.get("formatter"), h = {
          start: r.start.y,
          end: r.end.y,
          nameMap: m
        }, d = this._formatterLabel(y, h), _ = new P({
          z2: 30,
          style: w(t, {
            text: d
          })
        });
        _.attr(this._yearTextPositionControl(_, g[o], l, o, n)), i.add(_);
      }
    }, f.prototype._monthTextPositionControl = function(e, r, l, i, t) {
      var n = "left", o = "top", a = e[0], s = e[1];
      return l === "horizontal" ? (s = s + t, r && (n = "center"), i === "start" && (o = "bottom")) : (a = a + t, r && (o = "middle"), i === "start" && (n = "right")), {
        x: a,
        y: s,
        align: n,
        verticalAlign: o
      };
    }, f.prototype._renderMonthText = function(e, r, l, i) {
      var t = e.getModel("monthLabel");
      if (t.get("show")) {
        var n = t.get("nameMap"), o = t.get("margin"), a = t.get("position"), s = t.get("align"), v = [this._tlpoints, this._blpoints];
        (!n || S(n)) && (n && (r = L(n) || r), n = r.get(["time", "monthAbbr"]) || []);
        var p = a === "start" ? 0 : 1, g = l === "horizontal" ? 0 : 1;
        o = a === "start" ? -o : o;
        for (var m = s === "center", y = 0; y < v[p].length - 1; y++) {
          var h = v[p][y].slice(), d = this._firstDayOfMonth[y];
          if (m) {
            var _ = this._firstDayPoints[y];
            h[g] = (_[g] + v[0][y + 1][g]) / 2;
          }
          var c = t.get("formatter"), u = n[+d.m - 1], b = {
            yyyy: d.y,
            yy: (d.y + "").slice(2),
            MM: d.m,
            M: +d.m,
            nameMap: u
          }, M = this._formatterLabel(c, b), C = new P({
            z2: 30,
            style: T(w(t, {
              text: M
            }), this._monthTextPositionControl(h, m, l, a, o))
          });
          i.add(C);
        }
      }
    }, f.prototype._weekTextPositionControl = function(e, r, l, i, t) {
      var n = "center", o = "middle", a = e[0], s = e[1], v = l === "start";
      return r === "horizontal" ? (a = a + i + (v ? 1 : -1) * t[0] / 2, n = v ? "right" : "left") : (s = s + i + (v ? 1 : -1) * t[1] / 2, o = v ? "bottom" : "top"), {
        x: a,
        y: s,
        align: n,
        verticalAlign: o
      };
    }, f.prototype._renderWeekText = function(e, r, l, i, t) {
      var n = e.getModel("dayLabel");
      if (n.get("show")) {
        var o = e.coordinateSystem, a = n.get("position"), s = n.get("nameMap"), v = n.get("margin"), p = o.getFirstDayOfWeek();
        if (!s || S(s)) {
          s && (r = L(s) || r);
          var g = r.get(["time", "dayOfWeekShort"]);
          s = g || O(r.get(["time", "dayOfWeekAbbr"]), function(b) {
            return b[0];
          });
        }
        var m = o.getNextNDay(l.end.time, 7 - l.lweek).time, y = [o.getCellWidth(), o.getCellHeight()];
        v = W(v, Math.min(y[1], y[0])), a === "start" && (m = o.getNextNDay(l.start.time, -(7 + l.fweek)).time, v = -v);
        for (var h = 0; h < 7; h++) {
          var d = o.getNextNDay(m, h), _ = o.dataToRect([d.time], !1).center, c = h;
          c = Math.abs((h + p) % 7);
          var u = new P({
            z2: 30,
            style: T(w(n, {
              text: s[c]
            }), this._weekTextPositionControl(_, i, a, v, y))
          });
          t.add(u);
        }
      }
    }, f.type = "calendar", f;
  }(R)
);
export {
  G as default
};
//# sourceMappingURL=CalendarView.mjs.map
