import { __extends as X } from "../../../node_modules/tslib/tslib.es6.mjs";
import { bind as m, each as T, indexOf as U, isFunction as $, isString as j } from "../../../../zrender/lib/core/util.mjs";
import { stop as C } from "../../../../zrender/lib/core/event.mjs";
import { getTransform as q, transformDirection as J, applyTransform as V } from "../../util/graphic.mjs";
import { createOrUpdate as K, clear as Q } from "../../util/throttle.mjs";
import tt from "./DataZoomView.mjs";
import { linearMap as M, parsePercent as k, asc as B } from "../../util/number.mjs";
import { getLayoutParams as et, getLayoutRect as at } from "../../util/layout.mjs";
import rt from "../helper/sliderMove.mjs";
import { getAxisMainType as it, collectReferCoordSysModelInfo as ot } from "./helper.mjs";
import { enableHoverEmphasis as st } from "../../util/states.mjs";
import { symbolBuildProxies as nt, createSymbol as O } from "../../util/symbol.mjs";
import { deprecateLog as ht } from "../../util/log.mjs";
import { createTextStyle as lt } from "../../label/labelStyle.mjs";
import F from "../../../../zrender/lib/graphic/Group.mjs";
import dt from "../../../../zrender/lib/graphic/Text.mjs";
import G from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import ut from "../../../../zrender/lib/core/Point.mjs";
import pt from "../../../../zrender/lib/graphic/shape/Polygon.mjs";
import vt from "../../../../zrender/lib/graphic/shape/Polyline.mjs";
var I = G, H = 7, gt = 1, P = 30, ft = 7, R = "horizontal", N = "vertical", ct = 5, mt = ["line", "bar", "candlestick", "scatter"], _t = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
}, Ot = (
  /** @class */
  function(b) {
    X(h, b);
    function h() {
      var t = b !== null && b.apply(this, arguments) || this;
      return t.type = h.type, t._displayables = {}, t;
    }
    return h.prototype.init = function(t, e) {
      this.api = e, this._onBrush = m(this._onBrush, this), this._onBrushEnd = m(this._onBrushEnd, this);
    }, h.prototype.render = function(t, e, r, o) {
      if (b.prototype.render.apply(this, arguments), K(this, "_dispatchZoomAction", t.get("throttle"), "fixRate"), this._orient = t.getOrient(), t.get("show") === !1) {
        this.group.removeAll();
        return;
      }
      if (t.noTarget()) {
        this._clear(), this.group.removeAll();
        return;
      }
      (!o || o.type !== "dataZoom" || o.from !== this.uid) && this._buildView(), this._updateView();
    }, h.prototype.dispose = function() {
      this._clear(), b.prototype.dispose.apply(this, arguments);
    }, h.prototype._clear = function() {
      Q(this, "_dispatchZoomAction");
      var t = this.api.getZr();
      t.off("mousemove", this._onBrush), t.off("mouseup", this._onBrushEnd);
    }, h.prototype._buildView = function() {
      var t = this.group;
      t.removeAll(), this._brushing = !1, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
      var e = this._displayables.sliderGroup = new F();
      this._renderBackground(), this._renderHandle(), this._renderDataShadow(), t.add(e), this._positionGroup();
    }, h.prototype._resetLocation = function() {
      var t = this.dataZoomModel, e = this.api, r = t.get("brushSelect"), o = r ? ft : 0, a = this._findCoordRect(), i = {
        width: e.getWidth(),
        height: e.getHeight()
      }, s = this._orient === R ? {
        // Why using 'right', because right should be used in vertical,
        // and it is better to be consistent for dealing with position param merge.
        right: i.width - a.x - a.width,
        top: i.height - P - H - o,
        width: a.width,
        height: P
      } : {
        right: H,
        top: a.y,
        width: P,
        height: a.height
      }, n = et(t.option);
      T(["right", "top", "width", "height"], function(d) {
        n[d] === "ph" && (n[d] = s[d]);
      });
      var l = at(n, i);
      this._location = {
        x: l.x,
        y: l.y
      }, this._size = [l.width, l.height], this._orient === N && this._size.reverse();
    }, h.prototype._positionGroup = function() {
      var t = this.group, e = this._location, r = this._orient, o = this.dataZoomModel.getFirstTargetAxisModel(), a = o && o.get("inverse"), i = this._displayables.sliderGroup, s = (this._dataShadowInfo || {}).otherAxisInverse;
      i.attr(r === R && !a ? {
        scaleY: s ? 1 : -1,
        scaleX: 1
      } : r === R && a ? {
        scaleY: s ? 1 : -1,
        scaleX: -1
      } : r === N && !a ? {
        scaleY: s ? -1 : 1,
        scaleX: 1,
        rotation: Math.PI / 2
      } : {
        scaleY: s ? -1 : 1,
        scaleX: -1,
        rotation: Math.PI / 2
      });
      var n = t.getBoundingRect([i]);
      t.x = e.x - n.x, t.y = e.y - n.y, t.markRedraw();
    }, h.prototype._getViewExtent = function() {
      return [0, this._size[0]];
    }, h.prototype._renderBackground = function() {
      var t = this.dataZoomModel, e = this._size, r = this._displayables.sliderGroup, o = t.get("brushSelect");
      r.add(new I({
        silent: !0,
        shape: {
          x: 0,
          y: 0,
          width: e[0],
          height: e[1]
        },
        style: {
          fill: t.get("backgroundColor")
        },
        z2: -40
      }));
      var a = new I({
        shape: {
          x: 0,
          y: 0,
          width: e[0],
          height: e[1]
        },
        style: {
          fill: "transparent"
        },
        z2: 0,
        onclick: m(this._onClickPanel, this)
      }), i = this.api.getZr();
      o ? (a.on("mousedown", this._onBrushStart, this), a.cursor = "crosshair", i.on("mousemove", this._onBrush), i.on("mouseup", this._onBrushEnd)) : (i.off("mousemove", this._onBrush), i.off("mouseup", this._onBrushEnd)), r.add(a);
    }, h.prototype._renderDataShadow = function() {
      var t = this._dataShadowInfo = this._prepareDataShadowInfo();
      if (this._displayables.dataShadowSegs = [], !t)
        return;
      var e = this._size, r = this._shadowSize || [], o = t.series, a = o.getRawData(), i = o.getShadowDim && o.getShadowDim(), s = i && a.getDimensionInfo(i) ? o.getShadowDim() : t.otherDim;
      if (s == null)
        return;
      var n = this._shadowPolygonPts, l = this._shadowPolylinePts;
      if (a !== this._shadowData || s !== this._shadowDim || e[0] !== r[0] || e[1] !== r[1]) {
        var d = a.getDataExtent(s), g = (d[1] - d[0]) * 0.3;
        d = [d[0] - g, d[1] + g];
        var p = [0, e[1]], v = [0, e[0]], u = [[e[0], 0], [0, 0]], f = [], S = v[1] / (a.count() - 1), c = 0, D = Math.round(a.count() / e[0]), y;
        a.each([s], function(w, Z) {
          if (D > 0 && Z % D) {
            c += S;
            return;
          }
          var x = w == null || isNaN(w) || w === "", z = x ? 0 : M(w, d, p, !0);
          x && !y && Z ? (u.push([u[u.length - 1][0], 0]), f.push([f[f.length - 1][0], 0])) : !x && y && (u.push([c, 0]), f.push([c, 0])), u.push([c, z]), f.push([c, z]), c += S, y = x;
        }), n = this._shadowPolygonPts = u, l = this._shadowPolylinePts = f;
      }
      this._shadowData = a, this._shadowDim = s, this._shadowSize = [e[0], e[1]];
      var _ = this.dataZoomModel;
      function L(w) {
        var Z = _.getModel(w ? "selectedDataBackground" : "dataBackground"), x = new F(), z = new pt({
          shape: {
            points: n
          },
          segmentIgnoreThreshold: 1,
          style: Z.getModel("areaStyle").getAreaStyle(),
          silent: !0,
          z2: -20
        }), Y = new vt({
          shape: {
            points: l
          },
          segmentIgnoreThreshold: 1,
          style: Z.getModel("lineStyle").getLineStyle(),
          silent: !0,
          z2: -19
        });
        return x.add(z), x.add(Y), x;
      }
      for (var E = 0; E < 3; E++) {
        var A = L(E === 1);
        this._displayables.sliderGroup.add(A), this._displayables.dataShadowSegs.push(A);
      }
    }, h.prototype._prepareDataShadowInfo = function() {
      var t = this.dataZoomModel, e = t.get("showDataShadow");
      if (e !== !1) {
        var r, o = this.ecModel;
        return t.eachTargetAxis(function(a, i) {
          var s = t.getAxisProxy(a, i).getTargetSeriesModels();
          T(s, function(n) {
            if (!r && !(e !== !0 && U(mt, n.get("type")) < 0)) {
              var l = o.getComponent(it(a), i).axis, d = yt(a), g, p = n.coordinateSystem;
              d != null && p.getOtherAxis && (g = p.getOtherAxis(l).inverse), d = n.getData().mapDimension(d), r = {
                thisAxis: l,
                series: n,
                thisDim: a,
                otherDim: d,
                otherAxisInverse: g
              };
            }
          }, this);
        }, this), r;
      }
    }, h.prototype._renderHandle = function() {
      var t = this.group, e = this._displayables, r = e.handles = [null, null], o = e.handleLabels = [null, null], a = this._displayables.sliderGroup, i = this._size, s = this.dataZoomModel, n = this.api, l = s.get("borderRadius") || 0, d = s.get("brushSelect"), g = e.filler = new I({
        silent: d,
        style: {
          fill: s.get("fillerColor")
        },
        textConfig: {
          position: "inside"
        }
      });
      a.add(g), a.add(new I({
        silent: !0,
        subPixelOptimize: !0,
        shape: {
          x: 0,
          y: 0,
          width: i[0],
          height: i[1],
          r: l
        },
        style: {
          // deprecated option
          stroke: s.get("dataBackgroundColor") || s.get("borderColor"),
          lineWidth: gt,
          fill: "rgba(0,0,0,0)"
        }
      })), T([0, 1], function(D) {
        var y = s.get("handleIcon");
        !nt[y] && y.indexOf("path://") < 0 && y.indexOf("image://") < 0 && (y = "path://" + y, process.env.NODE_ENV !== "production" && ht("handleIcon now needs 'path://' prefix when using a path string"));
        var _ = O(y, -1, 0, 2, 2, null, !0);
        _.attr({
          cursor: W(this._orient),
          draggable: !0,
          drift: m(this._onDragMove, this, D),
          ondragend: m(this._onDragEnd, this),
          onmouseover: m(this._showDataInfo, this, !0),
          onmouseout: m(this._showDataInfo, this, !1),
          z2: 5
        });
        var L = _.getBoundingRect(), E = s.get("handleSize");
        this._handleHeight = k(E, this._size[1]), this._handleWidth = L.width / L.height * this._handleHeight, _.setStyle(s.getModel("handleStyle").getItemStyle()), _.style.strokeNoScale = !0, _.rectHover = !0, _.ensureState("emphasis").style = s.getModel(["emphasis", "handleStyle"]).getItemStyle(), st(_);
        var A = s.get("handleColor");
        A != null && (_.style.fill = A), a.add(r[D] = _);
        var w = s.getModel("textStyle");
        t.add(o[D] = new dt({
          silent: !0,
          invisible: !0,
          style: lt(w, {
            x: 0,
            y: 0,
            text: "",
            verticalAlign: "middle",
            align: "center",
            fill: w.getTextColor(),
            font: w.getFont()
          }),
          z2: 10
        }));
      }, this);
      var p = g;
      if (d) {
        var v = k(s.get("moveHandleSize"), i[1]), u = e.moveHandle = new G({
          style: s.getModel("moveHandleStyle").getItemStyle(),
          silent: !0,
          shape: {
            r: [0, 0, 2, 2],
            y: i[1] - 0.5,
            height: v
          }
        }), f = v * 0.8, S = e.moveHandleIcon = O(s.get("moveHandleIcon"), -f / 2, -f / 2, f, f, "#fff", !0);
        S.silent = !0, S.y = i[1] + v / 2 - 0.5, u.ensureState("emphasis").style = s.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
        var c = Math.min(i[1] / 2, Math.max(v, 10));
        p = e.moveZone = new G({
          invisible: !0,
          shape: {
            y: i[1] - c,
            height: v + c
          }
        }), p.on("mouseover", function() {
          n.enterEmphasis(u);
        }).on("mouseout", function() {
          n.leaveEmphasis(u);
        }), a.add(u), a.add(S), a.add(p);
      }
      p.attr({
        draggable: !0,
        cursor: W(this._orient),
        drift: m(this._onDragMove, this, "all"),
        ondragstart: m(this._showDataInfo, this, !0),
        ondragend: m(this._onDragEnd, this),
        onmouseover: m(this._showDataInfo, this, !0),
        onmouseout: m(this._showDataInfo, this, !1)
      });
    }, h.prototype._resetInterval = function() {
      var t = this._range = this.dataZoomModel.getPercentRange(), e = this._getViewExtent();
      this._handleEnds = [M(t[0], [0, 100], e, !0), M(t[1], [0, 100], e, !0)];
    }, h.prototype._updateInterval = function(t, e) {
      var r = this.dataZoomModel, o = this._handleEnds, a = this._getViewExtent(), i = r.findRepresentativeAxisProxy().getMinMaxSpan(), s = [0, 100];
      rt(e, o, a, r.get("zoomLock") ? "all" : t, i.minSpan != null ? M(i.minSpan, s, a, !0) : null, i.maxSpan != null ? M(i.maxSpan, s, a, !0) : null);
      var n = this._range, l = this._range = B([M(o[0], a, s, !0), M(o[1], a, s, !0)]);
      return !n || n[0] !== l[0] || n[1] !== l[1];
    }, h.prototype._updateView = function(t) {
      var e = this._displayables, r = this._handleEnds, o = B(r.slice()), a = this._size;
      T([0, 1], function(p) {
        var v = e.handles[p], u = this._handleHeight;
        v.attr({
          scaleX: u / 2,
          scaleY: u / 2,
          // This is a trick, by adding an extra tiny offset to let the default handle's end point align to the drag window.
          // NOTE: It may affect some custom shapes a bit. But we prefer to have better result by default.
          x: r[p] + (p ? -1 : 1),
          y: a[1] / 2 - u / 2
        });
      }, this), e.filler.setShape({
        x: o[0],
        y: 0,
        width: o[1] - o[0],
        height: a[1]
      });
      var i = {
        x: o[0],
        width: o[1] - o[0]
      };
      e.moveHandle && (e.moveHandle.setShape(i), e.moveZone.setShape(i), e.moveZone.getBoundingRect(), e.moveHandleIcon && e.moveHandleIcon.attr("x", i.x + i.width / 2));
      for (var s = e.dataShadowSegs, n = [0, o[0], o[1], a[0]], l = 0; l < s.length; l++) {
        var d = s[l], g = d.getClipPath();
        g || (g = new G(), d.setClipPath(g)), g.setShape({
          x: n[l],
          y: 0,
          width: n[l + 1] - n[l],
          height: a[1]
        });
      }
      this._updateDataInfo(t);
    }, h.prototype._updateDataInfo = function(t) {
      var e = this.dataZoomModel, r = this._displayables, o = r.handleLabels, a = this._orient, i = ["", ""];
      if (e.get("showDetail")) {
        var s = e.findRepresentativeAxisProxy();
        if (s) {
          var n = s.getAxisModel().axis, l = this._range, d = t ? s.calculateDataWindow({
            start: l[0],
            end: l[1]
          }).valueWindow : s.getDataValueWindow();
          i = [this._formatLabel(d[0], n), this._formatLabel(d[1], n)];
        }
      }
      var g = B(this._handleEnds.slice());
      p.call(this, 0), p.call(this, 1);
      function p(v) {
        var u = q(r.handles[v].parent, this.group), f = J(v === 0 ? "right" : "left", u), S = this._handleWidth / 2 + ct, c = V([g[v] + (v === 0 ? -S : S), this._size[1] / 2], u);
        o[v].setStyle({
          x: c[0],
          y: c[1],
          verticalAlign: a === R ? "middle" : f,
          align: a === R ? f : "center",
          text: i[v]
        });
      }
    }, h.prototype._formatLabel = function(t, e) {
      var r = this.dataZoomModel, o = r.get("labelFormatter"), a = r.get("labelPrecision");
      (a == null || a === "auto") && (a = e.getPixelPrecision());
      var i = t == null || isNaN(t) ? "" : e.type === "category" || e.type === "time" ? e.scale.getLabel({
        value: Math.round(t)
      }) : t.toFixed(Math.min(a, 20));
      return $(o) ? o(t, i) : j(o) ? o.replace("{value}", i) : i;
    }, h.prototype._showDataInfo = function(t) {
      t = this._dragging || t;
      var e = this._displayables, r = e.handleLabels;
      r[0].attr("invisible", !t), r[1].attr("invisible", !t), e.moveHandle && this.api[t ? "enterEmphasis" : "leaveEmphasis"](e.moveHandle, 1);
    }, h.prototype._onDragMove = function(t, e, r, o) {
      this._dragging = !0, C(o.event);
      var a = this._displayables.sliderGroup.getLocalTransform(), i = V([e, r], a, !0), s = this._updateInterval(t, i[0]), n = this.dataZoomModel.get("realtime");
      this._updateView(!n), s && n && this._dispatchZoomAction(!0);
    }, h.prototype._onDragEnd = function() {
      this._dragging = !1, this._showDataInfo(!1);
      var t = this.dataZoomModel.get("realtime");
      !t && this._dispatchZoomAction(!1);
    }, h.prototype._onClickPanel = function(t) {
      var e = this._size, r = this._displayables.sliderGroup.transformCoordToLocal(t.offsetX, t.offsetY);
      if (!(r[0] < 0 || r[0] > e[0] || r[1] < 0 || r[1] > e[1])) {
        var o = this._handleEnds, a = (o[0] + o[1]) / 2, i = this._updateInterval("all", r[0] - a);
        this._updateView(), i && this._dispatchZoomAction(!1);
      }
    }, h.prototype._onBrushStart = function(t) {
      var e = t.offsetX, r = t.offsetY;
      this._brushStart = new ut(e, r), this._brushing = !0, this._brushStartTime = +/* @__PURE__ */ new Date();
    }, h.prototype._onBrushEnd = function(t) {
      if (this._brushing) {
        var e = this._displayables.brushRect;
        if (this._brushing = !1, !!e) {
          e.attr("ignore", !0);
          var r = e.shape, o = +/* @__PURE__ */ new Date();
          if (!(o - this._brushStartTime < 200 && Math.abs(r.width) < 5)) {
            var a = this._getViewExtent(), i = [0, 100];
            this._range = B([M(r.x, a, i, !0), M(r.x + r.width, a, i, !0)]), this._handleEnds = [r.x, r.x + r.width], this._updateView(), this._dispatchZoomAction(!1);
          }
        }
      }
    }, h.prototype._onBrush = function(t) {
      this._brushing && (C(t.event), this._updateBrushRect(t.offsetX, t.offsetY));
    }, h.prototype._updateBrushRect = function(t, e) {
      var r = this._displayables, o = this.dataZoomModel, a = r.brushRect;
      a || (a = r.brushRect = new I({
        silent: !0,
        style: o.getModel("brushStyle").getItemStyle()
      }), r.sliderGroup.add(a)), a.attr("ignore", !1);
      var i = this._brushStart, s = this._displayables.sliderGroup, n = s.transformCoordToLocal(t, e), l = s.transformCoordToLocal(i.x, i.y), d = this._size;
      n[0] = Math.max(Math.min(d[0], n[0]), 0), a.setShape({
        x: l[0],
        y: 0,
        width: n[0] - l[0],
        height: d[1]
      });
    }, h.prototype._dispatchZoomAction = function(t) {
      var e = this._range;
      this.api.dispatchAction({
        type: "dataZoom",
        from: this.uid,
        dataZoomId: this.dataZoomModel.id,
        animation: t ? _t : null,
        start: e[0],
        end: e[1]
      });
    }, h.prototype._findCoordRect = function() {
      var t, e = ot(this.dataZoomModel).infoList;
      if (!t && e.length) {
        var r = e[0].model.coordinateSystem;
        t = r.getRect && r.getRect();
      }
      if (!t) {
        var o = this.api.getWidth(), a = this.api.getHeight();
        t = {
          x: o * 0.2,
          y: a * 0.2,
          width: o * 0.6,
          height: a * 0.6
        };
      }
      return t;
    }, h.type = "dataZoom.slider", h;
  }(tt)
);
function yt(b) {
  var h = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return h[b];
}
function W(b) {
  return b === "vertical" ? "ns-resize" : "ew-resize";
}
export {
  Ot as default
};
//# sourceMappingURL=SliderZoomView.mjs.map
