import { createHashMap as G, each as S, extend as E } from "../../../../zrender/lib/core/util.mjs";
import J from "./RoamController.mjs";
import { updateViewOnPan as Z, updateViewOnZoom as U } from "./roamHelper.mjs";
import { onIrrelevantElement as q } from "./cursorHelper.mjs";
import { setTooltipConfig as K } from "../../util/graphic.mjs";
import { setDefaultStateProxy as j, toggleHoverEmphasis as Q, enableComponentHighDownFeatures as W } from "../../util/states.mjs";
import L from "../../coord/geo/geoSourceManager.mjs";
import { getUID as $ } from "../../util/component.mjs";
import { setLabelStyle as C, getLabelStatesModels as B } from "../../label/labelStyle.mjs";
import { getECData as ee } from "../../util/innerStore.mjs";
import { createOrUpdatePatternFromDecal as te } from "../../util/decal.mjs";
import A from "../../../../zrender/lib/graphic/Displayable.mjs";
import { makeInner as oe } from "../../util/model.mjs";
import D from "../../../../zrender/lib/graphic/Group.mjs";
import re from "../../../../zrender/lib/graphic/shape/Polygon.mjs";
import ae from "../../../../zrender/lib/graphic/shape/Polyline.mjs";
import { updateProps as ne } from "../../animation/basicTransition.mjs";
import ie from "../../../../zrender/lib/graphic/CompoundPath.mjs";
var b = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], se = G(b), le = G(b.concat(["g"])), ue = G(b.concat(["g"])), x = oe();
function I(u) {
  var e = u.getItemStyle(), t = u.get("areaColor");
  return t != null && (e.fill = t), e;
}
function F(u) {
  var e = u.style;
  e && (e.stroke = e.stroke || e.fill, e.fill = null);
}
var Ve = (
  /** @class */
  function() {
    function u(e) {
      var t = new D();
      this.uid = $("ec_map_draw"), this._controller = new J(e.getZr()), this._controllerHost = {
        target: t
      }, this.group = t, t.add(this._regionsGroup = new D()), t.add(this._svgGroup = new D());
    }
    return u.prototype.draw = function(e, t, o, s, r) {
      var i = e.mainType === "geo", n = e.getData && e.getData();
      i && t.eachComponent({
        mainType: "series",
        subType: "map"
      }, function(v) {
        !n && v.getHostGeoModel() === e && (n = v.getData());
      });
      var f = e.coordinateSystem, a = this._regionsGroup, c = this.group, g = f.getTransformInfo(), h = g.raw, l = g.roam, p = !a.childAt(0) || r;
      p ? (c.x = l.x, c.y = l.y, c.scaleX = l.scaleX, c.scaleY = l.scaleY, c.dirty()) : ne(c, l, e);
      var m = n && n.getVisual("visualMeta") && n.getVisual("visualMeta").length > 0, d = {
        api: o,
        geo: f,
        mapOrGeoModel: e,
        data: n,
        isVisualEncodedByVisualMap: m,
        isGeo: i,
        transformInfoRaw: h
      };
      f.resourceType === "geoJSON" ? this._buildGeoJSON(d) : f.resourceType === "geoSVG" && this._buildSVG(d), this._updateController(e, t, o), this._updateMapSelectHandler(e, a, o, s);
    }, u.prototype._buildGeoJSON = function(e) {
      var t = this._regionsGroupByName = G(), o = G(), s = this._regionsGroup, r = e.transformInfoRaw, i = e.mapOrGeoModel, n = e.data, f = e.geo.projection, a = f && f.stream;
      function c(l, p) {
        return p && (l = p(l)), l && [l[0] * r.scaleX + r.x, l[1] * r.scaleY + r.y];
      }
      function g(l) {
        for (var p = [], m = !a && f && f.project, d = 0; d < l.length; ++d) {
          var v = c(l[d], m);
          v && p.push(v);
        }
        return p;
      }
      function h(l) {
        return {
          shape: {
            points: g(l)
          }
        };
      }
      s.removeAll(), S(e.geo.regions, function(l) {
        var p = l.name, m = t.get(p), d = o.get(p) || {}, v = d.dataIdx, M = d.regionModel;
        m || (m = t.set(p, new D()), s.add(m), v = n ? n.indexOfName(p) : null, M = e.isGeo ? i.getRegionModel(p) : n ? n.getItemModel(v) : null, o.set(p, {
          dataIdx: v,
          regionModel: M
        }));
        var V = [], N = [];
        S(l.geometries, function(_) {
          if (_.type === "polygon") {
            var T = [_.exterior].concat(_.interiors || []);
            a && (T = Y(T, a)), S(T, function(R) {
              V.push(new re(h(R)));
            });
          } else {
            var y = _.points;
            a && (y = Y(y, a, !0)), S(y, function(R) {
              N.push(new ae(h(R)));
            });
          }
        });
        var X = c(l.getCenter(), f && f.project);
        function P(_, T) {
          if (_.length) {
            var y = new ie({
              culling: !0,
              segmentIgnoreThreshold: 1,
              shape: {
                paths: _
              }
            });
            m.add(y), w(e, y, v, M), H(e, y, p, M, i, v, X), T && (F(y), S(y.states, F));
          }
        }
        P(V), P(N, !0);
      }), t.each(function(l, p) {
        var m = o.get(p), d = m.dataIdx, v = m.regionModel;
        k(e, l, p, v, i, d), O(e, l, p, v, i), z(e, l, p, v, i);
      }, this);
    }, u.prototype._buildSVG = function(e) {
      var t = e.geo.map, o = e.transformInfoRaw;
      this._svgGroup.x = o.x, this._svgGroup.y = o.y, this._svgGroup.scaleX = o.scaleX, this._svgGroup.scaleY = o.scaleY, this._svgResourceChanged(t) && (this._freeSVG(), this._useSVG(t));
      var s = this._svgDispatcherMap = G(), r = !1;
      S(this._svgGraphicRecord.named, function(i) {
        var n = i.name, f = e.mapOrGeoModel, a = e.data, c = i.svgNodeTagLower, g = i.el, h = a ? a.indexOfName(n) : null, l = f.getRegionModel(n);
        if (se.get(c) != null && g instanceof A && w(e, g, h, l), g instanceof A && (g.culling = !0), g.z2EmphasisLift = 0, !i.namedFrom && (ue.get(c) != null && H(e, g, n, l, f, h, null), k(e, g, n, l, f, h), O(e, g, n, l, f), le.get(c) != null)) {
          var p = z(e, g, n, l, f);
          p === "self" && (r = !0);
          var m = s.get(n) || s.set(n, []);
          m.push(g);
        }
      }, this), this._enableBlurEntireSVG(r, e);
    }, u.prototype._enableBlurEntireSVG = function(e, t) {
      if (e && t.isGeo) {
        var o = t.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), s = o.opacity;
        this._svgGraphicRecord.root.traverse(function(r) {
          if (!r.isGroup) {
            j(r);
            var i = r.ensureState("blur").style || {};
            i.opacity == null && s != null && (i.opacity = s), r.ensureState("emphasis");
          }
        });
      }
    }, u.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, u.prototype.findHighDownDispatchers = function(e, t) {
      if (e == null)
        return [];
      var o = t.coordinateSystem;
      if (o.resourceType === "geoJSON") {
        var s = this._regionsGroupByName;
        if (s) {
          var r = s.get(e);
          return r ? [r] : [];
        }
      } else if (o.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(e) || [];
    }, u.prototype._svgResourceChanged = function(e) {
      return this._svgMapName !== e;
    }, u.prototype._useSVG = function(e) {
      var t = L.getGeoResource(e);
      if (t && t.type === "geoSVG") {
        var o = t.useGraphic(this.uid);
        this._svgGroup.add(o.root), this._svgGraphicRecord = o, this._svgMapName = e;
      }
    }, u.prototype._freeSVG = function() {
      var e = this._svgMapName;
      if (e != null) {
        var t = L.getGeoResource(e);
        t && t.type === "geoSVG" && t.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, u.prototype._updateController = function(e, t, o) {
      var s = e.coordinateSystem, r = this._controller, i = this._controllerHost;
      i.zoomLimit = e.get("scaleLimit"), i.zoom = s.getZoom(), r.enable(e.get("roam") || !1);
      var n = e.mainType;
      function f() {
        var a = {
          type: "geoRoam",
          componentType: n
        };
        return a[n + "Id"] = e.id, a;
      }
      r.off("pan").on("pan", function(a) {
        this._mouseDownFlag = !1, Z(i, a.dx, a.dy), o.dispatchAction(E(f(), {
          dx: a.dx,
          dy: a.dy,
          animation: {
            duration: 0
          }
        }));
      }, this), r.off("zoom").on("zoom", function(a) {
        this._mouseDownFlag = !1, U(i, a.scale, a.originX, a.originY), o.dispatchAction(E(f(), {
          totalZoom: i.zoom,
          zoom: a.scale,
          originX: a.originX,
          originY: a.originY,
          animation: {
            duration: 0
          }
        }));
      }, this), r.setPointerChecker(function(a, c, g) {
        return s.containPoint([c, g]) && !q(a, o, e);
      });
    }, u.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(e) {
        var t = e.getTextContent();
        t && (t.ignore = x(t).ignore);
      });
    }, u.prototype._updateMapSelectHandler = function(e, t, o, s) {
      var r = this;
      t.off("mousedown"), t.off("click"), e.get("selectedMode") && (t.on("mousedown", function() {
        r._mouseDownFlag = !0;
      }), t.on("click", function(i) {
        r._mouseDownFlag && (r._mouseDownFlag = !1);
      }));
    }, u;
  }()
);
function w(u, e, t, o) {
  var s = o.getModel("itemStyle"), r = o.getModel(["emphasis", "itemStyle"]), i = o.getModel(["blur", "itemStyle"]), n = o.getModel(["select", "itemStyle"]), f = I(s), a = I(r), c = I(n), g = I(i), h = u.data;
  if (h) {
    var l = h.getItemVisual(t, "style"), p = h.getItemVisual(t, "decal");
    u.isVisualEncodedByVisualMap && l.fill && (f.fill = l.fill), p && (f.decal = te(p, u.api));
  }
  e.setStyle(f), e.style.strokeNoScale = !0, e.ensureState("emphasis").style = a, e.ensureState("select").style = c, e.ensureState("blur").style = g, j(e);
}
function H(u, e, t, o, s, r, i) {
  var n = u.data, f = u.isGeo, a = n && isNaN(n.get(n.mapDimension("value"), r)), c = n && n.getItemLayout(r);
  if (f || a || c && c.showLabel) {
    var g = f ? t : r, h = void 0;
    (!n || r >= 0) && (h = s);
    var l = i ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    C(e, B(o), {
      labelFetcher: h,
      labelDataIndex: g,
      defaultText: t
    }, l);
    var p = e.getTextContent();
    if (p && (x(p).ignore = p.ignore, e.textConfig && i)) {
      var m = e.getBoundingRect().clone();
      e.textConfig.layoutRect = m, e.textConfig.position = [(i[0] - m.x) / m.width * 100 + "%", (i[1] - m.y) / m.height * 100 + "%"];
    }
    e.disableLabelAnimation = !0;
  } else
    e.removeTextContent(), e.removeTextConfig(), e.disableLabelAnimation = null;
}
function k(u, e, t, o, s, r) {
  u.data ? u.data.setItemGraphicEl(r, e) : ee(e).eventData = {
    componentType: "geo",
    componentIndex: s.componentIndex,
    geoIndex: s.componentIndex,
    name: t,
    region: o && o.option || {}
  };
}
function O(u, e, t, o, s) {
  u.data || K({
    el: e,
    componentModel: s,
    itemName: t,
    // @ts-ignore FIXME:TS fix the "compatible with each other"?
    itemTooltipOption: o.get("tooltip")
  });
}
function z(u, e, t, o, s) {
  e.highDownSilentOnTouch = !!s.get("selectedMode");
  var r = o.getModel("emphasis"), i = r.get("focus");
  return Q(e, i, r.get("blurScope"), r.get("disabled")), u.isGeo && W(e, s, t), i;
}
function Y(u, e, t) {
  var o = [], s;
  function r() {
    s = [];
  }
  function i() {
    s.length && (o.push(s), s = []);
  }
  var n = e({
    polygonStart: r,
    polygonEnd: i,
    lineStart: r,
    lineEnd: i,
    point: function(f, a) {
      isFinite(f) && isFinite(a) && s.push([f, a]);
    },
    sphere: function() {
    }
  });
  return !t && n.polygonStart(), S(u, function(f) {
    n.lineStart();
    for (var a = 0; a < f.length; a++)
      n.point(f[a][0], f[a][1]);
    n.lineEnd();
  }), !t && n.polygonEnd(), o;
}
export {
  Ve as default
};
//# sourceMappingURL=MapDraw.mjs.map
