import { __extends as N } from "../../../node_modules/tslib/tslib.es6.mjs";
import { defaults as X, createHashMap as j, extend as E, isFunction as I, isString as q, curry as J, each as Q } from "../../../../zrender/lib/core/util.mjs";
import { parse as Y, stringify as M } from "../../../../zrender/lib/tool/color.mjs";
import { setTooltipConfig as tt } from "../../util/graphic.mjs";
import { enableHoverEmphasis as P } from "../../util/states.mjs";
import { setLabelStyle as et, createTextStyle as it } from "../../label/labelStyle.mjs";
import { makeBackground as rt } from "../helper/listComponent.mjs";
import { getLayoutRect as K, box as V } from "../../util/layout.mjs";
import nt from "../../view/Component.mjs";
import { createSymbol as at } from "../../util/symbol.mjs";
import { createOrUpdatePatternFromDecal as ot } from "../../util/decal.mjs";
import { getECData as z } from "../../util/innerStore.mjs";
import $ from "../../../../zrender/lib/graphic/Text.mjs";
import st from "../../../../zrender/lib/graphic/shape/Rect.mjs";
import lt from "../../../../zrender/lib/graphic/Group.mjs";
var L = J, B = Q, H = lt, Gt = (
  /** @class */
  function(a) {
    N(r, a);
    function r() {
      var t = a !== null && a.apply(this, arguments) || this;
      return t.type = r.type, t.newlineDisabled = !1, t;
    }
    return r.prototype.init = function() {
      this.group.add(this._contentGroup = new H()), this.group.add(this._selectorGroup = new H()), this._isFirstRender = !0;
    }, r.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, r.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, r.prototype.render = function(t, e, h) {
      var c = this._isFirstRender;
      if (this._isFirstRender = !1, this.resetInner(), !!t.get("show", !0)) {
        var f = t.get("align"), y = t.get("orient");
        (!f || f === "auto") && (f = t.get("left") === "right" && y === "vertical" ? "right" : "left");
        var p = t.get("selector", !0), i = t.get("selectorPosition", !0);
        p && (!i || i === "auto") && (i = y === "horizontal" ? "end" : "start"), this.renderInner(f, t, e, h, p, y, i);
        var o = t.getBoxLayoutParams(), u = {
          width: h.getWidth(),
          height: h.getHeight()
        }, s = t.get("padding"), l = K(o, u, s), g = this.layoutInner(t, f, l, c, p, i), n = K(X({
          width: g.width,
          height: g.height
        }, o), u, s);
        this.group.x = n.x - g.x, this.group.y = n.y - g.y, this.group.markRedraw(), this.group.add(this._backgroundEl = rt(g, t));
      }
    }, r.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, r.prototype.renderInner = function(t, e, h, c, f, y, p) {
      var i = this.getContentGroup(), o = j(), u = e.get("selectedMode"), s = [];
      h.eachRawSeries(function(l) {
        !l.get("legendHoverLink") && s.push(l.id);
      }), B(e.getData(), function(l, g) {
        var n = l.get("name");
        if (!this.newlineDisabled && (n === "" || n === `
`)) {
          var m = new H();
          m.newline = !0, i.add(m);
          return;
        }
        var v = h.getSeriesByName(n)[0];
        if (!o.get(n)) {
          if (v) {
            var x = v.getData(), d = x.getVisual("legendLineStyle") || {}, C = x.getVisual("legendIcon"), S = x.getVisual("style"), _ = this._createItem(v, n, g, l, e, t, d, S, C, u, c);
            _.on("click", L(U, n, null, c, s)).on("mouseover", L(F, v.name, null, c, s)).on("mouseout", L(O, v.name, null, c, s)), h.ssr && _.eachChild(function(k) {
              var w = z(k);
              w.seriesIndex = v.seriesIndex, w.dataIndex = g, w.ssrType = "legend";
            }), o.set(n, !0);
          } else
            h.eachRawSeries(function(k) {
              if (!o.get(n) && k.legendVisualProvider) {
                var w = k.legendVisualProvider;
                if (!w.containName(n))
                  return;
                var A = w.indexOfName(n), b = w.getItemVisual(A, "style"), D = w.getItemVisual(A, "legendIcon"), R = Y(b.fill);
                R && R[3] === 0 && (R[3] = 0.2, b = E(E({}, b), {
                  fill: M(R, "rgba")
                }));
                var G = this._createItem(k, n, g, l, e, t, {}, b, D, u, c);
                G.on("click", L(U, null, n, c, s)).on("mouseover", L(F, null, n, c, s)).on("mouseout", L(O, null, n, c, s)), h.ssr && G.eachChild(function(T) {
                  var W = z(T);
                  W.seriesIndex = k.seriesIndex, W.dataIndex = g, W.ssrType = "legend";
                }), o.set(n, !0);
              }
            }, this);
          process.env.NODE_ENV !== "production" && (o.get(n) || console.warn(n + " series not exists. Legend data should be same with series name or data name."));
        }
      }, this), f && this._createSelector(f, e, c, y, p);
    }, r.prototype._createSelector = function(t, e, h, c, f) {
      var y = this.getSelectorGroup();
      B(t, function(i) {
        var o = i.type, u = new $({
          style: {
            x: 0,
            y: 0,
            align: "center",
            verticalAlign: "middle"
          },
          onclick: function() {
            h.dispatchAction({
              type: o === "all" ? "legendAllSelect" : "legendInverseSelect"
            });
          }
        });
        y.add(u);
        var s = e.getModel("selectorLabel"), l = e.getModel(["emphasis", "selectorLabel"]);
        et(u, {
          normal: s,
          emphasis: l
        }, {
          defaultText: i.title
        }), P(u);
      });
    }, r.prototype._createItem = function(t, e, h, c, f, y, p, i, o, u, s) {
      var l = t.visualDrawType, g = f.get("itemWidth"), n = f.get("itemHeight"), m = f.isSelected(e), v = c.get("symbolRotate"), x = c.get("symbolKeepAspect"), d = c.get("icon");
      o = d || o || "roundRect";
      var C = ct(o, c, p, i, l, m, s), S = new H(), _ = c.getModel("textStyle");
      if (I(t.getLegendIcon) && (!d || d === "inherit"))
        S.add(t.getLegendIcon({
          itemWidth: g,
          itemHeight: n,
          icon: o,
          iconRotate: v,
          itemStyle: C.itemStyle,
          lineStyle: C.lineStyle,
          symbolKeepAspect: x
        }));
      else {
        var k = d === "inherit" && t.getData().getVisual("symbol") ? v === "inherit" ? t.getData().getVisual("symbolRotate") : v : 0;
        S.add(ht({
          itemWidth: g,
          itemHeight: n,
          icon: o,
          iconRotate: k,
          itemStyle: C.itemStyle,
          lineStyle: C.lineStyle,
          symbolKeepAspect: x
        }));
      }
      var w = y === "left" ? g + 5 : -5, A = y, b = f.get("formatter"), D = e;
      q(b) && b ? D = b.replace("{name}", e ?? "") : I(b) && (D = b(e));
      var R = m ? _.getTextColor() : c.get("inactiveColor");
      S.add(new $({
        style: it(_, {
          text: D,
          x: w,
          y: n / 2,
          fill: R,
          align: A,
          verticalAlign: "middle"
        }, {
          inheritColor: R
        })
      }));
      var G = new st({
        shape: S.getBoundingRect(),
        style: {
          // Cannot use 'invisible' because SVG SSR will miss the node
          fill: "transparent"
        }
      }), T = c.getModel("tooltip");
      return T.get("show") && tt({
        el: G,
        componentModel: f,
        itemName: e,
        itemTooltipOption: T.option
      }), S.add(G), S.eachChild(function(W) {
        W.silent = !0;
      }), G.silent = !u, this.getContentGroup().add(S), P(S), S.__legendDataIndex = h, S;
    }, r.prototype.layoutInner = function(t, e, h, c, f, y) {
      var p = this.getContentGroup(), i = this.getSelectorGroup();
      V(t.get("orient"), p, t.get("itemGap"), h.width, h.height);
      var o = p.getBoundingRect(), u = [-o.x, -o.y];
      if (i.markRedraw(), p.markRedraw(), f) {
        V(
          // Buttons in selectorGroup always layout horizontally
          "horizontal",
          i,
          t.get("selectorItemGap", !0)
        );
        var s = i.getBoundingRect(), l = [-s.x, -s.y], g = t.get("selectorButtonGap", !0), n = t.getOrient().index, m = n === 0 ? "width" : "height", v = n === 0 ? "height" : "width", x = n === 0 ? "y" : "x";
        y === "end" ? l[n] += o[m] + g : u[n] += s[m] + g, l[1 - n] += o[v] / 2 - s[v] / 2, i.x = l[0], i.y = l[1], p.x = u[0], p.y = u[1];
        var d = {
          x: 0,
          y: 0
        };
        return d[m] = o[m] + g + s[m], d[v] = Math.max(o[v], s[v]), d[x] = Math.min(0, s[x] + l[1 - n]), d;
      } else
        return p.x = u[0], p.y = u[1], this.group.getBoundingRect();
    }, r.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = !0;
    }, r.type = "legend.plain", r;
  }(nt)
);
function ct(a, r, t, e, h, c, f) {
  function y(m, v) {
    m.lineWidth === "auto" && (m.lineWidth = v.lineWidth > 0 ? 2 : 0), B(m, function(x, d) {
      m[d] === "inherit" && (m[d] = v[d]);
    });
  }
  var p = r.getModel("itemStyle"), i = p.getItemStyle(), o = a.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke", u = p.getShallow("decal");
  i.decal = !u || u === "inherit" ? e.decal : ot(u, f), i.fill === "inherit" && (i.fill = e[h]), i.stroke === "inherit" && (i.stroke = e[o]), i.opacity === "inherit" && (i.opacity = (h === "fill" ? e : t).opacity), y(i, e);
  var s = r.getModel("lineStyle"), l = s.getLineStyle();
  if (y(l, t), i.fill === "auto" && (i.fill = e.fill), i.stroke === "auto" && (i.stroke = e.fill), l.stroke === "auto" && (l.stroke = e.fill), !c) {
    var g = r.get("inactiveBorderWidth"), n = i[o];
    i.lineWidth = g === "auto" ? e.lineWidth > 0 && n ? 2 : 0 : i.lineWidth, i.fill = r.get("inactiveColor"), i.stroke = r.get("inactiveBorderColor"), l.stroke = s.get("inactiveColor"), l.lineWidth = s.get("inactiveWidth");
  }
  return {
    itemStyle: i,
    lineStyle: l
  };
}
function ht(a) {
  var r = a.icon || "roundRect", t = at(r, 0, 0, a.itemWidth, a.itemHeight, a.itemStyle.fill, a.symbolKeepAspect);
  return t.setStyle(a.itemStyle), t.rotation = (a.iconRotate || 0) * Math.PI / 180, t.setOrigin([a.itemWidth / 2, a.itemHeight / 2]), r.indexOf("empty") > -1 && (t.style.stroke = t.style.fill, t.style.fill = "#fff", t.style.lineWidth = 2), t;
}
function U(a, r, t, e) {
  O(a, r, t, e), t.dispatchAction({
    type: "legendToggleSelect",
    name: a ?? r
  }), F(a, r, t, e);
}
function Z(a) {
  for (var r = a.getZr().storage.getDisplayList(), t, e = 0, h = r.length; e < h && !(t = r[e].states.emphasis); )
    e++;
  return t && t.hoverLayer;
}
function F(a, r, t, e) {
  Z(t) || t.dispatchAction({
    type: "highlight",
    seriesName: a,
    name: r,
    excludeSeriesId: e
  });
}
function O(a, r, t, e) {
  Z(t) || t.dispatchAction({
    type: "downplay",
    seriesName: a,
    name: r,
    excludeSeriesId: e
  });
}
export {
  Gt as default
};
//# sourceMappingURL=LegendView.mjs.map
