import { __extends as J } from "../../../node_modules/tslib/tslib.es6.mjs";
import z from "../../data/SeriesData.mjs";
import { parsePercent as K } from "../../util/number.mjs";
import { getAxisInfo as M, numCalculate as Q, dataTransform as P, dataFilter as H, createMarkerDimValueGetter as U } from "./markerHelper.mjs";
import X from "../../chart/helper/LineDraw.mjs";
import Y from "./MarkerView.mjs";
import { getStackedDimension as Z } from "../../data/helper/dataStackHelper.mjs";
import { isCoordinateSystemType as $ } from "../../coord/CoordinateSystem.mjs";
import { getECData as W } from "../../util/innerStore.mjs";
import T from "./MarkerModel.mjs";
import { isArray as h, retrieve2 as A, map as V, extend as R, curry as j, filter as C, retrieve as _, clone as F, isNumber as x, logError as d, merge as q } from "../../../../zrender/lib/core/util.mjs";
import { makeInner as tt } from "../../util/model.mjs";
import { getVisualFromData as et } from "../../visual/helper.mjs";
var N = tt(), at = function(e, a, r, t) {
  var g = e.getData(), i;
  if (h(t))
    i = t;
  else {
    var l = t.type;
    if (l === "min" || l === "max" || l === "average" || l === "median" || t.xAxis != null || t.yAxis != null) {
      var o = void 0, f = void 0;
      if (t.yAxis != null || t.xAxis != null)
        o = a.getAxis(t.yAxis != null ? "y" : "x"), f = _(t.yAxis, t.xAxis);
      else {
        var s = M(t, g, a, e);
        o = s.valueAxis;
        var m = Z(g, s.valueDataDim);
        f = Q(g, m, l);
      }
      var c = o.dim === "x" ? 0 : 1, y = 1 - c, u = F(t), v = {
        coord: []
      };
      u.type = null, u.coord = [], u.coord[y] = -1 / 0, v.coord[y] = 1 / 0;
      var D = r.get("precision");
      D >= 0 && x(f) && (f = +f.toFixed(Math.min(D, 20))), u.coord[c] = v.coord[c] = f, i = [u, v, {
        type: l,
        valueIndex: t.valueIndex,
        // Force to use the value of calculated value.
        value: f
      }];
    } else
      process.env.NODE_ENV !== "production" && d("Invalid markLine data."), i = [];
  }
  var p = [P(e, i[0]), P(e, i[1]), R({}, i[2])];
  return p[2].type = p[2].type || null, q(p[2], p[0]), q(p[2], p[1]), p;
};
function O(e) {
  return !isNaN(e) && !isFinite(e);
}
function B(e, a, r, t) {
  var g = 1 - e, i = t.dimensions[e];
  return O(a[g]) && O(r[g]) && a[e] === r[e] && t.getAxis(i).containData(a[e]);
}
function rt(e, a) {
  if (e.type === "cartesian2d") {
    var r = a[0].coord, t = a[1].coord;
    if (r && t && (B(1, r, t, e) || B(0, r, t, e)))
      return !0;
  }
  return H(e, a[0]) && H(e, a[1]);
}
function E(e, a, r, t, g) {
  var i = t.coordinateSystem, l = e.getItemModel(a), o, f = K(l.get("x"), g.getWidth()), s = K(l.get("y"), g.getHeight());
  if (!isNaN(f) && !isNaN(s))
    o = [f, s];
  else {
    if (t.getMarkerPosition)
      o = t.getMarkerPosition(e.getValues(e.dimensions, a));
    else {
      var m = i.dimensions, c = e.get(m[0], a), y = e.get(m[1], a);
      o = i.dataToPoint([c, y]);
    }
    if ($(i, "cartesian2d")) {
      var u = i.getAxis("x"), v = i.getAxis("y"), m = i.dimensions;
      O(e.get(m[0], a)) ? o[0] = u.toGlobalCoord(u.getExtent()[r ? 0 : 1]) : O(e.get(m[1], a)) && (o[1] = v.toGlobalCoord(v.getExtent()[r ? 0 : 1]));
    }
    isNaN(f) || (o[0] = f), isNaN(s) || (o[1] = s);
  }
  e.setItemLayout(a, o);
}
var Dt = (
  /** @class */
  function(e) {
    J(a, e);
    function a() {
      var r = e !== null && e.apply(this, arguments) || this;
      return r.type = a.type, r;
    }
    return a.prototype.updateTransform = function(r, t, g) {
      t.eachSeries(function(i) {
        var l = T.getMarkerModelFromSeries(i, "markLine");
        if (l) {
          var o = l.getData(), f = N(l).from, s = N(l).to;
          f.each(function(m) {
            E(f, m, !0, i, g), E(s, m, !1, i, g);
          }), o.each(function(m) {
            o.setItemLayout(m, [f.getItemLayout(m), s.getItemLayout(m)]);
          }), this.markerGroupMap.get(i.id).updateLayout();
        }
      }, this);
    }, a.prototype.renderSeries = function(r, t, g, i) {
      var l = r.coordinateSystem, o = r.id, f = r.getData(), s = this.markerGroupMap, m = s.get(o) || s.set(o, new X());
      this.group.add(m.group);
      var c = nt(l, r, t), y = c.from, u = c.to, v = c.line;
      N(t).from = y, N(t).to = u, t.setData(v);
      var D = t.get("symbol"), p = t.get("symbolSize"), k = t.get("symbolRotate"), L = t.get("symbolOffset");
      h(D) || (D = [D, D]), h(p) || (p = [p, p]), h(k) || (k = [k, k]), h(L) || (L = [L, L]), c.from.each(function(n) {
        G(y, n, !0), G(u, n, !1);
      }), v.each(function(n) {
        var b = v.getItemModel(n).getModel("lineStyle").getLineStyle();
        v.setItemLayout(n, [y.getItemLayout(n), u.getItemLayout(n)]), b.stroke == null && (b.stroke = y.getItemVisual(n, "style").fill), v.setItemVisual(n, {
          fromSymbolKeepAspect: y.getItemVisual(n, "symbolKeepAspect"),
          fromSymbolOffset: y.getItemVisual(n, "symbolOffset"),
          fromSymbolRotate: y.getItemVisual(n, "symbolRotate"),
          fromSymbolSize: y.getItemVisual(n, "symbolSize"),
          fromSymbol: y.getItemVisual(n, "symbol"),
          toSymbolKeepAspect: u.getItemVisual(n, "symbolKeepAspect"),
          toSymbolOffset: u.getItemVisual(n, "symbolOffset"),
          toSymbolRotate: u.getItemVisual(n, "symbolRotate"),
          toSymbolSize: u.getItemVisual(n, "symbolSize"),
          toSymbol: u.getItemVisual(n, "symbol"),
          style: b
        });
      }), m.updateData(v), c.line.eachItemGraphicEl(function(n) {
        W(n).dataModel = t, n.traverse(function(b) {
          W(b).dataModel = t;
        });
      });
      function G(n, b, S) {
        var I = n.getItemModel(b);
        E(n, b, S, r, i);
        var w = I.getModel("itemStyle").getItemStyle();
        w.fill == null && (w.fill = et(f, "color")), n.setItemVisual(b, {
          symbolKeepAspect: I.get("symbolKeepAspect"),
          // `0` should be considered as a valid value, so use `retrieve2` instead of `||`
          symbolOffset: A(I.get("symbolOffset", !0), L[S ? 0 : 1]),
          symbolRotate: A(I.get("symbolRotate", !0), k[S ? 0 : 1]),
          // TODO: when 2d array is supported, it should ignore parent
          symbolSize: A(I.get("symbolSize"), p[S ? 0 : 1]),
          symbol: A(I.get("symbol", !0), D[S ? 0 : 1]),
          style: w
        });
      }
      this.markKeep(m), m.group.silent = t.get("silent") || r.get("silent");
    }, a.type = "markLine", a;
  }(Y)
);
function nt(e, a, r) {
  var t;
  e ? t = V(e && e.dimensions, function(s) {
    var m = a.getData().getDimensionInfo(a.getData().mapDimension(s)) || {};
    return R(R({}, m), {
      name: s,
      // DON'T use ordinalMeta to parse and collect ordinal.
      ordinalMeta: null
    });
  }) : t = [{
    name: "value",
    type: "float"
  }];
  var g = new z(t, r), i = new z(t, r), l = new z([], r), o = V(r.get("data"), j(at, a, e, r));
  e && (o = C(o, j(rt, e)));
  var f = U(!!e, t);
  return g.initData(V(o, function(s) {
    return s[0];
  }), null, f), i.initData(V(o, function(s) {
    return s[1];
  }), null, f), l.initData(V(o, function(s) {
    return s[2];
  })), l.hasItemOption = !0, {
    from: g,
    to: i,
    line: l
  };
}
export {
  Dt as default
};
//# sourceMappingURL=MarkLineView.mjs.map
