import { __extends as V } from "../../../node_modules/tslib/tslib.es6.mjs";
import N from "../../../../zrender/lib/core/BoundingRect.mjs";
import { translate as D, rotate as H, create as U } from "../../../../zrender/lib/core/matrix.mjs";
import { applyTransform as W, createIcon as X } from "../../util/graphic.mjs";
import { createTextStyle as L } from "../../label/labelStyle.mjs";
import { getLayoutRect as Y } from "../../util/layout.mjs";
import Z from "./TimelineView.mjs";
import j from "./TimelineAxis.mjs";
import { createSymbol as q, normalizeSymbolSize as F, normalizeSymbolOffset as J } from "../../util/symbol.mjs";
import { asc as K } from "../../util/number.mjs";
import { each as B, isString as R, extend as Q, defaults as $, bind as b, retrieve2 as tt, merge as et } from "../../../../zrender/lib/core/util.mjs";
import rt from "../../scale/Ordinal.mjs";
import at from "../../scale/Time.mjs";
import it from "../../scale/Interval.mjs";
import { parsePercent as ot } from "../../../../zrender/lib/contain/text.mjs";
import { makeInner as nt } from "../../util/model.mjs";
import { getECData as lt } from "../../util/innerStore.mjs";
import { enableHoverEmphasis as A } from "../../util/states.mjs";
import { createTooltipMarkup as st } from "../tooltip/tooltipMarkup.mjs";
import ct from "../../../../zrender/lib/graphic/Group.mjs";
import M from "../../../../zrender/lib/graphic/shape/Line.mjs";
import vt from "../../../../zrender/lib/graphic/Text.mjs";
var z = Math.PI, E = nt(), Et = (
  /** @class */
  function(g) {
    V(n, g);
    function n() {
      var t = g !== null && g.apply(this, arguments) || this;
      return t.type = n.type, t;
    }
    return n.prototype.init = function(t, a) {
      this.api = a;
    }, n.prototype.render = function(t, a, e) {
      if (this.model = t, this.api = e, this.ecModel = a, this.group.removeAll(), t.get("show", !0)) {
        var r = this._layout(t, e), i = this._createGroup("_mainGroup"), o = this._createGroup("_labelGroup"), s = this._axis = this._createAxis(r, t);
        t.formatTooltip = function(l) {
          var c = s.scale.getLabel({
            value: l
          });
          return st("nameValue", {
            noName: !0,
            value: c
          });
        }, B(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(l) {
          this["_render" + l](r, i, s, t);
        }, this), this._renderAxisLabel(r, o, s, t), this._position(r, t);
      }
      this._doPlayStop(), this._updateTicksStatus();
    }, n.prototype.remove = function() {
      this._clearTimer(), this.group.removeAll();
    }, n.prototype.dispose = function() {
      this._clearTimer();
    }, n.prototype._layout = function(t, a) {
      var e = t.get(["label", "position"]), r = t.get("orient"), i = ut(t, a), o;
      e == null || e === "auto" ? o = r === "horizontal" ? i.y + i.height / 2 < a.getHeight() / 2 ? "-" : "+" : i.x + i.width / 2 < a.getWidth() / 2 ? "+" : "-" : R(e) ? o = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[r][e] : o = e;
      var s = {
        horizontal: "center",
        vertical: o >= 0 || o === "+" ? "left" : "right"
      }, l = {
        horizontal: o >= 0 || o === "+" ? "top" : "bottom",
        vertical: "middle"
      }, c = {
        horizontal: 0,
        vertical: z / 2
      }, v = r === "vertical" ? i.height : i.width, p = t.getModel("controlStyle"), d = p.get("show", !0), f = d ? p.get("itemSize") : 0, y = d ? p.get("itemGap") : 0, h = f + y, u = t.get(["label", "rotate"]) || 0;
      u = u * z / 180;
      var x, _, m, C = p.get("position", !0), k = d && p.get("showPlayBtn", !0), P = d && p.get("showPrevBtn", !0), T = d && p.get("showNextBtn", !0), w = 0, S = v;
      C === "left" || C === "bottom" ? (k && (x = [0, 0], w += h), P && (_ = [w, 0], w += h), T && (m = [S - f, 0], S -= h)) : (k && (x = [S - f, 0], S -= h), P && (_ = [0, 0], w += h), T && (m = [S - f, 0], S -= h));
      var I = [w, S];
      return t.get("inverse") && I.reverse(), {
        viewRect: i,
        mainLength: v,
        orient: r,
        rotation: c[r],
        labelRotation: u,
        labelPosOpt: o,
        labelAlign: t.get(["label", "align"]) || s[r],
        labelBaseline: t.get(["label", "verticalAlign"]) || t.get(["label", "baseline"]) || l[r],
        // Based on mainGroup.
        playPosition: x,
        prevBtnPosition: _,
        nextBtnPosition: m,
        axisExtent: I,
        controlSize: f,
        controlGap: y
      };
    }, n.prototype._position = function(t, a) {
      var e = this._mainGroup, r = this._labelGroup, i = t.viewRect;
      if (t.orient === "vertical") {
        var o = U(), s = i.x, l = i.y + i.height;
        D(o, o, [-s, -l]), H(o, o, -z / 2), D(o, o, [s, l]), i = i.clone(), i.applyTransform(o);
      }
      var c = x(i), v = x(e.getBoundingRect()), p = x(r.getBoundingRect()), d = [e.x, e.y], f = [r.x, r.y];
      f[0] = d[0] = c[0][0];
      var y = t.labelPosOpt;
      if (y == null || R(y)) {
        var h = y === "+" ? 0 : 1;
        _(d, v, c, 1, h), _(f, p, c, 1, 1 - h);
      } else {
        var h = y >= 0 ? 0 : 1;
        _(d, v, c, 1, h), f[1] = d[1] + y;
      }
      e.setPosition(d), r.setPosition(f), e.rotation = r.rotation = t.rotation, u(e), u(r);
      function u(m) {
        m.originX = c[0][0] - m.x, m.originY = c[1][0] - m.y;
      }
      function x(m) {
        return [[m.x, m.x + m.width], [m.y, m.y + m.height]];
      }
      function _(m, C, k, P, T) {
        m[P] += k[P][T] - C[P][T];
      }
    }, n.prototype._createAxis = function(t, a) {
      var e = a.getData(), r = a.get("axisType"), i = gt(a, r);
      i.getTicks = function() {
        return e.mapArray(["value"], function(l) {
          return {
            value: l
          };
        });
      };
      var o = e.getDataExtent("value");
      i.setExtent(o[0], o[1]), i.calcNiceTicks();
      var s = new j("value", i, t.axisExtent, r);
      return s.model = a, s;
    }, n.prototype._createGroup = function(t) {
      var a = this[t] = new ct();
      return this.group.add(a), a;
    }, n.prototype._renderAxisLine = function(t, a, e, r) {
      var i = e.getExtent();
      if (r.get(["lineStyle", "show"])) {
        var o = new M({
          shape: {
            x1: i[0],
            y1: 0,
            x2: i[1],
            y2: 0
          },
          style: Q({
            lineCap: "round"
          }, r.getModel("lineStyle").getLineStyle()),
          silent: !0,
          z2: 1
        });
        a.add(o);
        var s = this._progressLine = new M({
          shape: {
            x1: i[0],
            x2: this._currentPointer ? this._currentPointer.x : i[0],
            y1: 0,
            y2: 0
          },
          style: $({
            lineCap: "round",
            lineWidth: o.style.lineWidth
          }, r.getModel(["progress", "lineStyle"]).getLineStyle()),
          silent: !0,
          z2: 1
        });
        a.add(s);
      }
    }, n.prototype._renderAxisTick = function(t, a, e, r) {
      var i = this, o = r.getData(), s = e.scale.getTicks();
      this._tickSymbols = [], B(s, function(l) {
        var c = e.dataToCoord(l.value), v = o.getItemModel(l.value), p = v.getModel("itemStyle"), d = v.getModel(["emphasis", "itemStyle"]), f = v.getModel(["progress", "itemStyle"]), y = {
          x: c,
          y: 0,
          onclick: b(i._changeTimeline, i, l.value)
        }, h = G(v, p, a, y);
        h.ensureState("emphasis").style = d.getItemStyle(), h.ensureState("progress").style = f.getItemStyle(), A(h);
        var u = lt(h);
        v.get("tooltip") ? (u.dataIndex = l.value, u.dataModel = r) : u.dataIndex = u.dataModel = null, i._tickSymbols.push(h);
      });
    }, n.prototype._renderAxisLabel = function(t, a, e, r) {
      var i = this, o = e.getLabelModel();
      if (o.get("show")) {
        var s = r.getData(), l = e.getViewLabels();
        this._tickLabels = [], B(l, function(c) {
          var v = c.tickValue, p = s.getItemModel(v), d = p.getModel("label"), f = p.getModel(["emphasis", "label"]), y = p.getModel(["progress", "label"]), h = e.dataToCoord(c.tickValue), u = new vt({
            x: h,
            y: 0,
            rotation: t.labelRotation - t.rotation,
            onclick: b(i._changeTimeline, i, v),
            silent: !1,
            style: L(d, {
              text: c.formattedLabel,
              align: t.labelAlign,
              verticalAlign: t.labelBaseline
            })
          });
          u.ensureState("emphasis").style = L(f), u.ensureState("progress").style = L(y), a.add(u), A(u), E(u).dataIndex = v, i._tickLabels.push(u);
        });
      }
    }, n.prototype._renderControl = function(t, a, e, r) {
      var i = t.controlSize, o = t.rotation, s = r.getModel("controlStyle").getItemStyle(), l = r.getModel(["emphasis", "controlStyle"]).getItemStyle(), c = r.getPlayState(), v = r.get("inverse", !0);
      p(t.nextBtnPosition, "next", b(this._changeTimeline, this, v ? "-" : "+")), p(t.prevBtnPosition, "prev", b(this._changeTimeline, this, v ? "+" : "-")), p(t.playPosition, c ? "stop" : "play", b(this._handlePlayClick, this, !c), !0);
      function p(d, f, y, h) {
        if (d) {
          var u = ot(tt(r.get(["controlStyle", f + "BtnSize"]), i), i), x = [0, -u / 2, u, u], _ = ht(r, f + "Icon", x, {
            x: d[0],
            y: d[1],
            originX: i / 2,
            originY: 0,
            rotation: h ? -o : 0,
            rectHover: !0,
            style: s,
            onclick: y
          });
          _.ensureState("emphasis").style = l, a.add(_), A(_);
        }
      }
    }, n.prototype._renderCurrentPointer = function(t, a, e, r) {
      var i = r.getData(), o = r.getCurrentIndex(), s = i.getItemModel(o).getModel("checkpointStyle"), l = this, c = {
        onCreate: function(v) {
          v.draggable = !0, v.drift = b(l._handlePointerDrag, l), v.ondragend = b(l._handlePointerDragend, l), O(v, l._progressLine, o, e, r, !0);
        },
        onUpdate: function(v) {
          O(v, l._progressLine, o, e, r);
        }
      };
      this._currentPointer = G(s, s, this._mainGroup, {}, this._currentPointer, c);
    }, n.prototype._handlePlayClick = function(t) {
      this._clearTimer(), this.api.dispatchAction({
        type: "timelinePlayChange",
        playState: t,
        from: this.uid
      });
    }, n.prototype._handlePointerDrag = function(t, a, e) {
      this._clearTimer(), this._pointerChangeTimeline([e.offsetX, e.offsetY]);
    }, n.prototype._handlePointerDragend = function(t) {
      this._pointerChangeTimeline([t.offsetX, t.offsetY], !0);
    }, n.prototype._pointerChangeTimeline = function(t, a) {
      var e = this._toAxisCoord(t)[0], r = this._axis, i = K(r.getExtent().slice());
      e > i[1] && (e = i[1]), e < i[0] && (e = i[0]), this._currentPointer.x = e, this._currentPointer.markRedraw();
      var o = this._progressLine;
      o && (o.shape.x2 = e, o.dirty());
      var s = this._findNearestTick(e), l = this.model;
      (a || s !== l.getCurrentIndex() && l.get("realtime")) && this._changeTimeline(s);
    }, n.prototype._doPlayStop = function() {
      var t = this;
      this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
        var a = t.model;
        t._changeTimeline(a.getCurrentIndex() + (a.get("rewind", !0) ? -1 : 1));
      }, this.model.get("playInterval")));
    }, n.prototype._toAxisCoord = function(t) {
      var a = this._mainGroup.getLocalTransform();
      return W(t, a, !0);
    }, n.prototype._findNearestTick = function(t) {
      var a = this.model.getData(), e = 1 / 0, r, i = this._axis;
      return a.each(["value"], function(o, s) {
        var l = i.dataToCoord(o), c = Math.abs(l - t);
        c < e && (e = c, r = s);
      }), r;
    }, n.prototype._clearTimer = function() {
      this._timer && (clearTimeout(this._timer), this._timer = null);
    }, n.prototype._changeTimeline = function(t) {
      var a = this.model.getCurrentIndex();
      t === "+" ? t = a + 1 : t === "-" && (t = a - 1), this.api.dispatchAction({
        type: "timelineChange",
        currentIndex: t,
        from: this.uid
      });
    }, n.prototype._updateTicksStatus = function() {
      var t = this.model.getCurrentIndex(), a = this._tickSymbols, e = this._tickLabels;
      if (a)
        for (var r = 0; r < a.length; r++)
          a && a[r] && a[r].toggleState("progress", r < t);
      if (e)
        for (var r = 0; r < e.length; r++)
          e && e[r] && e[r].toggleState("progress", E(e[r]).dataIndex <= t);
    }, n.type = "timeline.slider", n;
  }(Z)
);
function gt(g, n) {
  if (n = n || g.get("type"), n)
    switch (n) {
      case "category":
        return new rt({
          ordinalMeta: g.getCategories(),
          extent: [1 / 0, -1 / 0]
        });
      case "time":
        return new at({
          locale: g.ecModel.getLocaleModel(),
          useUTC: g.ecModel.get("useUTC")
        });
      default:
        return new it();
    }
}
function ut(g, n) {
  return Y(g.getBoxLayoutParams(), {
    width: n.getWidth(),
    height: n.getHeight()
  }, g.get("padding"));
}
function ht(g, n, t, a) {
  var e = a.style, r = X(g.get(["controlStyle", n]), a || {}, new N(t[0], t[1], t[2], t[3]));
  return e && r.setStyle(e), r;
}
function G(g, n, t, a, e, r) {
  var i = n.get("color");
  if (e)
    e.setColor(i), t.add(e), r && r.onUpdate(e);
  else {
    var o = g.get("symbol");
    e = q(o, -1, -1, 2, 2, i), e.setStyle("strokeNoScale", !0), t.add(e), r && r.onCreate(e);
  }
  var s = n.getItemStyle(["color"]);
  e.setStyle(s), a = et({
    rectHover: !0,
    z2: 100
  }, a, !0);
  var l = F(g.get("symbolSize"));
  a.scaleX = l[0] / 2, a.scaleY = l[1] / 2;
  var c = J(g.get("symbolOffset"), l);
  c && (a.x = (a.x || 0) + c[0], a.y = (a.y || 0) + c[1]);
  var v = g.get("symbolRotate");
  return a.rotation = (v || 0) * Math.PI / 180 || 0, e.attr(a), e.updateTransform(), e;
}
function O(g, n, t, a, e, r) {
  if (!g.dragging) {
    var i = e.getModel("checkpointStyle"), o = a.dataToCoord(e.getData().get("value", t));
    if (r || !i.get("animation", !0))
      g.attr({
        x: o,
        y: 0
      }), n && n.attr({
        shape: {
          x2: o
        }
      });
    else {
      var s = {
        duration: i.get("animationDuration", !0),
        easing: i.get("animationEasing", !0)
      };
      g.stopAnimation(null, !0), g.animateTo({
        x: o,
        y: 0
      }, s), n && n.animateTo({
        shape: {
          x2: o
        }
      }, s);
    }
  }
}
export {
  Et as default
};
//# sourceMappingURL=SliderTimelineView.mjs.map
