import { isString as m, isDom as C, isFunction as O, isArray as N, each as _, bind as R, indexOf as D } from "../../../../zrender/lib/core/util.mjs";
import { normalizeEvent as z } from "../../../../zrender/lib/core/event.mjs";
import { transformLocalCoord as L } from "../../../../zrender/lib/core/dom.mjs";
import u from "../../../../zrender/lib/core/env.mjs";
import { convertToColorString as x, toCamelCase as k, normalizeCssArray as F } from "../../util/format.mjs";
import { toCSSVendorPrefix as S, TRANSITION_VENDOR as W, TRANSFORM_VENDOR as H, getComputedStyle as A, shouldTooltipConfine as E } from "./helper.mjs";
import { getPaddingFromTooltipModel as I } from "./tooltipMarkup.mjs";
var V = S(W, "transition"), w = S(H, "transform"), B = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (u.transform3dSupported ? "will-change:transform;" : "");
function X(e) {
  return e = e === "left" ? "right" : e === "right" ? "left" : e === "top" ? "bottom" : "top", e;
}
function Y(e, t, a) {
  if (!m(a) || a === "inside")
    return "";
  var r = e.get("backgroundColor"), i = e.get("borderWidth");
  t = x(t);
  var o = X(a), s = Math.max(Math.round(i) * 1.5, 6), n = "", h = w + ":", l;
  D(["left", "right"], o) > -1 ? (n += "top:50%", h += "translateY(-50%) rotate(" + (l = o === "left" ? -225 : -45) + "deg)") : (n += "left:50%", h += "translateX(-50%) rotate(" + (l = o === "top" ? 225 : 45) + "deg)");
  var f = l * Math.PI / 180, d = s + i, v = d * Math.abs(Math.cos(f)) + d * Math.abs(Math.sin(f)), g = Math.round(((v - Math.SQRT2 * i) / 2 + Math.SQRT2 * i - (v - d) / 2) * 100) / 100;
  n += ";" + o + ":-" + g + "px";
  var p = t + " solid " + i + "px;", c = ["position:absolute;width:" + s + "px;height:" + s + "px;z-index:-1;", n + ";" + h + ";", "border-bottom:" + p, "border-right:" + p, "background-color:" + r + ";"];
  return '<div style="' + c.join("") + '"></div>';
}
function j(e, t) {
  var a = "cubic-bezier(0.23,1,0.32,1)", r = " " + e / 2 + "s " + a, i = "opacity" + r + ",visibility" + r;
  return t || (r = " " + e + "s " + a, i += u.transformSupported ? "," + w + r : ",left" + r + ",top" + r), V + ":" + i;
}
function y(e, t, a) {
  var r = e.toFixed(0) + "px", i = t.toFixed(0) + "px";
  if (!u.transformSupported)
    return a ? "top:" + i + ";left:" + r + ";" : [["top", i], ["left", r]];
  var o = u.transform3dSupported, s = "translate" + (o ? "3d" : "") + "(" + r + "," + i + (o ? ",0" : "") + ")";
  return a ? "top:0;left:0;" + w + ":" + s + ";" : [["top", 0], ["left", 0], [H, s]];
}
function M(e) {
  var t = [], a = e.get("fontSize"), r = e.getTextColor();
  r && t.push("color:" + r), t.push("font:" + e.getFont()), a && t.push("line-height:" + Math.round(a * 3 / 2) + "px");
  var i = e.get("textShadowColor"), o = e.get("textShadowBlur") || 0, s = e.get("textShadowOffsetX") || 0, n = e.get("textShadowOffsetY") || 0;
  return i && o && t.push("text-shadow:" + s + "px " + n + "px " + o + "px " + i), _(["decoration", "align"], function(h) {
    var l = e.get(h);
    l && t.push("text-" + h + ":" + l);
  }), t.join(";");
}
function P(e, t, a) {
  var r = [], i = e.get("transitionDuration"), o = e.get("backgroundColor"), s = e.get("shadowBlur"), n = e.get("shadowColor"), h = e.get("shadowOffsetX"), l = e.get("shadowOffsetY"), f = e.getModel("textStyle"), d = I(e, "html"), v = h + "px " + l + "px " + s + "px " + n;
  return r.push("box-shadow:" + v), t && i && r.push(j(i, a)), o && r.push("background-color:" + o), _(["width", "color", "radius"], function(g) {
    var p = "border-" + g, c = k(p), T = e.get(c);
    T != null && r.push(p + ":" + T + (g === "color" ? "" : "px"));
  }), r.push(M(f)), d != null && r.push("padding:" + F(d).join("px ") + "px"), r.join(";") + ";";
}
function b(e, t, a, r, i) {
  var o = t && t.painter;
  if (a) {
    var s = o && o.getViewportRoot();
    s && L(e, s, a, r, i);
  } else {
    e[0] = r, e[1] = i;
    var n = o && o.getViewportRootOffset();
    n && (e[0] += n.offsetLeft, e[1] += n.offsetTop);
  }
  e[2] = e[0] / t.getWidth(), e[3] = e[1] / t.getHeight();
}
var $ = (
  /** @class */
  function() {
    function e(t, a) {
      if (this._show = !1, this._styleCoord = [0, 0, 0, 0], this._enterable = !0, this._alwaysShowContent = !1, this._firstShow = !0, this._longHide = !0, u.wxa)
        return null;
      var r = document.createElement("div");
      r.domBelongToZr = !0, this.el = r;
      var i = this._zr = t.getZr(), o = a.appendTo, s = o && (m(o) ? document.querySelector(o) : C(o) ? o : O(o) && o(t.getDom()));
      b(this._styleCoord, i, s, t.getWidth() / 2, t.getHeight() / 2), (s || t.getDom()).appendChild(r), this._api = t, this._container = s;
      var n = this;
      r.onmouseenter = function() {
        n._enterable && (clearTimeout(n._hideTimeout), n._show = !0), n._inContent = !0;
      }, r.onmousemove = function(h) {
        if (h = h || window.event, !n._enterable) {
          var l = i.handler, f = i.painter.getViewportRoot();
          z(f, h, !0), l.dispatch("mousemove", h);
        }
      }, r.onmouseleave = function() {
        n._inContent = !1, n._enterable && n._show && n.hideLater(n._hideDelay);
      };
    }
    return e.prototype.update = function(t) {
      if (!this._container) {
        var a = this._api.getDom(), r = A(a, "position"), i = a.style;
        i.position !== "absolute" && r !== "absolute" && (i.position = "relative");
      }
      var o = t.get("alwaysShowContent");
      o && this._moveIfResized(), this._alwaysShowContent = o, this.el.className = t.get("className") || "";
    }, e.prototype.show = function(t, a) {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var r = this.el, i = r.style, o = this._styleCoord;
      r.innerHTML ? i.cssText = B + P(t, !this._firstShow, this._longHide) + y(o[0], o[1], !0) + ("border-color:" + x(a) + ";") + (t.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : i.display = "none", this._show = !0, this._firstShow = !1, this._longHide = !1;
    }, e.prototype.setContent = function(t, a, r, i, o) {
      var s = this.el;
      if (t == null) {
        s.innerHTML = "";
        return;
      }
      var n = "";
      if (m(o) && r.get("trigger") === "item" && !E(r) && (n = Y(r, i, o)), m(t))
        s.innerHTML = t + n;
      else if (t) {
        s.innerHTML = "", N(t) || (t = [t]);
        for (var h = 0; h < t.length; h++)
          C(t[h]) && t[h].parentNode !== s && s.appendChild(t[h]);
        if (n && s.childNodes.length) {
          var l = document.createElement("div");
          l.innerHTML = n, s.appendChild(l);
        }
      }
    }, e.prototype.setEnterable = function(t) {
      this._enterable = t;
    }, e.prototype.getSize = function() {
      var t = this.el;
      return [t.offsetWidth, t.offsetHeight];
    }, e.prototype.moveTo = function(t, a) {
      var r = this._styleCoord;
      if (b(r, this._zr, this._container, t, a), r[0] != null && r[1] != null) {
        var i = this.el.style, o = y(r[0], r[1]);
        _(o, function(s) {
          i[s[0]] = s[1];
        });
      }
    }, e.prototype._moveIfResized = function() {
      var t = this._styleCoord[2], a = this._styleCoord[3];
      this.moveTo(t * this._zr.getWidth(), a * this._zr.getHeight());
    }, e.prototype.hide = function() {
      var t = this, a = this.el.style;
      a.visibility = "hidden", a.opacity = "0", u.transform3dSupported && (a.willChange = ""), this._show = !1, this._longHideTimeout = setTimeout(function() {
        return t._longHide = !0;
      }, 500);
    }, e.prototype.hideLater = function(t) {
      this._show && !(this._inContent && this._enterable) && !this._alwaysShowContent && (t ? (this._hideDelay = t, this._show = !1, this._hideTimeout = setTimeout(R(this.hide, this), t)) : this.hide());
    }, e.prototype.isShow = function() {
      return this._show;
    }, e.prototype.dispose = function() {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var t = this.el.parentNode;
      t && t.removeChild(this.el), this.el = this._container = null;
    }, e;
  }()
);
export {
  $ as default
};
//# sourceMappingURL=TooltipHTMLContent.mjs.map
