import { map as h, each as T } from "../../../zrender/lib/core/util.mjs";
import { getPixelPrecision as M, linearMap as p, round as d } from "../util/number.mjs";
import { createAxisTicks as E, createAxisLabels as b, calculateCategoryInterval as B } from "./axisTickLabelBuilder.mjs";
var v = [0, 1], z = (
  /** @class */
  function() {
    function r(t, n, e) {
      this.onBand = !1, this.inverse = !1, this.dim = t, this.scale = n, this._extent = e || [0, 0];
    }
    return r.prototype.contain = function(t) {
      var n = this._extent, e = Math.min(n[0], n[1]), i = Math.max(n[0], n[1]);
      return t >= e && t <= i;
    }, r.prototype.containData = function(t) {
      return this.scale.contain(t);
    }, r.prototype.getExtent = function() {
      return this._extent.slice();
    }, r.prototype.getPixelPrecision = function(t) {
      return M(t || this.scale.getExtent(), this._extent);
    }, r.prototype.setExtent = function(t, n) {
      var e = this._extent;
      e[0] = t, e[1] = n;
    }, r.prototype.dataToCoord = function(t, n) {
      var e = this._extent, i = this.scale;
      return t = i.normalize(t), this.onBand && i.type === "ordinal" && (e = e.slice(), x(e, i.count())), p(t, v, e, n);
    }, r.prototype.coordToData = function(t, n) {
      var e = this._extent, i = this.scale;
      this.onBand && i.type === "ordinal" && (e = e.slice(), x(e, i.count()));
      var o = p(t, e, v, n);
      return this.scale.scale(o);
    }, r.prototype.pointToData = function(t, n) {
    }, r.prototype.getTicksCoords = function(t) {
      t = t || {};
      var n = t.tickModel || this.getTickModel(), e = E(this, n), i = e.ticks, o = h(i, function(c) {
        return {
          coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(c) : c),
          tickValue: c
        };
      }, this), a = n.get("alignWithLabel");
      return L(this, o, a, t.clamp), o;
    }, r.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var t = this.model.getModel("minorTick"), n = t.get("splitNumber");
      n > 0 && n < 100 || (n = 5);
      var e = this.scale.getMinorTicks(n), i = h(e, function(o) {
        return h(o, function(a) {
          return {
            coord: this.dataToCoord(a),
            tickValue: a
          };
        }, this);
      }, this);
      return i;
    }, r.prototype.getViewLabels = function() {
      return b(this).labels;
    }, r.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, r.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, r.prototype.getBandWidth = function() {
      var t = this._extent, n = this.scale.getExtent(), e = n[1] - n[0] + (this.onBand ? 1 : 0);
      e === 0 && (e = 1);
      var i = Math.abs(t[1] - t[0]);
      return Math.abs(i) / e;
    }, r.prototype.calculateCategoryInterval = function() {
      return B(this);
    }, r;
  }()
);
function x(r, t) {
  var n = r[1] - r[0], e = t, i = n / e / 2;
  r[0] += i, r[1] -= i;
}
function L(r, t, n, e) {
  var i = t.length;
  if (!r.onBand || n || !i)
    return;
  var o = r.getExtent(), a, c;
  if (i === 1)
    t[0].coord = o[0], a = t[1] = {
      coord: o[1]
    };
  else {
    var g = t[i - 1].tickValue - t[0].tickValue, f = (t[i - 1].coord - t[0].coord) / g;
    T(t, function(l) {
      l.coord -= f / 2;
    });
    var m = r.scale.getExtent();
    c = 1 + m[1] - t[i - 1].tickValue, a = {
      coord: t[i - 1].coord + f * c
    }, t.push(a);
  }
  var y = o[0] > o[1];
  s(t[0].coord, o[0]) && (e ? t[0].coord = o[0] : t.shift()), e && s(o[0], t[0].coord) && t.unshift({
    coord: o[0]
  }), s(o[1], a.coord) && (e ? a.coord = o[1] : t.pop()), e && s(a.coord, o[1]) && t.push({
    coord: o[1]
  });
  function s(l, u) {
    return l = d(l), u = d(u), y ? l > u : l < u;
  }
}
export {
  z as default
};
//# sourceMappingURL=Axis.mjs.map
