import { each as m, keys as b, isString as h, isFunction as p } from "../../../zrender/lib/core/util.mjs";
import M from "../scale/Ordinal.mjs";
import y from "../scale/Interval.mjs";
import w from "../scale/Scale.mjs";
import { prepareLayoutBarSeries as L, makeColumnLayout as d, retrieveColumnLayout as I } from "../layout/barGrid.mjs";
import E from "../../../zrender/lib/core/BoundingRect.mjs";
import S from "../scale/Time.mjs";
import O from "../scale/Log.mjs";
import { getStackedDimension as C } from "../data/helper/dataStackHelper.mjs";
import { ensureScaleRawExtentInfo as F } from "./scaleRawExtentInfo.mjs";
function k(e, t) {
  var n = e.type, r = F(e, t, e.getExtent()).calculate();
  e.setBlank(r.isBlank);
  var a = r.min, i = r.max, u = t.ecModel;
  if (u && n === "time") {
    var o = L("bar", u), l = !1;
    if (m(o, function(g) {
      l = l || g.getBaseAxis() === t.axis;
    }), l) {
      var v = d(o), f = R(a, i, t, v);
      a = f.min, i = f.max;
    }
  }
  return {
    extent: [a, i],
    // "fix" means "fixed", the value should not be
    // changed in the subsequent steps.
    fixMin: r.minFixed,
    fixMax: r.maxFixed
  };
}
function R(e, t, n, r) {
  var a = n.axis.getExtent(), i = a[1] - a[0], u = I(r, n.axis);
  if (u === void 0)
    return {
      min: e,
      max: t
    };
  var o = 1 / 0;
  m(u, function(c) {
    o = Math.min(c.offset, o);
  });
  var l = -1 / 0;
  m(u, function(c) {
    l = Math.max(c.offset + c.width, l);
  }), o = Math.abs(o), l = Math.abs(l);
  var v = o + l, f = t - e, g = 1 - (o + l) / i, s = f / g - f;
  return t += s * (l / v), e -= s * (o / v), {
    min: e,
    max: t
  };
}
function J(e, t) {
  var n = t, r = k(e, n), a = r.extent, i = n.get("splitNumber");
  e instanceof O && (e.base = n.get("logBase"));
  var u = e.type, o = n.get("interval"), l = u === "interval" || u === "time";
  e.setExtent(a[0], a[1]), e.calcNiceExtent({
    splitNumber: i,
    fixMin: r.fixMin,
    fixMax: r.fixMax,
    minInterval: l ? n.get("minInterval") : null,
    maxInterval: l ? n.get("maxInterval") : null
  }), o != null && e.setInterval && e.setInterval(o);
}
function K(e, t) {
  if (t = t || e.get("type"), t)
    switch (t) {
      case "category":
        return new M({
          ordinalMeta: e.getOrdinalMeta ? e.getOrdinalMeta() : e.getCategories(),
          extent: [1 / 0, -1 / 0]
        });
      case "time":
        return new S({
          locale: e.ecModel.getLocaleModel(),
          useUTC: e.ecModel.get("useUTC")
        });
      default:
        return new (w.getClass(t) || y)();
    }
}
function Q(e) {
  var t = e.scale.getExtent(), n = t[0], r = t[1];
  return !(n > 0 && r > 0 || n < 0 && r < 0);
}
function T(e) {
  var t = e.getLabelModel().get("formatter"), n = e.type === "category" ? e.scale.getExtent()[0] : null;
  return e.scale.type === "time" ? /* @__PURE__ */ function(r) {
    return function(a, i) {
      return e.scale.getFormattedLabel(a, i, r);
    };
  }(t) : h(t) ? /* @__PURE__ */ function(r) {
    return function(a) {
      var i = e.scale.getLabel(a), u = r.replace("{value}", i ?? "");
      return u;
    };
  }(t) : p(t) ? /* @__PURE__ */ function(r) {
    return function(a, i) {
      return n != null && (i = a.value - n), r(D(e, a), i, a.level != null ? {
        level: a.level
      } : null);
    };
  }(t) : function(r) {
    return e.scale.getLabel(r);
  };
}
function D(e, t) {
  return e.type === "category" ? e.scale.getLabel(t) : t.value;
}
function X(e) {
  var t = e.model, n = e.scale;
  if (!(!t.get(["axisLabel", "show"]) || n.isBlank())) {
    var r, a, i = n.getExtent();
    n instanceof M ? a = n.count() : (r = n.getTicks(), a = r.length);
    var u = e.getLabelModel(), o = T(e), l, v = 1;
    a > 40 && (v = Math.ceil(a / 40));
    for (var f = 0; f < a; f += v) {
      var g = r ? r[f] : {
        value: i[0] + f
      }, s = o(g, f), c = u.getTextRect(s), x = N(c, u.get("rotate") || 0);
      l ? l.union(x) : l = x;
    }
    return l;
  }
}
function N(e, t) {
  var n = t * Math.PI / 180, r = e.width, a = e.height, i = r * Math.abs(Math.cos(n)) + Math.abs(a * Math.sin(n)), u = r * Math.abs(Math.sin(n)) + Math.abs(a * Math.cos(n)), o = new E(e.x, e.y, i, u);
  return o;
}
function A(e) {
  var t = e.get("interval");
  return t ?? "auto";
}
function Y(e) {
  return e.type === "category" && A(e.getLabelModel()) === 0;
}
function B(e, t) {
  var n = {};
  return m(e.mapDimensionsAll(t), function(r) {
    n[C(e, r)] = !0;
  }), b(n);
}
function $(e, t, n) {
  t && m(B(t, n), function(r) {
    var a = t.getApproximateExtent(r);
    a[0] < e[0] && (e[0] = a[0]), a[1] > e[1] && (e[1] = a[1]);
  });
}
export {
  K as createScaleByModel,
  X as estimateLabelUnionRect,
  D as getAxisRawValue,
  B as getDataDimensionsOnAxis,
  A as getOptionCategoryInterval,
  k as getScaleExtent,
  Q as ifAxisCrossZero,
  T as makeLabelFormatter,
  J as niceScaleExtent,
  Y as shouldShowAllLabels,
  $ as unionAxisExtentFromData
};
//# sourceMappingURL=axisHelper.mjs.map
