import { map as I, isFunction as A, each as z } from "../../../zrender/lib/core/util.mjs";
import { getBoundingRect as O } from "../../../zrender/lib/contain/text.mjs";
import { makeInner as P } from "../util/model.mjs";
import { makeLabelFormatter as d, getOptionCategoryInterval as E, shouldShowAllLabels as W } from "./axisHelper.mjs";
var L = P();
function V(t, a) {
  var e = I(a, function(r) {
    return t.scale.parse(r);
  });
  return t.type === "time" && e.length > 0 && (e.sort(), e.unshift(e[0]), e.push(e[e.length - 1])), e;
}
function Y(t) {
  var a = t.getLabelModel().get("customValues");
  if (a) {
    var e = d(t);
    return {
      labels: V(t, a).map(function(r) {
        var o = {
          value: r
        };
        return {
          formattedLabel: e(o),
          rawLabel: t.scale.getLabel(o),
          tickValue: r
        };
      })
    };
  }
  return t.type === "category" ? j(t) : q(t);
}
function Z(t, a) {
  var e = t.getTickModel().get("customValues");
  return e ? {
    ticks: V(t, e)
  } : t.type === "category" ? G(t, a) : {
    ticks: I(t.scale.getTicks(), function(r) {
      return r.value;
    })
  };
}
function j(t) {
  var a = t.getLabelModel(), e = F(t, a);
  return !a.get("show") || t.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: e.labelCategoryInterval
  } : e;
}
function F(t, a) {
  var e = N(t, "labels"), r = E(a), o = R(e, r);
  if (o)
    return o;
  var l, n;
  return A(r) ? l = H(t, r) : (n = r === "auto" ? D(t) : r, l = B(t, n)), S(e, r, {
    labels: l,
    labelCategoryInterval: n
  });
}
function G(t, a) {
  var e = N(t, "ticks"), r = E(a), o = R(e, r);
  if (o)
    return o;
  var l, n;
  if ((!a.get("show") || t.scale.isBlank()) && (l = []), A(r))
    l = H(t, r, !0);
  else if (r === "auto") {
    var v = F(t, t.getLabelModel());
    n = v.labelCategoryInterval, l = I(v.labels, function(u) {
      return u.tickValue;
    });
  } else
    n = r, l = B(t, n, !0);
  return S(e, r, {
    ticks: l,
    tickCategoryInterval: n
  });
}
function q(t) {
  var a = t.scale.getTicks(), e = d(t);
  return {
    labels: I(a, function(r, o) {
      return {
        level: r.level,
        formattedLabel: e(r, o),
        rawLabel: t.scale.getLabel(r),
        tickValue: r.value
      };
    })
  };
}
function N(t, a) {
  return L(t)[a] || (L(t)[a] = []);
}
function R(t, a) {
  for (var e = 0; e < t.length; e++)
    if (t[e].key === a)
      return t[e].value;
}
function S(t, a, e) {
  return t.push({
    key: a,
    value: e
  }), e;
}
function D(t) {
  var a = L(t).autoInterval;
  return a ?? (L(t).autoInterval = t.calculateCategoryInterval());
}
function _(t) {
  var a = J(t), e = d(t), r = (a.axisRotate - a.labelRotate) / 180 * Math.PI, o = t.scale, l = o.getExtent(), n = o.count();
  if (l[1] - l[0] < 1)
    return 0;
  var v = 1;
  n > 40 && (v = Math.max(1, Math.floor(n / 40)));
  for (var u = l[0], c = t.dataToCoord(u + 1) - t.dataToCoord(u), p = Math.abs(c * Math.cos(r)), C = Math.abs(c * Math.sin(r)), m = 0, h = 0; u <= l[1]; u += v) {
    var s = 0, b = 0, f = O(e({
      value: u
    }), a.font, "center", "top");
    s = f.width * 1.3, b = f.height * 1.3, m = Math.max(m, s, 7), h = Math.max(h, b, 7);
  }
  var g = m / p, T = h / C;
  isNaN(g) && (g = 1 / 0), isNaN(T) && (T = 1 / 0);
  var k = Math.max(0, Math.floor(Math.min(g, T))), i = L(t.model), M = t.getExtent(), y = i.lastAutoInterval, w = i.lastTickCount;
  return y != null && w != null && Math.abs(y - k) <= 1 && Math.abs(w - n) <= 1 && y > k && i.axisExtent0 === M[0] && i.axisExtent1 === M[1] ? k = y : (i.lastTickCount = n, i.lastAutoInterval = k, i.axisExtent0 = M[0], i.axisExtent1 = M[1]), k;
}
function J(t) {
  var a = t.getLabelModel();
  return {
    axisRotate: t.getRotate ? t.getRotate() : t.isHorizontal && !t.isHorizontal() ? 90 : 0,
    labelRotate: a.get("rotate") || 0,
    font: a.getFont()
  };
}
function B(t, a, e) {
  var r = d(t), o = t.scale, l = o.getExtent(), n = t.getLabelModel(), v = [], u = Math.max((a || 0) + 1, 1), c = l[0], p = o.count();
  c !== 0 && u > 1 && p / u > 2 && (c = Math.round(Math.ceil(c / u) * u));
  var C = W(t), m = n.get("showMinLabel") || C, h = n.get("showMaxLabel") || C;
  m && c !== l[0] && b(l[0]);
  for (var s = c; s <= l[1]; s += u)
    b(s);
  h && s - u !== l[1] && b(l[1]);
  function b(f) {
    var g = {
      value: f
    };
    v.push(e ? f : {
      formattedLabel: r(g),
      rawLabel: o.getLabel(g),
      tickValue: f
    });
  }
  return v;
}
function H(t, a, e) {
  var r = t.scale, o = d(t), l = [];
  return z(r.getTicks(), function(n) {
    var v = r.getLabel(n), u = n.value;
    a(n.value, v) && l.push(e ? u : {
      formattedLabel: o(n),
      rawLabel: v,
      tickValue: u
    });
  }), l;
}
export {
  _ as calculateCategoryInterval,
  Y as createAxisLabels,
  Z as createAxisTicks
};
//# sourceMappingURL=axisTickLabelBuilder.mjs.map
