import { extend as E, each as d, map as H, mergeAll as l, retrieve as W, createHashMap as U } from "../../../../zrender/lib/core/util.mjs";
import L, { geo2DDimensions as Z } from "./Geo.mjs";
import { getLayoutRect as k } from "../../util/layout.mjs";
import { parsePercent as z } from "../../util/number.mjs";
import q from "./geoSourceManager.mjs";
import { min as J, max as K } from "../../../../zrender/lib/core/vector.mjs";
function j(v, u) {
  var g = v.get("boundingCoords");
  if (g != null) {
    var t = g[0], i = g[1];
    if (!(isFinite(t[0]) && isFinite(t[1]) && isFinite(i[0]) && isFinite(i[1])))
      process.env.NODE_ENV !== "production" && console.error("Invalid boundingCoords");
    else {
      var c = this.projection;
      if (c) {
        var e = t[0], r = t[1], a = i[0], n = i[1];
        t = [1 / 0, 1 / 0], i = [-1 / 0, -1 / 0];
        var o = function(R, F, A, O) {
          for (var V = A - R, b = O - F, C = 0; C <= 100; C++) {
            var P = C / 100, D = c.project([R + V * P, F + b * P]);
            J(t, t, D), K(i, i, D);
          }
        };
        o(e, r, a, r), o(a, r, a, n), o(a, n, e, n), o(e, n, a, r);
      }
      this.setBoundingRect(t[0], t[1], i[0] - t[0], i[1] - t[1]);
    }
  }
  var N = this.getBoundingRect(), p = v.get("layoutCenter"), G = v.get("layoutSize"), y = u.getWidth(), w = u.getHeight(), m = N.width / N.height * this.aspectScale, S = !1, f, h;
  p && G && (f = [z(p[0], y), z(p[1], w)], h = z(G, Math.min(y, w)), !isNaN(f[0]) && !isNaN(f[1]) && !isNaN(h) ? S = !0 : process.env.NODE_ENV !== "production" && console.warn("Given layoutCenter or layoutSize data are invalid. Use left/top/width/height instead."));
  var s;
  if (S)
    s = {}, m > 1 ? (s.width = h, s.height = h / m) : (s.height = h, s.width = h * m), s.y = f[1] - s.height / 2, s.x = f[0] - s.width / 2;
  else {
    var I = v.getBoxLayoutParams();
    I.aspect = m, s = k(I, {
      width: y,
      height: w
    });
  }
  this.setViewRect(s.x, s.y, s.width, s.height), this.setCenter(v.get("center"), u), this.setZoom(v.get("zoom"));
}
function Q(v, u) {
  d(u.get("geoCoord"), function(g, t) {
    v.addGeoCoord(t, g);
  });
}
var X = (
  /** @class */
  function() {
    function v() {
      this.dimensions = Z;
    }
    return v.prototype.create = function(u, g) {
      var t = [];
      function i(e) {
        return {
          nameProperty: e.get("nameProperty"),
          aspectScale: e.get("aspectScale"),
          projection: e.get("projection")
        };
      }
      u.eachComponent("geo", function(e, r) {
        var a = e.get("map"), n = new L(a + r, a, E({
          nameMap: e.get("nameMap")
        }, i(e)));
        n.zoomLimit = e.get("scaleLimit"), t.push(n), e.coordinateSystem = n, n.model = e, n.resize = j, n.resize(e, g);
      }), u.eachSeries(function(e) {
        var r = e.get("coordinateSystem");
        if (r === "geo") {
          var a = e.get("geoIndex") || 0;
          e.coordinateSystem = t[a];
        }
      });
      var c = {};
      return u.eachSeriesByType("map", function(e) {
        if (!e.getHostGeoModel()) {
          var r = e.getMapType();
          c[r] = c[r] || [], c[r].push(e);
        }
      }), d(c, function(e, r) {
        var a = H(e, function(o) {
          return o.get("nameMap");
        }), n = new L(r, r, E({
          nameMap: l(a)
        }, i(e[0])));
        n.zoomLimit = W.apply(null, H(e, function(o) {
          return o.get("scaleLimit");
        })), t.push(n), n.resize = j, n.resize(e[0], g), d(e, function(o) {
          o.coordinateSystem = n, Q(n, o);
        });
      }), t;
    }, v.prototype.getFilledRegions = function(u, g, t, i) {
      for (var c = (u || []).slice(), e = U(), r = 0; r < c.length; r++)
        e.set(c[r].name, c[r]);
      var a = q.load(g, t, i);
      return d(a.regions, function(n) {
        var o = n.name;
        !e.get(o) && c.push({
          name: o
        });
      }), c;
    }, v;
  }()
), M = new X();
export {
  M as default
};
//# sourceMappingURL=geoCreator.mjs.map
