import { createHashMap as u } from "../../../../zrender/lib/core/util.mjs";
import { GeoSVGResource as c } from "./GeoSVGResource.mjs";
import { GeoJSONResource as i } from "./GeoJSONResource.mjs";
var t = u();
const f = {
  /**
   * Compatible with previous `echarts.registerMap`.
   *
   * @usage
   * ```js
   *
   * echarts.registerMap('USA', geoJson, specialAreas);
   *
   * echarts.registerMap('USA', {
   *     geoJson: geoJson,
   *     specialAreas: {...}
   * });
   * echarts.registerMap('USA', {
   *     geoJSON: geoJson,
   *     specialAreas: {...}
   * });
   *
   * echarts.registerMap('airport', {
   *     svg: svg
   * }
   * ```
   *
   * Note:
   * Do not support that register multiple geoJSON or SVG
   * one map name. Because different geoJSON and SVG have
   * different unit. It's not easy to make sure how those
   * units are mapping/normalize.
   * If intending to use multiple geoJSON or SVG, we can
   * use multiple geo coordinate system.
   */
  registerMap: function(o, e, s) {
    if (e.svg) {
      var r = new c(o, e.svg);
      t.set(o, r);
    } else {
      var n = e.geoJson || e.geoJSON;
      n && !e.features ? s = e.specialAreas : n = e;
      var r = new i(o, n, s);
      t.set(o, r);
    }
  },
  getGeoResource: function(o) {
    return t.get(o);
  },
  /**
   * Only for exporting to users.
   * **MUST NOT** used internally.
   */
  getMapForUser: function(o) {
    var e = t.get(o);
    return e && e.type === "geoJSON" && e.getMapForUser();
  },
  load: function(o, e, s) {
    var r = t.get(o);
    if (!r) {
      process.env.NODE_ENV !== "production" && console.error("Map " + o + " not exists. The GeoJSON of the map must be provided.");
      return;
    }
    return r.load(e, s);
  }
};
export {
  f as default
};
//# sourceMappingURL=geoSourceManager.mjs.map
