import { __extends as Se } from "../../node_modules/tslib/tslib.es6.mjs";
import { init as Me, registerSSRDataGetter as Ct } from "../../../zrender/lib/zrender.mjs";
import { isDom as yt, retrieve2 as Y, bind as Le, clone as xe, setAsPrimitive as Rt, isObject as W, each as y, extend as k, assert as ee, createHashMap as ne, map as wt, defaults as Ot, indexOf as Qe, noop as q, isString as At, isFunction as et } from "../../../zrender/lib/core/util.mjs";
import z from "../../../zrender/lib/core/env.mjs";
import ae from "../../../zrender/lib/core/timsort.mjs";
import Re from "../../../zrender/lib/core/Eventful.mjs";
import Pt from "../model/Global.mjs";
import Dt from "./ExtensionAPI.mjs";
import tt from "./CoordinateSystem.mjs";
import Vt from "../model/OptionManager.mjs";
import rt from "../preprocessor/backwardCompat.mjs";
import It from "../processor/dataStack.mjs";
import Ne from "../model/Series.mjs";
import Mt from "../view/Component.mjs";
import se from "../view/Chart.mjs";
import { getECData as $ } from "../util/innerStore.mjs";
import { isSelectChangePayload as Ue, isHighDownPayload as ke, allLeaveBlur as Lt, getAllSelectedIndices as xt, updateSeriesElementSelection as ze, HOVER_STATE_EMPHASIS as Nt, HOVER_STATE_BLUR as Ut, savePathStates as kt, enterEmphasis as be, leaveEmphasis as Fe, enterBlur as zt, leaveBlur as bt, enterSelect as Ft, leaveSelect as Ht, HIGHLIGHT_ACTION_TYPE as F, DOWNPLAY_ACTION_TYPE as oe, SELECT_ACTION_TYPE as ue, UNSELECT_ACTION_TYPE as fe, TOGGLE_SELECT_ACTION_TYPE as de, blurSeriesFromHighlightPayload as Yt, findComponentHighDownDispatchers as Bt, blurComponent as Gt, toggleSelectionFromPayload as Wt, isHighDownDispatcher as He, handleGlobalMouseOverForHighDown as Xt, handleGlobalMouseOutForHighDown as Zt } from "../util/states.mjs";
import { setAttribute as it, getAttribute as qt, parseFinder as pe, preParseFinder as Kt, convertOptionIdName as $t, normalizeToArray as jt } from "../util/model.mjs";
import { throttle as Jt } from "../util/throttle.mjs";
import { seriesStyleTask as Qt, dataStyleTask as er, dataColorPaletteTask as tr } from "../visual/style.mjs";
import rr from "../loading/default.mjs";
import nt from "./Scheduler.mjs";
import ir from "../theme/light.mjs";
import nr from "../theme/dark.mjs";
import { parseClassType as Ye } from "../util/clazz.mjs";
import { ECEventProcessor as ar } from "../util/ECEventProcessor.mjs";
import { seriesSymbolTask as sr, dataSymbolTask as or } from "../visual/symbol.mjs";
import { getItemVisualFromData as ur, getVisualFromData as fr } from "../visual/helper.mjs";
import { deprecateLog as at, warn as N, error as Be, deprecateReplaceLog as dr } from "../util/log.mjs";
import { handleLegacySelectEvents as pr } from "../legacy/dataSelectAction.mjs";
import { registerExternalTransform as lr } from "../data/helper/transform.mjs";
import { createLocaleObject as cr, SYSTEM_LANG as hr } from "./locale.mjs";
import { registerLocale as ki } from "./locale.mjs";
import { findEventDispatcher as j } from "../util/event.mjs";
import vr from "../visual/decal.mjs";
import M from "./lifecycle.mjs";
import { platformApi as _r } from "../../../zrender/lib/core/platform.mjs";
import { getImpl as gr } from "./impl.mjs";
import mr from "../../../zrender/lib/graphic/shape/Rect.mjs";
import Tr from "../../../zrender/lib/graphic/Image.mjs";
import Sr from "../../../zrender/lib/graphic/Path.mjs";
import { isElementRemoved as le } from "../animation/basicTransition.mjs";
var Er = 1, Cr = 800, yr = 900, Rr = 1e3, wr = 2e3, Or = 5e3, st = 1e3, Ar = 1100, we = 2e3, ot = 3e3, Pr = 4e3, ie = 4500, Dr = 4600, Vr = 5e3, Ir = 6e3, ut = 7e3, Ai = {
  PROCESSOR: {
    FILTER: Rr,
    SERIES_FILTER: Cr,
    STATISTIC: Or
  },
  VISUAL: {
    LAYOUT: st,
    PROGRESSIVE_LAYOUT: Ar,
    GLOBAL: we,
    CHART: ot,
    POST_CHART_LAYOUT: Dr,
    COMPONENT: Pr,
    BRUSH: Vr,
    CHART_ITEM: ie,
    ARIA: Ir,
    DECAL: ut
  }
}, w = "__flagInMainProcess", O = "__pendingUpdate", ce = "__needsUpdateStatus", Ge = /^[a-zA-Z0-9_]+$/, he = "__connectUpdateStatus", We = 0, Mr = 1, Lr = 2;
function ft(c) {
  return function() {
    for (var u = [], r = 0; r < arguments.length; r++)
      u[r] = arguments[r];
    if (this.isDisposed()) {
      P(this.id);
      return;
    }
    return pt(this, c, u);
  };
}
function dt(c) {
  return function() {
    for (var u = [], r = 0; r < arguments.length; r++)
      u[r] = arguments[r];
    return pt(this, c, u);
  };
}
function pt(c, u, r) {
  return r[0] = r[0] && r[0].toLowerCase(), Re.prototype[u].apply(c, r);
}
var lt = (
  /** @class */
  function(c) {
    Se(u, c);
    function u() {
      return c !== null && c.apply(this, arguments) || this;
    }
    return u;
  }(Re)
), ct = lt.prototype;
ct.on = dt("on");
ct.off = dt("off");
var b, ve, J, U, _e, ge, me, B, G, Xe, Ze, Te, qe, Q, Ke, ht, V, $e, vt = (
  /** @class */
  function(c) {
    Se(u, c);
    function u(r, a, l) {
      var o = c.call(this, new ar()) || this;
      o._chartsViews = [], o._chartsMap = {}, o._componentsViews = [], o._componentsMap = {}, o._pendingActions = [], l = l || {}, At(a) && (a = _t[a]), o._dom = r;
      var m = "canvas", E = "auto", g = !1;
      if (process.env.NODE_ENV !== "production") {
        var C = (
          /* eslint-disable-next-line */
          z.hasGlobalWindow ? window : global
        );
        C && (m = Y(C.__ECHARTS__DEFAULT__RENDERER__, m), E = Y(C.__ECHARTS__DEFAULT__COARSE_POINTER, E), g = Y(C.__ECHARTS__DEFAULT__USE_DIRTY_RECT__, g));
      }
      l.ssr && Ct(function(t) {
        var n = $(t), s = n.dataIndex;
        if (s != null) {
          var d = ne();
          return d.set("series_index", n.seriesIndex), d.set("data_index", s), n.ssrType && d.set("ssr_type", n.ssrType), d;
        }
      });
      var T = o._zr = Me(r, {
        renderer: l.renderer || m,
        devicePixelRatio: l.devicePixelRatio,
        width: l.width,
        height: l.height,
        ssr: l.ssr,
        useDirtyRect: Y(l.useDirtyRect, g),
        useCoarsePointer: Y(l.useCoarsePointer, E),
        pointerSize: l.pointerSize
      });
      o._ssr = l.ssr, o._throttledZrFlush = Jt(Le(T.flush, T), 17), a = xe(a), a && rt(a, !0), o._theme = a, o._locale = cr(l.locale || hr), o._coordSysMgr = new tt();
      var e = o._api = Ke(o);
      function i(t, n) {
        return t.__prio - n.__prio;
      }
      return ae(re, i), ae(Ee, i), o._scheduler = new nt(o, e, Ee, re), o._messageCenter = new lt(), o._initEvents(), o.resize = Le(o.resize, o), T.animation.on("frame", o._onframe, o), Xe(T, o), Ze(T, o), Rt(o), o;
    }
    return u.prototype._onframe = function() {
      if (!this._disposed) {
        $e(this);
        var r = this._scheduler;
        if (this[O]) {
          var a = this[O].silent;
          this[w] = !0;
          try {
            b(this), U.update.call(this, null, this[O].updateParams);
          } catch (g) {
            throw this[w] = !1, this[O] = null, g;
          }
          this._zr.flush(), this[w] = !1, this[O] = null, B.call(this, a), G.call(this, a);
        } else if (r.unfinished) {
          var l = Er, o = this._model, m = this._api;
          r.unfinished = !1;
          do {
            var E = +/* @__PURE__ */ new Date();
            r.performSeriesTasks(o), r.performDataProcessorTasks(o), ge(this, o), r.performVisualTasks(o), Q(this, this._model, m, "remain", {}), l -= +/* @__PURE__ */ new Date() - E;
          } while (l > 0 && r.unfinished);
          r.unfinished || this._zr.flush();
        }
      }
    }, u.prototype.getDom = function() {
      return this._dom;
    }, u.prototype.getId = function() {
      return this.id;
    }, u.prototype.getZr = function() {
      return this._zr;
    }, u.prototype.isSSR = function() {
      return this._ssr;
    }, u.prototype.setOption = function(r, a, l) {
      if (this[w]) {
        process.env.NODE_ENV !== "production" && Be("`setOption` should not be called during main process.");
        return;
      }
      if (this._disposed) {
        P(this.id);
        return;
      }
      var o, m, E;
      if (W(a) && (l = a.lazyUpdate, o = a.silent, m = a.replaceMerge, E = a.transition, a = a.notMerge), this[w] = !0, !this._model || a) {
        var g = new Vt(this._api), C = this._theme, T = this._model = new Pt();
        T.scheduler = this._scheduler, T.ssr = this._ssr, T.init(null, null, null, C, this._locale, g);
      }
      this._model.setOption(r, {
        replaceMerge: m
      }, Ce);
      var e = {
        seriesTransition: E,
        optionChanged: !0
      };
      if (l)
        this[O] = {
          silent: o,
          updateParams: e
        }, this[w] = !1, this.getZr().wakeUp();
      else {
        try {
          b(this), U.update.call(this, null, e);
        } catch (i) {
          throw this[O] = null, this[w] = !1, i;
        }
        this._ssr || this._zr.flush(), this[O] = null, this[w] = !1, B.call(this, o), G.call(this, o);
      }
    }, u.prototype.setTheme = function() {
      at("ECharts#setTheme() is DEPRECATED in ECharts 3.0");
    }, u.prototype.getModel = function() {
      return this._model;
    }, u.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, u.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, u.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, u.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || z.hasGlobalWindow && window.devicePixelRatio || 1;
    }, u.prototype.getRenderedCanvas = function(r) {
      return process.env.NODE_ENV !== "production" && dr("getRenderedCanvas", "renderToCanvas"), this.renderToCanvas(r);
    }, u.prototype.renderToCanvas = function(r) {
      r = r || {};
      var a = this._zr.painter;
      if (process.env.NODE_ENV !== "production" && a.type !== "canvas")
        throw new Error("renderToCanvas can only be used in the canvas renderer.");
      return a.getRenderedCanvas({
        backgroundColor: r.backgroundColor || this._model.get("backgroundColor"),
        pixelRatio: r.pixelRatio || this.getDevicePixelRatio()
      });
    }, u.prototype.renderToSVGString = function(r) {
      r = r || {};
      var a = this._zr.painter;
      if (process.env.NODE_ENV !== "production" && a.type !== "svg")
        throw new Error("renderToSVGString can only be used in the svg renderer.");
      return a.renderToString({
        useViewBox: r.useViewBox
      });
    }, u.prototype.getSvgDataURL = function() {
      if (z.svgSupported) {
        var r = this._zr, a = r.storage.getDisplayList();
        return y(a, function(l) {
          l.stopAnimation(null, !0);
        }), r.painter.toDataURL();
      }
    }, u.prototype.getDataURL = function(r) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      r = r || {};
      var a = r.excludeComponents, l = this._model, o = [], m = this;
      y(a, function(g) {
        l.eachComponent({
          mainType: g
        }, function(C) {
          var T = m._componentsMap[C.__viewId];
          T.group.ignore || (o.push(T), T.group.ignore = !0);
        });
      });
      var E = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(r).toDataURL("image/" + (r && r.type || "png"));
      return y(o, function(g) {
        g.group.ignore = !1;
      }), E;
    }, u.prototype.getConnectedDataURL = function(r) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      var a = r.type === "svg", l = this.group, o = Math.min, m = Math.max, E = 1 / 0;
      if (je[l]) {
        var g = E, C = E, T = -E, e = -E, i = [], t = r && r.pixelRatio || this.getDevicePixelRatio();
        y(Z, function(p, v) {
          if (p.group === l) {
            var S = a ? p.getZr().painter.getSvgDom().innerHTML : p.renderToCanvas(xe(r)), _ = p.getDom().getBoundingClientRect();
            g = o(_.left, g), C = o(_.top, C), T = m(_.right, T), e = m(_.bottom, e), i.push({
              dom: S,
              left: _.left,
              top: _.top
            });
          }
        }), g *= t, C *= t, T *= t, e *= t;
        var n = T - g, s = e - C, d = _r.createCanvas(), f = Me(d, {
          renderer: a ? "svg" : "canvas"
        });
        if (f.resize({
          width: n,
          height: s
        }), a) {
          var h = "";
          return y(i, function(p) {
            var v = p.left - g, S = p.top - C;
            h += '<g transform="translate(' + v + "," + S + ')">' + p.dom + "</g>";
          }), f.painter.getSvgRoot().innerHTML = h, r.connectedBackgroundColor && f.painter.setBackgroundColor(r.connectedBackgroundColor), f.refreshImmediately(), f.painter.toDataURL();
        } else
          return r.connectedBackgroundColor && f.add(new mr({
            shape: {
              x: 0,
              y: 0,
              width: n,
              height: s
            },
            style: {
              fill: r.connectedBackgroundColor
            }
          })), y(i, function(p) {
            var v = new Tr({
              style: {
                x: p.left * t - g,
                y: p.top * t - C,
                image: p.dom
              }
            });
            f.add(v);
          }), f.refreshImmediately(), d.toDataURL("image/" + (r && r.type || "png"));
      } else
        return this.getDataURL(r);
    }, u.prototype.convertToPixel = function(r, a) {
      return _e(this, "convertToPixel", r, a);
    }, u.prototype.convertFromPixel = function(r, a) {
      return _e(this, "convertFromPixel", r, a);
    }, u.prototype.containPixel = function(r, a) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      var l = this._model, o, m = pe(l, r);
      return y(m, function(E, g) {
        g.indexOf("Models") >= 0 && y(E, function(C) {
          var T = C.coordinateSystem;
          if (T && T.containPoint)
            o = o || !!T.containPoint(a);
          else if (g === "seriesModels") {
            var e = this._chartsMap[C.__viewId];
            e && e.containPoint ? o = o || e.containPoint(a, C) : process.env.NODE_ENV !== "production" && N(g + ": " + (e ? "The found component do not support containPoint." : "No view mapping to the found component."));
          } else
            process.env.NODE_ENV !== "production" && N(g + ": containPoint is not supported");
        }, this);
      }, this), !!o;
    }, u.prototype.getVisual = function(r, a) {
      var l = this._model, o = pe(l, r, {
        defaultMainType: "series"
      }), m = o.seriesModel;
      process.env.NODE_ENV !== "production" && (m || N("There is no specified series model"));
      var E = m.getData(), g = o.hasOwnProperty("dataIndexInside") ? o.dataIndexInside : o.hasOwnProperty("dataIndex") ? E.indexOfRawIndex(o.dataIndex) : null;
      return g != null ? ur(E, g, a) : fr(E, a);
    }, u.prototype.getViewOfComponentModel = function(r) {
      return this._componentsMap[r.__viewId];
    }, u.prototype.getViewOfSeriesModel = function(r) {
      return this._chartsMap[r.__viewId];
    }, u.prototype._initEvents = function() {
      var r = this;
      y(xr, function(a) {
        var l = function(o) {
          var m = r.getModel(), E = o.target, g, C = a === "globalout";
          if (C ? g = {} : E && j(E, function(n) {
            var s = $(n);
            if (s && s.dataIndex != null) {
              var d = s.dataModel || m.getSeriesByIndex(s.seriesIndex);
              return g = d && d.getDataParams(s.dataIndex, s.dataType, E) || {}, !0;
            } else if (s.eventData)
              return g = k({}, s.eventData), !0;
          }, !0), g) {
            var T = g.componentType, e = g.componentIndex;
            (T === "markLine" || T === "markPoint" || T === "markArea") && (T = "series", e = g.seriesIndex);
            var i = T && e != null && m.getComponent(T, e), t = i && r[i.mainType === "series" ? "_chartsMap" : "_componentsMap"][i.__viewId];
            process.env.NODE_ENV !== "production" && !C && !(i && t) && N("model or view can not be found by params"), g.event = o, g.type = a, r._$eventProcessor.eventInfo = {
              targetEl: E,
              packedEvent: g,
              model: i,
              view: t
            }, r.trigger(a, g);
          }
        };
        l.zrEventfulCallAtLast = !0, r._zr.on(a, l, r);
      }), y(X, function(a, l) {
        r._messageCenter.on(l, function(o) {
          this.trigger(l, o);
        }, r);
      }), y(["selectchanged"], function(a) {
        r._messageCenter.on(a, function(l) {
          this.trigger(a, l);
        }, r);
      }), pr(this._messageCenter, this, this._api);
    }, u.prototype.isDisposed = function() {
      return this._disposed;
    }, u.prototype.clear = function() {
      if (this._disposed) {
        P(this.id);
        return;
      }
      this.setOption({
        series: []
      }, !0);
    }, u.prototype.dispose = function() {
      if (this._disposed) {
        P(this.id);
        return;
      }
      this._disposed = !0;
      var r = this.getDom();
      r && it(this.getDom(), Ae, "");
      var a = this, l = a._api, o = a._model;
      y(a._componentsViews, function(m) {
        m.dispose(o, l);
      }), y(a._chartsViews, function(m) {
        m.dispose(o, l);
      }), a._zr.dispose(), a._dom = a._model = a._chartsMap = a._componentsMap = a._chartsViews = a._componentsViews = a._scheduler = a._api = a._zr = a._throttledZrFlush = a._theme = a._coordSysMgr = a._messageCenter = null, delete Z[a.id];
    }, u.prototype.resize = function(r) {
      if (this[w]) {
        process.env.NODE_ENV !== "production" && Be("`resize` should not be called during main process.");
        return;
      }
      if (this._disposed) {
        P(this.id);
        return;
      }
      this._zr.resize(r);
      var a = this._model;
      if (this._loadingFX && this._loadingFX.resize(), !!a) {
        var l = a.resetOption("media"), o = r && r.silent;
        this[O] && (o == null && (o = this[O].silent), l = !0, this[O] = null), this[w] = !0;
        try {
          l && b(this), U.update.call(this, {
            type: "resize",
            animation: k({
              // Disable animation
              duration: 0
            }, r && r.animation)
          });
        } catch (m) {
          throw this[w] = !1, m;
        }
        this[w] = !1, B.call(this, o), G.call(this, o);
      }
    }, u.prototype.showLoading = function(r, a) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      if (W(r) && (a = r, r = ""), r = r || "default", this.hideLoading(), !ye[r]) {
        process.env.NODE_ENV !== "production" && N("Loading effects " + r + " not exists.");
        return;
      }
      var l = ye[r](this._api, a), o = this._zr;
      this._loadingFX = l, o.add(l);
    }, u.prototype.hideLoading = function() {
      if (this._disposed) {
        P(this.id);
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, u.prototype.makeActionFromEvent = function(r) {
      var a = k({}, r);
      return a.type = X[r.type], a;
    }, u.prototype.dispatchAction = function(r, a) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      if (W(a) || (a = {
        silent: !!a
      }), !!te[r.type] && this._model) {
        if (this[w]) {
          this._pendingActions.push(r);
          return;
        }
        var l = a.silent;
        me.call(this, r, l);
        var o = a.flush;
        o ? this._zr.flush() : o !== !1 && z.browser.weChat && this._throttledZrFlush(), B.call(this, l), G.call(this, l);
      }
    }, u.prototype.updateLabelLayout = function() {
      M.trigger("series:layoutlabels", this._model, this._api, {
        // Not adding series labels.
        // TODO
        updatedSeries: []
      });
    }, u.prototype.appendData = function(r) {
      if (this._disposed) {
        P(this.id);
        return;
      }
      var a = r.seriesIndex, l = this.getModel(), o = l.getSeriesByIndex(a);
      process.env.NODE_ENV !== "production" && ee(r.data && o), o.appendData(r), this._scheduler.unfinished = !0, this.getZr().wakeUp();
    }, u.internalField = function() {
      b = function(e) {
        var i = e._scheduler;
        i.restorePipelines(e._model), i.prepareStageTasks(), ve(e, !0), ve(e, !1), i.plan();
      }, ve = function(e, i) {
        for (var t = e._model, n = e._scheduler, s = i ? e._componentsViews : e._chartsViews, d = i ? e._componentsMap : e._chartsMap, f = e._zr, h = e._api, p = 0; p < s.length; p++)
          s[p].__alive = !1;
        i ? t.eachComponent(function(_, A) {
          _ !== "series" && v(A);
        }) : t.eachSeries(v);
        function v(_) {
          var A = _.__requireNewView;
          _.__requireNewView = !1;
          var L = "_ec_" + _.id + "_" + _.type, R = !A && d[L];
          if (!R) {
            var I = Ye(_.type), x = i ? Mt.getClass(I.main, I.sub) : (
              // FIXME:TS
              // (ChartView as ChartViewConstructor).getClass('series', classType.sub)
              // For backward compat, still support a chart type declared as only subType
              // like "liquidfill", but recommend "series.liquidfill"
              // But need a base class to make a type series.
              se.getClass(I.sub)
            );
            process.env.NODE_ENV !== "production" && ee(x, I.sub + " does not exist."), R = new x(), R.init(t, h), d[L] = R, s.push(R), f.add(R.group);
          }
          _.__viewId = R.__id = L, R.__alive = !0, R.__model = _, R.group.__ecComponentInfo = {
            mainType: _.mainType,
            index: _.componentIndex
          }, !i && n.prepareView(R, _, t, h);
        }
        for (var p = 0; p < s.length; ) {
          var S = s[p];
          S.__alive ? p++ : (!i && S.renderTask.dispose(), f.remove(S.group), S.dispose(t, h), s.splice(p, 1), d[S.__id] === S && delete d[S.__id], S.__id = S.group.__ecComponentInfo = null);
        }
      }, J = function(e, i, t, n, s) {
        var d = e._model;
        if (d.setUpdatePayload(t), !n) {
          y([].concat(e._componentsViews).concat(e._chartsViews), S);
          return;
        }
        var f = {};
        f[n + "Id"] = t[n + "Id"], f[n + "Index"] = t[n + "Index"], f[n + "Name"] = t[n + "Name"];
        var h = {
          mainType: n,
          query: f
        };
        s && (h.subType = s);
        var p = t.excludeSeriesId, v;
        p != null && (v = ne(), y(jt(p), function(_) {
          var A = $t(_, null);
          A != null && v.set(A, !0);
        })), d && d.eachComponent(h, function(_) {
          var A = v && v.get(_.id) != null;
          if (!A)
            if (ke(t))
              if (_ instanceof Ne)
                t.type === F && !t.notBlur && !_.get(["emphasis", "disabled"]) && Yt(_, t, e._api);
              else {
                var L = Bt(_.mainType, _.componentIndex, t.name, e._api), R = L.focusSelf, I = L.dispatchers;
                t.type === F && R && !t.notBlur && Gt(_.mainType, _.componentIndex, e._api), I && y(I, function(x) {
                  t.type === F ? be(x) : Fe(x);
                });
              }
            else
              Ue(t) && _ instanceof Ne && (Wt(_, t, e._api), ze(_), V(e));
        }, e), d && d.eachComponent(h, function(_) {
          var A = v && v.get(_.id) != null;
          A || S(e[n === "series" ? "_chartsMap" : "_componentsMap"][_.__viewId]);
        }, e);
        function S(_) {
          _ && _.__alive && _[i] && _[i](_.__model, d, e._api, t);
        }
      }, U = {
        prepareAndUpdate: function(e) {
          b(this), U.update.call(this, e, {
            // Needs to mark option changed if newOption is given.
            // It's from MagicType.
            // TODO If use a separate flag optionChanged in payload?
            optionChanged: e.newOption != null
          });
        },
        update: function(e, i) {
          var t = this._model, n = this._api, s = this._zr, d = this._coordSysMgr, f = this._scheduler;
          if (t) {
            t.setUpdatePayload(e), f.restoreData(t, e), f.performSeriesTasks(t), d.create(t, n), f.performDataProcessorTasks(t, e), ge(this, t), d.update(t, n), r(t), f.performVisualTasks(t, e), Te(this, t, n, e, i);
            var h = t.get("backgroundColor") || "transparent", p = t.get("darkMode");
            s.setBackgroundColor(h), p != null && p !== "auto" && s.setDarkMode(p), M.trigger("afterupdate", t, n);
          }
        },
        updateTransform: function(e) {
          var i = this, t = this._model, n = this._api;
          if (t) {
            t.setUpdatePayload(e);
            var s = [];
            t.eachComponent(function(f, h) {
              if (f !== "series") {
                var p = i.getViewOfComponentModel(h);
                if (p && p.__alive)
                  if (p.updateTransform) {
                    var v = p.updateTransform(h, t, n, e);
                    v && v.update && s.push(p);
                  } else
                    s.push(p);
              }
            });
            var d = ne();
            t.eachSeries(function(f) {
              var h = i._chartsMap[f.__viewId];
              if (h.updateTransform) {
                var p = h.updateTransform(f, t, n, e);
                p && p.update && d.set(f.uid, 1);
              } else
                d.set(f.uid, 1);
            }), r(t), this._scheduler.performVisualTasks(t, e, {
              setDirty: !0,
              dirtyMap: d
            }), Q(this, t, n, e, {}, d), M.trigger("afterupdate", t, n);
          }
        },
        updateView: function(e) {
          var i = this._model;
          i && (i.setUpdatePayload(e), se.markUpdateMethod(e, "updateView"), r(i), this._scheduler.performVisualTasks(i, e, {
            setDirty: !0
          }), Te(this, i, this._api, e, {}), M.trigger("afterupdate", i, this._api));
        },
        updateVisual: function(e) {
          var i = this, t = this._model;
          t && (t.setUpdatePayload(e), t.eachSeries(function(n) {
            n.getData().clearAllVisual();
          }), se.markUpdateMethod(e, "updateVisual"), r(t), this._scheduler.performVisualTasks(t, e, {
            visualType: "visual",
            setDirty: !0
          }), t.eachComponent(function(n, s) {
            if (n !== "series") {
              var d = i.getViewOfComponentModel(s);
              d && d.__alive && d.updateVisual(s, t, i._api, e);
            }
          }), t.eachSeries(function(n) {
            var s = i._chartsMap[n.__viewId];
            s.updateVisual(n, t, i._api, e);
          }), M.trigger("afterupdate", t, this._api));
        },
        updateLayout: function(e) {
          U.update.call(this, e);
        }
      }, _e = function(e, i, t, n) {
        if (e._disposed) {
          P(e.id);
          return;
        }
        for (var s = e._model, d = e._coordSysMgr.getCoordinateSystems(), f, h = pe(s, t), p = 0; p < d.length; p++) {
          var v = d[p];
          if (v[i] && (f = v[i](s, h, n)) != null)
            return f;
        }
        process.env.NODE_ENV !== "production" && N("No coordinate system that supports " + i + " found by the given finder.");
      }, ge = function(e, i) {
        var t = e._chartsMap, n = e._scheduler;
        i.eachSeries(function(s) {
          n.updateStreamModes(s, t[s.__viewId]);
        });
      }, me = function(e, i) {
        var t = this, n = this.getModel(), s = e.type, d = e.escapeConnect, f = te[s], h = f.actionInfo, p = (h.update || "update").split(":"), v = p.pop(), S = p[0] != null && Ye(p[0]);
        this[w] = !0;
        var _ = [e], A = !1;
        e.batch && (A = !0, _ = wt(e.batch, function(D) {
          return D = Ot(k({}, D), e), D.batch = null, D;
        }));
        var L = [], R, I = Ue(e), x = ke(e);
        if (x && Lt(this._api), y(_, function(D) {
          if (R = f.action(D, t._model, t._api), R = R || k({}, D), R.type = h.event || R.type, L.push(R), x) {
            var Ie = Kt(e), Tt = Ie.queryOptionMap, St = Ie.mainTypeSpecified, Et = St ? Tt.keys()[0] : "series";
            J(t, v, D, Et), V(t);
          } else
            I ? (J(t, v, D, "series"), V(t)) : S && J(t, v, D, S.main, S.sub);
        }), v !== "none" && !x && !I && !S)
          try {
            this[O] ? (b(this), U.update.call(this, e), this[O] = null) : U[v].call(this, e);
          } catch (D) {
            throw this[w] = !1, D;
          }
        if (A ? R = {
          type: h.event || s,
          escapeConnect: d,
          batch: L
        } : R = L[0], this[w] = !1, !i) {
          var De = this._messageCenter;
          if (De.trigger(R.type, R), I) {
            var Ve = {
              type: "selectchanged",
              escapeConnect: d,
              selected: xt(n),
              isFromClick: e.isFromClick || !1,
              fromAction: e.type,
              fromActionPayload: e
            };
            De.trigger(Ve.type, Ve);
          }
        }
      }, B = function(e) {
        for (var i = this._pendingActions; i.length; ) {
          var t = i.shift();
          me.call(this, t, e);
        }
      }, G = function(e) {
        !e && this.trigger("updated");
      }, Xe = function(e, i) {
        e.on("rendered", function(t) {
          i.trigger("rendered", t), // Although zr is dirty if initial animation is not finished
          // and this checking is called on frame, we also check
          // animation finished for robustness.
          e.animation.isFinished() && !i[O] && !i._scheduler.unfinished && !i._pendingActions.length && i.trigger("finished");
        });
      }, Ze = function(e, i) {
        e.on("mouseover", function(t) {
          var n = t.target, s = j(n, He);
          s && (Xt(s, t, i._api), V(i));
        }).on("mouseout", function(t) {
          var n = t.target, s = j(n, He);
          s && (Zt(s, t, i._api), V(i));
        }).on("click", function(t) {
          var n = t.target, s = j(n, function(h) {
            return $(h).dataIndex != null;
          }, !0);
          if (s) {
            var d = s.selected ? "unselect" : "select", f = $(s);
            i._api.dispatchAction({
              type: d,
              dataType: f.dataType,
              dataIndexInside: f.dataIndex,
              seriesIndex: f.seriesIndex,
              isFromClick: !0
            });
          }
        });
      };
      function r(e) {
        e.clearColorPalette(), e.eachSeries(function(i) {
          i.clearColorPalette();
        });
      }
      function a(e) {
        var i = [], t = [], n = !1;
        if (e.eachComponent(function(h, p) {
          var v = p.get("zlevel") || 0, S = p.get("z") || 0, _ = p.getZLevelKey();
          n = n || !!_, (h === "series" ? t : i).push({
            zlevel: v,
            z: S,
            idx: p.componentIndex,
            type: h,
            key: _
          });
        }), n) {
          var s = i.concat(t), d, f;
          ae(s, function(h, p) {
            return h.zlevel === p.zlevel ? h.z - p.z : h.zlevel - p.zlevel;
          }), y(s, function(h) {
            var p = e.getComponent(h.type, h.idx), v = h.zlevel, S = h.key;
            d != null && (v = Math.max(d, v)), S ? (v === d && S !== f && v++, f = S) : f && (v === d && v++, f = ""), d = v, p.setZLevel(v);
          });
        }
      }
      Te = function(e, i, t, n, s) {
        a(i), qe(e, i, t, n, s), y(e._chartsViews, function(d) {
          d.__alive = !1;
        }), Q(e, i, t, n, s), y(e._chartsViews, function(d) {
          d.__alive || d.remove(i, t);
        });
      }, qe = function(e, i, t, n, s, d) {
        y(d || e._componentsViews, function(f) {
          var h = f.__model;
          C(h, f), f.render(h, i, t, n), E(h, f), T(h, f);
        });
      }, Q = function(e, i, t, n, s, d) {
        var f = e._scheduler;
        s = k(s || {}, {
          updatedSeries: i.getSeries()
        }), M.trigger("series:beforeupdate", i, t, s);
        var h = !1;
        i.eachSeries(function(p) {
          var v = e._chartsMap[p.__viewId];
          v.__alive = !0;
          var S = v.renderTask;
          f.updatePayload(S, n), C(p, v), d && d.get(p.uid) && S.dirty(), S.perform(f.getPerformArgs(S)) && (h = !0), v.group.silent = !!p.get("silent"), m(p, v), ze(p);
        }), f.unfinished = h || f.unfinished, M.trigger("series:layoutlabels", i, t, s), M.trigger("series:transition", i, t, s), i.eachSeries(function(p) {
          var v = e._chartsMap[p.__viewId];
          E(p, v), T(p, v);
        }), o(e, i), M.trigger("series:afterupdate", i, t, s);
      }, V = function(e) {
        e[ce] = !0, e.getZr().wakeUp();
      }, $e = function(e) {
        e[ce] && (e.getZr().storage.traverse(function(i) {
          le(i) || l(i);
        }), e[ce] = !1);
      };
      function l(e) {
        for (var i = [], t = e.currentStates, n = 0; n < t.length; n++) {
          var s = t[n];
          s === "emphasis" || s === "blur" || s === "select" || i.push(s);
        }
        e.selected && e.states.select && i.push("select"), e.hoverState === Nt && e.states.emphasis ? i.push("emphasis") : e.hoverState === Ut && e.states.blur && i.push("blur"), e.useStates(i);
      }
      function o(e, i) {
        var t = e._zr, n = t.storage, s = 0;
        n.traverse(function(d) {
          d.isGroup || s++;
        }), s > i.get("hoverLayerThreshold") && !z.node && !z.worker && i.eachSeries(function(d) {
          if (!d.preventUsingHoverLayer) {
            var f = e._chartsMap[d.__viewId];
            f.__alive && f.eachRendered(function(h) {
              h.states.emphasis && (h.states.emphasis.hoverLayer = !0);
            });
          }
        });
      }
      function m(e, i) {
        var t = e.get("blendMode") || null;
        i.eachRendered(function(n) {
          n.isGroup || (n.style.blend = t);
        });
      }
      function E(e, i) {
        if (!e.preventAutoZ) {
          var t = e.get("z") || 0, n = e.get("zlevel") || 0;
          i.eachRendered(function(s) {
            return g(s, t, n, -1 / 0), !0;
          });
        }
      }
      function g(e, i, t, n) {
        var s = e.getTextContent(), d = e.getTextGuideLine(), f = e.isGroup;
        if (f)
          for (var h = e.childrenRef(), p = 0; p < h.length; p++)
            n = Math.max(g(h[p], i, t, n), n);
        else
          e.z = i, e.zlevel = t, n = Math.max(e.z2, n);
        if (s && (s.z = i, s.zlevel = t, isFinite(n) && (s.z2 = n + 2)), d) {
          var v = e.textGuideLineConfig;
          d.z = i, d.zlevel = t, isFinite(n) && (d.z2 = n + (v && v.showAbove ? 1 : -1));
        }
        return n;
      }
      function C(e, i) {
        i.eachRendered(function(t) {
          if (!le(t)) {
            var n = t.getTextContent(), s = t.getTextGuideLine();
            t.stateTransition && (t.stateTransition = null), n && n.stateTransition && (n.stateTransition = null), s && s.stateTransition && (s.stateTransition = null), t.hasState() ? (t.prevStates = t.currentStates, t.clearStates()) : t.prevStates && (t.prevStates = null);
          }
        });
      }
      function T(e, i) {
        var t = e.getModel("stateAnimation"), n = e.isAnimationEnabled(), s = t.get("duration"), d = s > 0 ? {
          duration: s,
          delay: t.get("delay"),
          easing: t.get("easing")
          // additive: stateAnimationModel.get('additive')
        } : null;
        i.eachRendered(function(f) {
          if (f.states && f.states.emphasis) {
            if (le(f))
              return;
            if (f instanceof Sr && kt(f), f.__dirty) {
              var h = f.prevStates;
              h && f.useStates(h);
            }
            if (n) {
              f.stateTransition = d;
              var p = f.getTextContent(), v = f.getTextGuideLine();
              p && (p.stateTransition = d), v && (v.stateTransition = d);
            }
            f.__dirty && l(f);
          }
        });
      }
      Ke = function(e) {
        return new /** @class */
        (function(i) {
          Se(t, i);
          function t() {
            return i !== null && i.apply(this, arguments) || this;
          }
          return t.prototype.getCoordinateSystems = function() {
            return e._coordSysMgr.getCoordinateSystems();
          }, t.prototype.getComponentByElement = function(n) {
            for (; n; ) {
              var s = n.__ecComponentInfo;
              if (s != null)
                return e._model.getComponent(s.mainType, s.index);
              n = n.parent;
            }
          }, t.prototype.enterEmphasis = function(n, s) {
            be(n, s), V(e);
          }, t.prototype.leaveEmphasis = function(n, s) {
            Fe(n, s), V(e);
          }, t.prototype.enterBlur = function(n) {
            zt(n), V(e);
          }, t.prototype.leaveBlur = function(n) {
            bt(n), V(e);
          }, t.prototype.enterSelect = function(n) {
            Ft(n), V(e);
          }, t.prototype.leaveSelect = function(n) {
            Ht(n), V(e);
          }, t.prototype.getModel = function() {
            return e.getModel();
          }, t.prototype.getViewOfComponentModel = function(n) {
            return e.getViewOfComponentModel(n);
          }, t.prototype.getViewOfSeriesModel = function(n) {
            return e.getViewOfSeriesModel(n);
          }, t;
        }(Dt))(e);
      }, ht = function(e) {
        function i(t, n) {
          for (var s = 0; s < t.length; s++) {
            var d = t[s];
            d[he] = n;
          }
        }
        y(X, function(t, n) {
          e._messageCenter.on(n, function(s) {
            if (je[e.group] && e[he] !== We) {
              if (s && s.escapeConnect)
                return;
              var d = e.makeActionFromEvent(s), f = [];
              y(Z, function(h) {
                h !== e && h.group === e.group && f.push(h);
              }), i(f, We), y(f, function(h) {
                h[he] !== Mr && h.dispatchAction(d);
              }), i(f, Lr);
            }
          });
        });
      };
    }(), u;
  }(Re)
), Oe = vt.prototype;
Oe.on = ft("on");
Oe.off = ft("off");
Oe.one = function(c, u, r) {
  var a = this;
  at("ECharts#one is deprecated.");
  function l() {
    for (var o = [], m = 0; m < arguments.length; m++)
      o[m] = arguments[m];
    u && u.apply && u.apply(this, o), a.off(c, l);
  }
  this.on.call(this, c, l, r);
};
var xr = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function P(c) {
  process.env.NODE_ENV !== "production" && N("Instance " + c + " has been disposed");
}
var te = {}, X = {}, Ee = [], Ce = [], re = [], _t = {}, ye = {}, Z = {}, je = {}, Nr = +/* @__PURE__ */ new Date() - 0, Ae = "_echarts_instance_";
function Pi(c, u, r) {
  var a = !(r && r.ssr);
  if (a) {
    if (process.env.NODE_ENV !== "production" && !c)
      throw new Error("Initialize failed: invalid dom.");
    var l = Ur(c);
    if (l)
      return process.env.NODE_ENV !== "production" && N("There is a chart instance already initialized on the dom."), l;
    process.env.NODE_ENV !== "production" && yt(c) && c.nodeName.toUpperCase() !== "CANVAS" && (!c.clientWidth && (!r || r.width == null) || !c.clientHeight && (!r || r.height == null)) && N("Can't get DOM width or height. Please check dom.clientWidth and dom.clientHeight. They should not be 0.For example, you may need to call this in the callback of window.onload.");
  }
  var o = new vt(c, u, r);
  return o.id = "ec_" + Nr++, Z[o.id] = o, a && it(c, Ae, o.id), ht(o), M.trigger("afterinit", o), o;
}
function Ur(c) {
  return Z[qt(c, Ae)];
}
function gt(c, u) {
  _t[c] = u;
}
function kr(c) {
  Qe(Ce, c) < 0 && Ce.push(c);
}
function zr(c, u) {
  Pe(Ee, c, u, wr);
}
function Di(c) {
  mt("afterinit", c);
}
function Vi(c) {
  mt("afterupdate", c);
}
function mt(c, u) {
  M.on(c, u);
}
function K(c, u, r) {
  et(u) && (r = u, u = "");
  var a = W(c) ? c.type : [c, c = {
    event: u
  }][0];
  c.event = (c.event || a).toLowerCase(), u = c.event, !X[u] && (ee(Ge.test(a) && Ge.test(u)), te[a] || (te[a] = {
    action: r,
    actionInfo: c
  }), X[u] = a);
}
function Ii(c, u) {
  tt.register(c, u);
}
function Mi(c, u) {
  Pe(re, c, u, st, "layout");
}
function H(c, u) {
  Pe(re, c, u, ot, "visual");
}
var Je = [];
function Pe(c, u, r, a, l) {
  if ((et(u) || W(u)) && (r = u, u = a), process.env.NODE_ENV !== "production") {
    if (isNaN(u) || u == null)
      throw new Error("Illegal priority");
    y(c, function(m) {
      ee(m.__raw !== r);
    });
  }
  if (!(Qe(Je, r) >= 0)) {
    Je.push(r);
    var o = nt.wrapStageHandler(r, l);
    o.__prio = u, o.__raw = r, c.push(o);
  }
}
function br(c, u) {
  ye[c] = u;
}
function Li(c, u, r) {
  var a = gr("registerMap");
  a && a(c, u, r);
}
var xi = lr;
H(we, Qt);
H(ie, er);
H(ie, tr);
H(we, sr);
H(ie, or);
H(ut, vr);
kr(rt);
zr(yr, It);
br("default", rr);
K({
  type: F,
  event: F,
  update: F
}, q);
K({
  type: oe,
  event: oe,
  update: oe
}, q);
K({
  type: ue,
  event: ue,
  update: ue
}, q);
K({
  type: fe,
  event: fe,
  update: fe
}, q);
K({
  type: de,
  event: de,
  update: de
}, q);
gt("light", ir);
gt("dark", nr);
export {
  Ai as PRIORITY,
  Ur as getInstanceByDom,
  Pi as init,
  K as registerAction,
  Ii as registerCoordinateSystem,
  Mi as registerLayout,
  br as registerLoading,
  ki as registerLocale,
  Li as registerMap,
  Di as registerPostInit,
  Vi as registerPostUpdate,
  kr as registerPreprocessor,
  zr as registerProcessor,
  gt as registerTheme,
  xi as registerTransform,
  mt as registerUpdateLifecycle,
  H as registerVisual
};
//# sourceMappingURL=echarts.mjs.map
