import { assert as k, isFunction as O, map as P, keys as B, reduce as T, clone as U, createHashMap as L } from "../../../zrender/lib/core/util.mjs";
import { parseDataValue as G } from "./helper/dataValueHelper.mjs";
import { shouldRetrieveDataByName as q } from "./Source.mjs";
var E = "undefined", H = typeof Uint32Array === E ? Array : Uint32Array, J = typeof Uint16Array === E ? Array : Uint16Array, K = typeof Int32Array === E ? Array : Int32Array, z = typeof Float64Array === E ? Array : Float64Array, b = {
  float: z,
  int: K,
  // Ordinal data type can be string or int
  ordinal: Array,
  number: Array,
  time: z
}, V;
function S(v) {
  return v > 65535 ? H : J;
}
function C() {
  return [1 / 0, -1 / 0];
}
function Q(v) {
  var t = v.constructor;
  return t === Array ? v.slice() : new t(v);
}
function F(v, t, r, e, a) {
  var n = b[r || "float"];
  if (a) {
    var i = v[t], s = i && i.length;
    if (s !== e) {
      for (var o = new n(e), u = 0; u < s; u++)
        o[u] = i[u];
      v[t] = o;
    }
  } else
    v[t] = new n(e);
}
var X = (
  /** @class */
  function() {
    function v() {
      this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = L();
    }
    return v.prototype.initData = function(t, r, e) {
      process.env.NODE_ENV !== "production" && k(O(t.getItem) && O(t.count), "Invalid data provider."), this._provider = t, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
      var a = t.getSource(), n = this.defaultDimValueGetter = V[a.sourceFormat];
      this._dimValueGetter = e || n, this._rawExtent = [];
      var i = q(a);
      this._dimensions = P(r, function(s) {
        return process.env.NODE_ENV !== "production" && i && k(s.property != null), {
          // Only pick these two props. Not leak other properties like orderMeta.
          type: s.type,
          property: s.property
        };
      }), this._initDataFromProvider(0, t.count());
    }, v.prototype.getProvider = function() {
      return this._provider;
    }, v.prototype.getSource = function() {
      return this._provider.getSource();
    }, v.prototype.ensureCalculationDimension = function(t, r) {
      var e = this._calcDimNameToIdx, a = this._dimensions, n = e.get(t);
      if (n != null) {
        if (a[n].type === r)
          return n;
      } else
        n = a.length;
      return a[n] = {
        type: r
      }, e.set(t, n), this._chunks[n] = new b[r || "float"](this._rawCount), this._rawExtent[n] = C(), n;
    }, v.prototype.collectOrdinalMeta = function(t, r) {
      var e = this._chunks[t], a = this._dimensions[t], n = this._rawExtent, i = a.ordinalOffset || 0, s = e.length;
      i === 0 && (n[t] = C());
      for (var o = n[t], u = i; u < s; u++) {
        var c = e[u] = r.parseAndCollect(e[u]);
        isNaN(c) || (o[0] = Math.min(c, o[0]), o[1] = Math.max(c, o[1]));
      }
      a.ordinalMeta = r, a.ordinalOffset = s, a.type = "ordinal";
    }, v.prototype.getOrdinalMeta = function(t) {
      var r = this._dimensions[t], e = r.ordinalMeta;
      return e;
    }, v.prototype.getDimensionProperty = function(t) {
      var r = this._dimensions[t];
      return r && r.property;
    }, v.prototype.appendData = function(t) {
      process.env.NODE_ENV !== "production" && k(!this._indices, "appendData can only be called on raw data.");
      var r = this._provider, e = this.count();
      r.appendData(t);
      var a = r.count();
      return r.persistent || (a += e), e < a && this._initDataFromProvider(e, a, !0), [e, a];
    }, v.prototype.appendValues = function(t, r) {
      for (var e = this._chunks, a = this._dimensions, n = a.length, i = this._rawExtent, s = this.count(), o = s + Math.max(t.length, r || 0), u = 0; u < n; u++) {
        var c = a[u];
        F(e, u, c.type, o, !0);
      }
      for (var y = [], _ = s; _ < o; _++)
        for (var f = _ - s, h = 0; h < n; h++) {
          var c = a[h], w = V.arrayRows.call(this, t[f] || y, c.property, f, h);
          e[h][_] = w;
          var l = i[h];
          w < l[0] && (l[0] = w), w > l[1] && (l[1] = w);
        }
      return this._rawCount = this._count = o, {
        start: s,
        end: o
      };
    }, v.prototype._initDataFromProvider = function(t, r, e) {
      for (var a = this._provider, n = this._chunks, i = this._dimensions, s = i.length, o = this._rawExtent, u = P(i, function(g) {
        return g.property;
      }), c = 0; c < s; c++) {
        var y = i[c];
        o[c] || (o[c] = C()), F(n, c, y.type, r, e);
      }
      if (a.fillStorage)
        a.fillStorage(t, r, n, o);
      else
        for (var _ = [], f = t; f < r; f++) {
          _ = a.getItem(f, _);
          for (var h = 0; h < s; h++) {
            var w = n[h], l = this._dimValueGetter(_, u[h], f, h);
            w[f] = l;
            var p = o[h];
            l < p[0] && (p[0] = l), l > p[1] && (p[1] = l);
          }
        }
      !a.persistent && a.clean && a.clean(), this._rawCount = this._count = r, this._extent = [];
    }, v.prototype.count = function() {
      return this._count;
    }, v.prototype.get = function(t, r) {
      if (!(r >= 0 && r < this._count))
        return NaN;
      var e = this._chunks[t];
      return e ? e[this.getRawIndex(r)] : NaN;
    }, v.prototype.getValues = function(t, r) {
      var e = [], a = [];
      if (r == null) {
        r = t, t = [];
        for (var n = 0; n < this._dimensions.length; n++)
          a.push(n);
      } else
        a = t;
      for (var n = 0, i = a.length; n < i; n++)
        e.push(this.get(a[n], r));
      return e;
    }, v.prototype.getByRawIndex = function(t, r) {
      if (!(r >= 0 && r < this._rawCount))
        return NaN;
      var e = this._chunks[t];
      return e ? e[r] : NaN;
    }, v.prototype.getSum = function(t) {
      var r = this._chunks[t], e = 0;
      if (r)
        for (var a = 0, n = this.count(); a < n; a++) {
          var i = this.get(t, a);
          isNaN(i) || (e += i);
        }
      return e;
    }, v.prototype.getMedian = function(t) {
      var r = [];
      this.each([t], function(n) {
        isNaN(n) || r.push(n);
      });
      var e = r.sort(function(n, i) {
        return n - i;
      }), a = this.count();
      return a === 0 ? 0 : a % 2 === 1 ? e[(a - 1) / 2] : (e[a / 2] + e[a / 2 - 1]) / 2;
    }, v.prototype.indexOfRawIndex = function(t) {
      if (t >= this._rawCount || t < 0)
        return -1;
      if (!this._indices)
        return t;
      var r = this._indices, e = r[t];
      if (e != null && e < this._count && e === t)
        return t;
      for (var a = 0, n = this._count - 1; a <= n; ) {
        var i = (a + n) / 2 | 0;
        if (r[i] < t)
          a = i + 1;
        else if (r[i] > t)
          n = i - 1;
        else
          return i;
      }
      return -1;
    }, v.prototype.indicesOfNearest = function(t, r, e) {
      var a = this._chunks, n = a[t], i = [];
      if (!n)
        return i;
      e == null && (e = 1 / 0);
      for (var s = 1 / 0, o = -1, u = 0, c = 0, y = this.count(); c < y; c++) {
        var _ = this.getRawIndex(c), f = r - n[_], h = Math.abs(f);
        h <= e && ((h < s || h === s && f >= 0 && o < 0) && (s = h, o = f, u = 0), f === o && (i[u++] = c));
      }
      return i.length = u, i;
    }, v.prototype.getIndices = function() {
      var t, r = this._indices;
      if (r) {
        var e = r.constructor, a = this._count;
        if (e === Array) {
          t = new e(a);
          for (var n = 0; n < a; n++)
            t[n] = r[n];
        } else
          t = new e(r.buffer, 0, a);
      } else {
        var e = S(this._rawCount);
        t = new e(this.count());
        for (var n = 0; n < t.length; n++)
          t[n] = n;
      }
      return t;
    }, v.prototype.filter = function(t, r) {
      if (!this._count)
        return this;
      for (var e = this.clone(), a = e.count(), n = S(e._rawCount), i = new n(a), s = [], o = t.length, u = 0, c = t[0], y = e._chunks, _ = 0; _ < a; _++) {
        var f = void 0, h = e.getRawIndex(_);
        if (o === 0)
          f = r(_);
        else if (o === 1) {
          var w = y[c][h];
          f = r(w, _);
        } else {
          for (var l = 0; l < o; l++)
            s[l] = y[t[l]][h];
          s[l] = _, f = r.apply(null, s);
        }
        f && (i[u++] = h);
      }
      return u < a && (e._indices = i), e._count = u, e._extent = [], e._updateGetRawIdx(), e;
    }, v.prototype.selectRange = function(t) {
      var r = this.clone(), e = r._count;
      if (!e)
        return this;
      var a = B(t), n = a.length;
      if (!n)
        return this;
      var i = r.count(), s = S(r._rawCount), o = new s(i), u = 0, c = a[0], y = t[c][0], _ = t[c][1], f = r._chunks, h = !1;
      if (!r._indices) {
        var w = 0;
        if (n === 1) {
          for (var l = f[a[0]], p = 0; p < e; p++) {
            var g = l[p];
            (g >= y && g <= _ || isNaN(g)) && (o[u++] = w), w++;
          }
          h = !0;
        } else if (n === 2) {
          for (var l = f[a[0]], d = f[a[1]], D = t[a[1]][0], R = t[a[1]][1], p = 0; p < e; p++) {
            var g = l[p], I = d[p];
            (g >= y && g <= _ || isNaN(g)) && (I >= D && I <= R || isNaN(I)) && (o[u++] = w), w++;
          }
          h = !0;
        }
      }
      if (!h)
        if (n === 1)
          for (var p = 0; p < i; p++) {
            var N = r.getRawIndex(p), g = f[a[0]][N];
            (g >= y && g <= _ || isNaN(g)) && (o[u++] = N);
          }
        else
          for (var p = 0; p < i; p++) {
            for (var M = !0, N = r.getRawIndex(p), A = 0; A < n; A++) {
              var m = a[A], g = f[m][N];
              (g < t[m][0] || g > t[m][1]) && (M = !1);
            }
            M && (o[u++] = r.getRawIndex(p));
          }
      return u < i && (r._indices = o), r._count = u, r._extent = [], r._updateGetRawIdx(), r;
    }, v.prototype.map = function(t, r) {
      var e = this.clone(t);
      return this._updateDims(e, t, r), e;
    }, v.prototype.modify = function(t, r) {
      this._updateDims(this, t, r);
    }, v.prototype._updateDims = function(t, r, e) {
      for (var a = t._chunks, n = [], i = r.length, s = t.count(), o = [], u = t._rawExtent, c = 0; c < r.length; c++)
        u[r[c]] = C();
      for (var y = 0; y < s; y++) {
        for (var _ = t.getRawIndex(y), f = 0; f < i; f++)
          o[f] = a[r[f]][_];
        o[i] = y;
        var h = e && e.apply(null, o);
        if (h != null) {
          typeof h != "object" && (n[0] = h, h = n);
          for (var c = 0; c < h.length; c++) {
            var w = r[c], l = h[c], p = u[w], g = a[w];
            g && (g[_] = l), l < p[0] && (p[0] = l), l > p[1] && (p[1] = l);
          }
        }
      }
    }, v.prototype.lttbDownSample = function(t, r) {
      var e = this.clone([t], !0), a = e._chunks, n = a[t], i = this.count(), s = 0, o = Math.floor(1 / r), u = this.getRawIndex(0), c, y, _, f = new (S(this._rawCount))(Math.min((Math.ceil(i / o) + 2) * 2, i));
      f[s++] = u;
      for (var h = 1; h < i - 1; h += o) {
        for (var w = Math.min(h + o, i - 1), l = Math.min(h + o * 2, i), p = (l + w) / 2, g = 0, d = w; d < l; d++) {
          var D = this.getRawIndex(d), R = n[D];
          isNaN(R) || (g += R);
        }
        g /= l - w;
        var I = h, N = Math.min(h + o, i), M = h - 1, A = n[u];
        c = -1, _ = I;
        for (var m = -1, x = 0, d = I; d < N; d++) {
          var D = this.getRawIndex(d), R = n[D];
          if (isNaN(R)) {
            x++, m < 0 && (m = D);
            continue;
          }
          y = Math.abs((M - p) * (R - A) - (M - d) * (g - A)), y > c && (c = y, _ = D);
        }
        x > 0 && x < N - I && (f[s++] = Math.min(m, _), _ = Math.max(m, _)), f[s++] = _, u = _;
      }
      return f[s++] = this.getRawIndex(i - 1), e._count = s, e._indices = f, e.getRawIndex = this._getRawIdx, e;
    }, v.prototype.downSample = function(t, r, e, a) {
      for (var n = this.clone([t], !0), i = n._chunks, s = [], o = Math.floor(1 / r), u = i[t], c = this.count(), y = n._rawExtent[t] = C(), _ = new (S(this._rawCount))(Math.ceil(c / o)), f = 0, h = 0; h < c; h += o) {
        o > c - h && (o = c - h, s.length = o);
        for (var w = 0; w < o; w++) {
          var l = this.getRawIndex(h + w);
          s[w] = u[l];
        }
        var p = e(s), g = this.getRawIndex(Math.min(h + a(s, p) || 0, c - 1));
        u[g] = p, p < y[0] && (y[0] = p), p > y[1] && (y[1] = p), _[f++] = g;
      }
      return n._count = f, n._indices = _, n._updateGetRawIdx(), n;
    }, v.prototype.each = function(t, r) {
      if (this._count)
        for (var e = t.length, a = this._chunks, n = 0, i = this.count(); n < i; n++) {
          var s = this.getRawIndex(n);
          switch (e) {
            case 0:
              r(n);
              break;
            case 1:
              r(a[t[0]][s], n);
              break;
            case 2:
              r(a[t[0]][s], a[t[1]][s], n);
              break;
            default:
              for (var o = 0, u = []; o < e; o++)
                u[o] = a[t[o]][s];
              u[o] = n, r.apply(null, u);
          }
        }
    }, v.prototype.getDataExtent = function(t) {
      var r = this._chunks[t], e = C();
      if (!r)
        return e;
      var a = this.count(), n = !this._indices, i;
      if (n)
        return this._rawExtent[t].slice();
      if (i = this._extent[t], i)
        return i.slice();
      i = e;
      for (var s = i[0], o = i[1], u = 0; u < a; u++) {
        var c = this.getRawIndex(u), y = r[c];
        y < s && (s = y), y > o && (o = y);
      }
      return i = [s, o], this._extent[t] = i, i;
    }, v.prototype.getRawDataItem = function(t) {
      var r = this.getRawIndex(t);
      if (this._provider.persistent)
        return this._provider.getItem(r);
      for (var e = [], a = this._chunks, n = 0; n < a.length; n++)
        e.push(a[n][r]);
      return e;
    }, v.prototype.clone = function(t, r) {
      var e = new v(), a = this._chunks, n = t && T(t, function(s, o) {
        return s[o] = !0, s;
      }, {});
      if (n)
        for (var i = 0; i < a.length; i++)
          e._chunks[i] = n[i] ? Q(a[i]) : a[i];
      else
        e._chunks = a;
      return this._copyCommonProps(e), r || (e._indices = this._cloneIndices()), e._updateGetRawIdx(), e;
    }, v.prototype._copyCommonProps = function(t) {
      t._count = this._count, t._rawCount = this._rawCount, t._provider = this._provider, t._dimensions = this._dimensions, t._extent = U(this._extent), t._rawExtent = U(this._rawExtent);
    }, v.prototype._cloneIndices = function() {
      if (this._indices) {
        var t = this._indices.constructor, r = void 0;
        if (t === Array) {
          var e = this._indices.length;
          r = new t(e);
          for (var a = 0; a < e; a++)
            r[a] = this._indices[a];
        } else
          r = new t(this._indices);
        return r;
      }
      return null;
    }, v.prototype._getRawIdxIdentity = function(t) {
      return t;
    }, v.prototype._getRawIdx = function(t) {
      return t < this._count && t >= 0 ? this._indices[t] : -1;
    }, v.prototype._updateGetRawIdx = function() {
      this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
    }, v.internalField = function() {
      function t(r, e, a, n) {
        return G(r[n], this._dimensions[n]);
      }
      V = {
        arrayRows: t,
        objectRows: function(r, e, a, n) {
          return G(r[e], this._dimensions[n]);
        },
        keyedColumns: t,
        original: function(r, e, a, n) {
          var i = r && (r.value == null ? r : r.value);
          return G(i instanceof Array ? i[n] : i, this._dimensions[n]);
        },
        typedArray: function(r, e, a, n) {
          return r[n];
        }
      };
    }(), v;
  }()
);
export {
  z as CtorFloat64Array,
  K as CtorInt32Array,
  J as CtorUint16Array,
  H as CtorUint32Array,
  X as default
};
//# sourceMappingURL=DataStore.mjs.map
