import { each as B, assert as g, isTypedArray as b, extend as W, bind as V } from "../../../../zrender/lib/core/util.mjs";
import { getDataItemValue as Y } from "../../util/model.mjs";
import { isSourceInstance as x, createSourceFromSeriesDataOption as K } from "../Source.mjs";
import { SOURCE_FORMAT_ARRAY_ROWS as _, SERIES_LAYOUT_BY_COLUMN as w, SERIES_LAYOUT_BY_ROW as M, SOURCE_FORMAT_OBJECT_ROWS as R, SOURCE_FORMAT_KEYED_COLUMNS as A, SOURCE_FORMAT_ORIGINAL as E, SOURCE_FORMAT_TYPED_ARRAY as I } from "../../util/types.mjs";
var l, h, D, F, C, tt = (
  /** @class */
  function() {
    function t(r, a) {
      var n = x(r) ? r : K(r);
      this._source = n;
      var i = this._data = n.data;
      if (n.sourceFormat === I) {
        if (process.env.NODE_ENV !== "production" && a == null)
          throw new Error("Typed array data must specify dimension size");
        this._offset = 0, this._dimSize = a, this._data = i;
      }
      C(this, i, n);
    }
    return t.prototype.getSource = function() {
      return this._source;
    }, t.prototype.count = function() {
      return 0;
    }, t.prototype.getItem = function(r, a) {
    }, t.prototype.appendData = function(r) {
    }, t.prototype.clean = function() {
    }, t.protoInitialize = function() {
      var r = t.prototype;
      r.pure = !1, r.persistent = !0;
    }(), t.internalField = function() {
      var r;
      C = function(e, o, u) {
        var p = u.sourceFormat, c = u.seriesLayoutBy, f = u.startIndex, d = u.dimensionsDefine, v = F[T(p, c)];
        if (process.env.NODE_ENV !== "production" && g(v, "Invalide sourceFormat: " + p), W(e, v), p === I)
          e.getItem = a, e.count = i, e.fillStorage = n;
        else {
          var m = J(p, c);
          e.getItem = V(m, null, o, f, d);
          var S = q(p, c);
          e.count = V(S, null, o, f, d);
        }
      };
      var a = function(e, o) {
        e = e - this._offset, o = o || [];
        for (var u = this._data, p = this._dimSize, c = p * e, f = 0; f < p; f++)
          o[f] = u[c + f];
        return o;
      }, n = function(e, o, u, p) {
        for (var c = this._data, f = this._dimSize, d = 0; d < f; d++) {
          for (var v = p[d], m = v[0] == null ? 1 / 0 : v[0], S = v[1] == null ? -1 / 0 : v[1], L = o - e, G = u[d], O = 0; O < L; O++) {
            var y = c[O * f + d];
            G[e + O] = y, y < m && (m = y), y > S && (S = y);
          }
          v[0] = m, v[1] = S;
        }
      }, i = function() {
        return this._data ? this._data.length / this._dimSize : 0;
      };
      F = (r = {}, r[_ + "_" + w] = {
        pure: !0,
        appendData: s
      }, r[_ + "_" + M] = {
        pure: !0,
        appendData: function() {
          throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
        }
      }, r[R] = {
        pure: !0,
        appendData: s
      }, r[A] = {
        pure: !0,
        appendData: function(e) {
          var o = this._data;
          B(e, function(u, p) {
            for (var c = o[p] || (o[p] = []), f = 0; f < (u || []).length; f++)
              c.push(u[f]);
          });
        }
      }, r[E] = {
        appendData: s
      }, r[I] = {
        persistent: !1,
        pure: !0,
        appendData: function(e) {
          process.env.NODE_ENV !== "production" && g(b(e), "Added data must be TypedArray if data in initialization is TypedArray"), this._data = e;
        },
        // Clean self if data is already used.
        clean: function() {
          this._offset += this.count(), this._data = null;
        }
      }, r);
      function s(e) {
        for (var o = 0; o < e.length; o++)
          this._data.push(e[o]);
      }
    }(), t;
  }()
), U = function(t, r, a, n) {
  return t[n];
}, P = (l = {}, l[_ + "_" + w] = function(t, r, a, n) {
  return t[n + r];
}, l[_ + "_" + M] = function(t, r, a, n, i) {
  n += r;
  for (var s = i || [], e = t, o = 0; o < e.length; o++) {
    var u = e[o];
    s[o] = u ? u[n] : null;
  }
  return s;
}, l[R] = U, l[A] = function(t, r, a, n, i) {
  for (var s = i || [], e = 0; e < a.length; e++) {
    var o = a[e].name;
    if (process.env.NODE_ENV !== "production" && o == null)
      throw new Error();
    var u = t[o];
    s[e] = u ? u[n] : null;
  }
  return s;
}, l[E] = U, l);
function J(t, r) {
  var a = P[T(t, r)];
  return process.env.NODE_ENV !== "production" && g(a, 'Do not support get item on "' + t + '", "' + r + '".'), a;
}
var z = function(t, r, a) {
  return t.length;
}, j = (h = {}, h[_ + "_" + w] = function(t, r, a) {
  return Math.max(0, t.length - r);
}, h[_ + "_" + M] = function(t, r, a) {
  var n = t[0];
  return n ? Math.max(0, n.length - r) : 0;
}, h[R] = z, h[A] = function(t, r, a) {
  var n = a[0].name;
  if (process.env.NODE_ENV !== "production" && n == null)
    throw new Error();
  var i = t[n];
  return i ? i.length : 0;
}, h[E] = z, h);
function q(t, r) {
  var a = j[T(t, r)];
  return process.env.NODE_ENV !== "production" && g(a, 'Do not support count on "' + t + '", "' + r + '".'), a;
}
var N = function(t, r, a) {
  return t[r];
}, H = (D = {}, D[_] = N, D[R] = function(t, r, a) {
  return t[a];
}, D[A] = N, D[E] = function(t, r, a) {
  var n = Y(t);
  return n instanceof Array ? n[r] : n;
}, D[I] = N, D);
function Q(t) {
  var r = H[t];
  return process.env.NODE_ENV !== "production" && g(r, 'Do not support get value on "' + t + '".'), r;
}
function T(t, r) {
  return t === _ ? t + "_" + r : t;
}
function rt(t, r, a) {
  if (t) {
    var n = t.getRawDataItem(r);
    if (n != null) {
      var i = t.getStore(), s = i.getSource().sourceFormat;
      if (a != null) {
        var e = t.getDimensionIndex(a), o = i.getDimensionProperty(e);
        return Q(s)(n, e, o);
      } else {
        var u = n;
        return s === E && (u = Y(n)), u;
      }
    }
  }
}
export {
  tt as DefaultDataProvider,
  q as getRawSourceDataCounter,
  J as getRawSourceItemGetter,
  Q as getRawSourceValueGetter,
  rt as retrieveRawValue
};
//# sourceMappingURL=dataProvider.mjs.map
