import { setAsPrimitive as T, isTypedArray as B, retrieve2 as h, assert as g, each as N, map as O } from "../../../../zrender/lib/core/util.mjs";
import { createSource as d, cloneSourceShallow as U } from "../Source.mjs";
import { SOURCE_FORMAT_TYPED_ARRAY as V, SOURCE_FORMAT_ORIGINAL as A } from "../../util/types.mjs";
import { querySeriesUpstreamDatasetModel as M, queryDatasetUpstreamDatasetModels as R } from "./sourceHelper.mjs";
import { applyDataTransform as C } from "./transform.mjs";
import G from "../DataStore.mjs";
import { DefaultDataProvider as b } from "./dataProvider.mjs";
var F = (
  /** @class */
  function() {
    function s(r) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = !0, this._sourceHost = r;
    }
    return s.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = !0;
    }, s.prototype._setLocalSource = function(r, e) {
      this._sourceList = r, this._upstreamSignList = e, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, s.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, s.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = !1);
    }, s.prototype._createSource = function() {
      this._setLocalSource([], []);
      var r = this._sourceHost, e = this._getUpstreamSourceManagers(), t = !!e.length, o, i;
      if (_(r)) {
        var n = r, a = void 0, u = void 0, c = void 0;
        if (t) {
          var f = e[0];
          f.prepareSource(), c = f.getSource(), a = c.data, u = c.sourceFormat, i = [f._getVersionSign()];
        } else
          a = n.get("data", !0), u = B(a) ? V : A, i = [];
        var p = this._getSourceMetaRawOption() || {}, v = c && c.metaRawOption || {}, m = h(p.seriesLayoutBy, v.seriesLayoutBy) || null, S = h(p.sourceHeader, v.sourceHeader), l = h(p.dimensions, v.dimensions), D = m !== v.seriesLayoutBy || !!S != !!v.sourceHeader || l;
        o = D ? [d(a, {
          seriesLayoutBy: m,
          sourceHeader: S,
          dimensions: l
        }, u)] : [];
      } else {
        var H = r;
        if (t) {
          var y = this._applyTransform(e);
          o = y.sourceList, i = y.upstreamSignList;
        } else {
          var E = H.get("source", !0);
          o = [d(E, this._getSourceMetaRawOption(), null)], i = [];
        }
      }
      process.env.NODE_ENV !== "production" && g(o && i), this._setLocalSource(o, i);
    }, s.prototype._applyTransform = function(r) {
      var e = this._sourceHost, t = e.get("transform", !0), o = e.get("fromTransformResult", !0);
      if (process.env.NODE_ENV !== "production" && g(o != null || t != null), o != null) {
        var i = "";
        r.length !== 1 && (process.env.NODE_ENV !== "production" && (i = "When using `fromTransformResult`, there should be only one upstream dataset"), L(i));
      }
      var n, a = [], u = [];
      return N(r, function(c) {
        c.prepareSource();
        var f = c.getSource(o || 0), p = "";
        o != null && !f && (process.env.NODE_ENV !== "production" && (p = "Can not retrieve result by `fromTransformResult`: " + o), L(p)), a.push(f), u.push(c._getVersionSign());
      }), t ? n = C(t, a, {
        datasetIndex: e.componentIndex
      }) : o != null && (n = [U(a[0])]), {
        sourceList: n,
        upstreamSignList: u
      };
    }, s.prototype._isDirty = function() {
      if (this._dirty)
        return !0;
      for (var r = this._getUpstreamSourceManagers(), e = 0; e < r.length; e++) {
        var t = r[e];
        if (
          // Consider the case that there is ancestor diry, call it recursively.
          // The performance is probably not an issue because usually the chain is not long.
          t._isDirty() || this._upstreamSignList[e] !== t._getVersionSign()
        )
          return !0;
      }
    }, s.prototype.getSource = function(r) {
      r = r || 0;
      var e = this._sourceList[r];
      if (!e) {
        var t = this._getUpstreamSourceManagers();
        return t[0] && t[0].getSource(r);
      }
      return e;
    }, s.prototype.getSharedDataStore = function(r) {
      process.env.NODE_ENV !== "production" && g(_(this._sourceHost), "Can only call getDataStore on series source manager.");
      var e = r.makeStoreSchema();
      return this._innerGetDataStore(e.dimensions, r.source, e.hash);
    }, s.prototype._innerGetDataStore = function(r, e, t) {
      var o = 0, i = this._storeList, n = i[o];
      n || (n = i[o] = {});
      var a = n[t];
      if (!a) {
        var u = this._getUpstreamSourceManagers()[0];
        _(this._sourceHost) && u ? a = u._innerGetDataStore(r, e, t) : (a = new G(), a.initData(new b(e, r.length), r)), n[t] = a;
      }
      return a;
    }, s.prototype._getUpstreamSourceManagers = function() {
      var r = this._sourceHost;
      if (_(r)) {
        var e = M(r);
        return e ? [e.getSourceManager()] : [];
      } else
        return O(R(r), function(t) {
          return t.getSourceManager();
        });
    }, s.prototype._getSourceMetaRawOption = function() {
      var r = this._sourceHost, e, t, o;
      if (_(r))
        e = r.get("seriesLayoutBy", !0), t = r.get("sourceHeader", !0), o = r.get("dimensions", !0);
      else if (!this._getUpstreamSourceManagers().length) {
        var i = r;
        e = i.get("seriesLayoutBy", !0), t = i.get("sourceHeader", !0), o = i.get("dimensions", !0);
      }
      return {
        seriesLayoutBy: e,
        sourceHeader: t,
        dimensions: o
      };
    }, s;
  }()
);
function W(s) {
  var r = s.option.transform;
  r && T(s.option.transform);
}
function _(s) {
  return s.mainType === "series";
}
function L(s) {
  throw new Error(s);
}
export {
  F as SourceManager,
  W as disableTransformOptionMerge
};
//# sourceMappingURL=sourceManager.mjs.map
