import { SERIES_LAYOUT_BY_COLUMN as N, SOURCE_FORMAT_ARRAY_ROWS as F, SOURCE_FORMAT_OBJECT_ROWS as b } from "../../util/types.mjs";
import { normalizeToArray as M } from "../../util/model.mjs";
import { createHashMap as T, clone as _, isObject as V, map as w, each as A, hasOwn as h, bind as D, extend as C, isNumber as B } from "../../../../zrender/lib/core/util.mjs";
import { getRawSourceItemGetter as U, getRawSourceDataCounter as j, getRawSourceValueGetter as G } from "./dataProvider.mjs";
import { parseDataValue as H } from "./dataValueHelper.mjs";
import { throwError as c, makePrintable as x, log as L } from "../../util/log.mjs";
import { detectSourceFormat as Y, createSource as k } from "../Source.mjs";
var P = (
  /** @class */
  function() {
    function e() {
    }
    return e.prototype.getRawData = function() {
      throw new Error("not supported");
    }, e.prototype.getRawDataItem = function(t) {
      throw new Error("not supported");
    }, e.prototype.cloneRawData = function() {
    }, e.prototype.getDimensionInfo = function(t) {
    }, e.prototype.cloneAllDimensionInfo = function() {
    }, e.prototype.count = function() {
    }, e.prototype.retrieveValue = function(t, r) {
    }, e.prototype.retrieveValueFromItem = function(t, r) {
    }, e.prototype.convertValue = function(t, r) {
      return H(t, r);
    }, e;
  }()
);
function W(e, t) {
  var r = new P(), i = e.data, n = r.sourceFormat = e.sourceFormat, a = e.startIndex, s = "";
  e.seriesLayoutBy !== N && (process.env.NODE_ENV !== "production" && (s = '`seriesLayoutBy` of upstream dataset can only be "column" in data transform.'), c(s));
  var u = [], d = {}, y = e.dimensionsDefine;
  if (y)
    A(y, function(f, p) {
      var m = f.name, R = {
        index: p,
        name: m,
        displayName: f.displayName
      };
      if (u.push(R), m != null) {
        var I = "";
        h(d, m) && (process.env.NODE_ENV !== "production" && (I = 'dimension name "' + m + '" duplicated.'), c(I)), d[m] = R;
      }
    });
  else
    for (var o = 0; o < e.dimensionsDetectedCount; o++)
      u.push({
        index: o
      });
  var v = U(n, N);
  t.__isBuiltIn && (r.getRawDataItem = function(f) {
    return v(i, a, u, f);
  }, r.getRawData = D(z, null, e)), r.cloneRawData = D(J, null, e);
  var l = j(n, N);
  r.count = D(l, null, i, a, u);
  var g = G(n);
  r.retrieveValue = function(f, p) {
    var m = v(i, a, u, f);
    return E(m, p);
  };
  var E = r.retrieveValueFromItem = function(f, p) {
    if (f != null) {
      var m = u[p];
      if (m)
        return g(f, p, m.name);
    }
  };
  return r.getDimensionInfo = D(q, null, u, d), r.cloneAllDimensionInfo = D(K, null, u), r;
}
function z(e) {
  var t = e.sourceFormat;
  if (!O(t)) {
    var r = "";
    process.env.NODE_ENV !== "production" && (r = "`getRawData` is not supported in source format " + t), c(r);
  }
  return e.data;
}
function J(e) {
  var t = e.sourceFormat, r = e.data;
  if (!O(t)) {
    var i = "";
    process.env.NODE_ENV !== "production" && (i = "`cloneRawData` is not supported in source format " + t), c(i);
  }
  if (t === F) {
    for (var n = [], a = 0, s = r.length; a < s; a++)
      n.push(r[a].slice());
    return n;
  } else if (t === b) {
    for (var n = [], a = 0, s = r.length; a < s; a++)
      n.push(C({}, r[a]));
    return n;
  }
}
function q(e, t, r) {
  if (r != null) {
    if (B(r) || !isNaN(r) && !h(t, r))
      return e[r];
    if (h(t, r))
      return t[r];
  }
}
function K(e) {
  return _(e);
}
var S = T();
function ae(e) {
  e = _(e);
  var t = e.type, r = "";
  t || (process.env.NODE_ENV !== "production" && (r = "Must have a `type` when `registerTransform`."), c(r));
  var i = t.split(":");
  i.length !== 2 && (process.env.NODE_ENV !== "production" && (r = 'Name must include namespace like "ns:regression".'), c(r));
  var n = !1;
  i[0] === "echarts" && (t = i[1], n = !0), e.__isBuiltIn = n, S.set(t, e);
}
function oe(e, t, r) {
  var i = M(e), n = i.length, a = "";
  n || (process.env.NODE_ENV !== "production" && (a = "If `transform` declared, it should at least contain one transform."), c(a));
  for (var s = 0, u = n; s < u; s++) {
    var d = i[s];
    t = Q(d, t, r, n === 1 ? null : s), s !== u - 1 && (t.length = Math.max(t.length, 1));
  }
  return t;
}
function Q(e, t, r, i) {
  var n = "";
  t.length || (process.env.NODE_ENV !== "production" && (n = "Must have at least one upstream dataset."), c(n)), V(e) || (process.env.NODE_ENV !== "production" && (n = "transform declaration must be an object rather than " + typeof e + "."), c(n));
  var a = e.type, s = S.get(a);
  s || (process.env.NODE_ENV !== "production" && (n = 'Can not find transform on type "' + a + '".'), c(n));
  var u = w(t, function(o) {
    return W(o, s);
  }), d = M(s.transform({
    upstream: u[0],
    upstreamList: u,
    config: _(e.config)
  }));
  if (process.env.NODE_ENV !== "production" && e.print) {
    var y = w(d, function(o) {
      var v = i != null ? " === pipe index: " + i : "";
      return ["=== dataset index: " + r.datasetIndex + v + " ===", "- transform result data:", x(o.data), "- transform result dimensions:", x(o.dimensions)].join(`
`);
    }).join(`
`);
    L(y);
  }
  return w(d, function(o, v) {
    var l = "";
    V(o) || (process.env.NODE_ENV !== "production" && (l = "A transform should not return some empty results."), c(l)), o.data || (process.env.NODE_ENV !== "production" && (l = "Transform result data should be not be null or undefined"), c(l));
    var g = Y(o.data);
    O(g) || (process.env.NODE_ENV !== "production" && (l = "Transform result data should be array rows or object rows."), c(l));
    var E, f = t[0];
    if (f && v === 0 && !o.dimensions) {
      var p = f.startIndex;
      p && (o.data = f.data.slice(0, p).concat(o.data)), E = {
        seriesLayoutBy: N,
        sourceHeader: p,
        dimensions: f.metaRawOption.dimensions
      };
    } else
      E = {
        seriesLayoutBy: N,
        sourceHeader: 0,
        dimensions: o.dimensions
      };
    return k(o.data, E, null);
  });
}
function O(e) {
  return e === F || e === b;
}
export {
  P as ExternalSource,
  oe as applyDataTransform,
  ae as registerExternalTransform
};
//# sourceMappingURL=transform.mjs.map
