import { __extends as X } from "../../node_modules/tslib/tslib.es6.mjs";
import { assert as w, each as h, createHashMap as m, clone as D, merge as L, extend as H, filter as g, isFunction as $, isString as ee, isObject as j, isArray as te, mixin as ne } from "../../../zrender/lib/core/util.mjs";
import { normalizeToArray as I, mappingToExists as re, setComponentTypeToKeyInfo as oe, isComponentIdInternal as ie, convertOptionIdName as T } from "../util/model.mjs";
import b from "./Model.mjs";
import v from "./Component.mjs";
import se from "./globalDefault.mjs";
import { resetSourceDefaulter as ae } from "../data/helper/sourceHelper.mjs";
import { concatInternalOptions as ue } from "./internalComponentCreator.mjs";
import { PaletteMixin as le } from "./mixin/palette.mjs";
import { error as G, warn as pe } from "../util/log.mjs";
var S, x, K, k = "\0_ec_inner", Z = 1, fe = {
  grid: "GridComponent",
  polar: "PolarComponent",
  geo: "GeoComponent",
  singleAxis: "SingleAxisComponent",
  parallel: "ParallelComponent",
  calendar: "CalendarComponent",
  graphic: "GraphicComponent",
  toolbox: "ToolboxComponent",
  tooltip: "TooltipComponent",
  axisPointer: "AxisPointerComponent",
  brush: "BrushComponent",
  title: "TitleComponent",
  timeline: "TimelineComponent",
  markPoint: "MarkPointComponent",
  markLine: "MarkLineComponent",
  markArea: "MarkAreaComponent",
  legend: "LegendComponent",
  dataZoom: "DataZoomComponent",
  visualMap: "VisualMapComponent",
  // aria: 'AriaComponent',
  // dataset: 'DatasetComponent',
  // Dependencies
  xAxis: "GridComponent",
  yAxis: "GridComponent",
  angleAxis: "PolarComponent",
  radiusAxis: "PolarComponent"
}, ce = {
  line: "LineChart",
  bar: "BarChart",
  pie: "PieChart",
  scatter: "ScatterChart",
  radar: "RadarChart",
  map: "MapChart",
  tree: "TreeChart",
  treemap: "TreemapChart",
  graph: "GraphChart",
  gauge: "GaugeChart",
  funnel: "FunnelChart",
  parallel: "ParallelChart",
  sankey: "SankeyChart",
  boxplot: "BoxplotChart",
  candlestick: "CandlestickChart",
  effectScatter: "EffectScatterChart",
  lines: "LinesChart",
  heatmap: "HeatmapChart",
  pictorialBar: "PictorialBarChart",
  themeRiver: "ThemeRiverChart",
  sunburst: "SunburstChart",
  custom: "CustomChart"
}, A = {};
function he(u) {
  h(u, function(o, e) {
    if (!v.hasClass(e)) {
      var n = fe[e];
      n && !A[n] && (G("Component " + e + ` is used but not imported.
import { ` + n + ` } from 'echarts/components';
echarts.use([` + n + "]);"), A[n] = !0);
    }
  });
}
var ve = (
  /** @class */
  function(u) {
    X(o, u);
    function o() {
      return u !== null && u.apply(this, arguments) || this;
    }
    return o.prototype.init = function(e, n, t, r, i, p) {
      r = r || {}, this.option = null, this._theme = new b(r), this._locale = new b(i), this._optionManager = p;
    }, o.prototype.setOption = function(e, n, t) {
      process.env.NODE_ENV !== "production" && (w(e != null, "option is null/undefined"), w(e[k] !== Z, "please use chart.getOption()"));
      var r = W(n);
      this._optionManager.setOption(e, t, r), this._resetOption(null, r);
    }, o.prototype.resetOption = function(e, n) {
      return this._resetOption(e, W(n));
    }, o.prototype._resetOption = function(e, n) {
      var t = !1, r = this._optionManager;
      if (!e || e === "recreate") {
        var i = r.mountOption(e === "recreate");
        process.env.NODE_ENV !== "production" && he(i), !this.option || e === "recreate" ? K(this, i) : (this.restoreData(), this._mergeOption(i, n)), t = !0;
      }
      if ((e === "timeline" || e === "media") && this.restoreData(), !e || e === "recreate" || e === "timeline") {
        var p = r.getTimelineOption(this);
        p && (t = !0, this._mergeOption(p, n));
      }
      if (!e || e === "recreate" || e === "media") {
        var l = r.getMediaOption(this);
        l.length && h(l, function(s) {
          t = !0, this._mergeOption(s, n);
        }, this);
      }
      return t;
    }, o.prototype.mergeOption = function(e) {
      this._mergeOption(e, null);
    }, o.prototype._mergeOption = function(e, n) {
      var t = this.option, r = this._componentsMap, i = this._componentsCount, p = [], l = m(), s = n && n.replaceMergeMainTypeMap;
      ae(this), h(e, function(a, f) {
        a != null && (v.hasClass(f) ? f && (p.push(f), l.set(f, !0)) : t[f] = t[f] == null ? D(a) : L(t[f], a, !0));
      }), s && s.each(function(a, f) {
        v.hasClass(f) && !l.get(f) && (p.push(f), l.set(f, !0));
      }), v.topologicalTravel(p, v.getAllClassMainTypes(), C, this);
      function C(a) {
        var f = ue(this, a, I(e[a])), _ = r.get(a), M = (
          // `!oldCmptList` means init. See the comment in `mappingToExists`
          _ ? s && s.get(a) ? "replaceMerge" : "normalMerge" : "replaceAll"
        ), U = re(_, f, M);
        oe(U, a, v), t[a] = null, r.set(a, null), i.set(a, 0);
        var E = [], P = [], V = 0, F, R;
        h(U, function(d, Y) {
          var c = d.existing, y = d.newOption;
          if (!y)
            c && (c.mergeOption({}, this), c.optionUpdated({}, !1));
          else {
            var J = a === "series", B = v.getClass(
              a,
              d.keyInfo.subType,
              !J
              // Give a more detailed warn later if series don't exists
            );
            if (!B) {
              if (process.env.NODE_ENV !== "production") {
                var O = d.keyInfo.subType, N = ce[O];
                A[O] || (A[O] = !0, N ? G("Series " + O + ` is used but not imported.
import { ` + N + ` } from 'echarts/charts';
echarts.use([` + N + "]);") : G("Unknown series " + O));
              }
              return;
            }
            if (a === "tooltip") {
              if (F) {
                process.env.NODE_ENV !== "production" && (R || (pe("Currently only one tooltip component is allowed."), R = !0));
                return;
              }
              F = !0;
            }
            if (c && c.constructor === B)
              c.name = d.keyInfo.name, c.mergeOption(y, this), c.optionUpdated(y, !1);
            else {
              var z = H({
                componentIndex: Y
              }, d.keyInfo);
              c = new B(y, this, this, z), H(c, z), d.brandNew && (c.__requireNewView = !0), c.init(y, this, this), c.optionUpdated(null, !0);
            }
          }
          c ? (E.push(c.option), P.push(c), V++) : (E.push(void 0), P.push(void 0));
        }, this), t[a] = E, r.set(a, P), i.set(a, V), a === "series" && S(this);
      }
      this._seriesIndices || S(this);
    }, o.prototype.getOption = function() {
      var e = D(this.option);
      return h(e, function(n, t) {
        if (v.hasClass(t)) {
          for (var r = I(n), i = r.length, p = !1, l = i - 1; l >= 0; l--)
            r[l] && !ie(r[l]) ? p = !0 : (r[l] = null, !p && i--);
          r.length = i, e[t] = r;
        }
      }), delete e[k], e;
    }, o.prototype.getTheme = function() {
      return this._theme;
    }, o.prototype.getLocaleModel = function() {
      return this._locale;
    }, o.prototype.setUpdatePayload = function(e) {
      this._payload = e;
    }, o.prototype.getUpdatePayload = function() {
      return this._payload;
    }, o.prototype.getComponent = function(e, n) {
      var t = this._componentsMap.get(e);
      if (t) {
        var r = t[n || 0];
        if (r)
          return r;
        if (n == null) {
          for (var i = 0; i < t.length; i++)
            if (t[i])
              return t[i];
        }
      }
    }, o.prototype.queryComponents = function(e) {
      var n = e.mainType;
      if (!n)
        return [];
      var t = e.index, r = e.id, i = e.name, p = this._componentsMap.get(n);
      if (!p || !p.length)
        return [];
      var l;
      return t != null ? (l = [], h(I(t), function(s) {
        p[s] && l.push(p[s]);
      })) : r != null ? l = q("id", r, p) : i != null ? l = q("name", i, p) : l = g(p, function(s) {
        return !!s;
      }), Q(l, e);
    }, o.prototype.findComponents = function(e) {
      var n = e.query, t = e.mainType, r = p(n), i = r ? this.queryComponents(r) : g(this._componentsMap.get(t), function(s) {
        return !!s;
      });
      return l(Q(i, e));
      function p(s) {
        var C = t + "Index", a = t + "Id", f = t + "Name";
        return s && (s[C] != null || s[a] != null || s[f] != null) ? {
          mainType: t,
          // subType will be filtered finally.
          index: s[C],
          id: s[a],
          name: s[f]
        } : null;
      }
      function l(s) {
        return e.filter ? g(s, e.filter) : s;
      }
    }, o.prototype.eachComponent = function(e, n, t) {
      var r = this._componentsMap;
      if ($(e)) {
        var i = n, p = e;
        r.each(function(a, f) {
          for (var _ = 0; a && _ < a.length; _++) {
            var M = a[_];
            M && p.call(i, f, M, M.componentIndex);
          }
        });
      } else
        for (var l = ee(e) ? r.get(e) : j(e) ? this.findComponents(e) : null, s = 0; l && s < l.length; s++) {
          var C = l[s];
          C && n.call(t, C, C.componentIndex);
        }
    }, o.prototype.getSeriesByName = function(e) {
      var n = T(e, null);
      return g(this._componentsMap.get("series"), function(t) {
        return !!t && n != null && t.name === n;
      });
    }, o.prototype.getSeriesByIndex = function(e) {
      return this._componentsMap.get("series")[e];
    }, o.prototype.getSeriesByType = function(e) {
      return g(this._componentsMap.get("series"), function(n) {
        return !!n && n.subType === e;
      });
    }, o.prototype.getSeries = function() {
      return g(this._componentsMap.get("series"), function(e) {
        return !!e;
      });
    }, o.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, o.prototype.eachSeries = function(e, n) {
      x(this), h(this._seriesIndices, function(t) {
        var r = this._componentsMap.get("series")[t];
        e.call(n, r, t);
      }, this);
    }, o.prototype.eachRawSeries = function(e, n) {
      h(this._componentsMap.get("series"), function(t) {
        t && e.call(n, t, t.componentIndex);
      });
    }, o.prototype.eachSeriesByType = function(e, n, t) {
      x(this), h(this._seriesIndices, function(r) {
        var i = this._componentsMap.get("series")[r];
        i.subType === e && n.call(t, i, r);
      }, this);
    }, o.prototype.eachRawSeriesByType = function(e, n, t) {
      return h(this.getSeriesByType(e), n, t);
    }, o.prototype.isSeriesFiltered = function(e) {
      return x(this), this._seriesIndicesMap.get(e.componentIndex) == null;
    }, o.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, o.prototype.filterSeries = function(e, n) {
      x(this);
      var t = [];
      h(this._seriesIndices, function(r) {
        var i = this._componentsMap.get("series")[r];
        e.call(n, i, r) && t.push(r);
      }, this), this._seriesIndices = t, this._seriesIndicesMap = m(t);
    }, o.prototype.restoreData = function(e) {
      S(this);
      var n = this._componentsMap, t = [];
      n.each(function(r, i) {
        v.hasClass(i) && t.push(i);
      }), v.topologicalTravel(t, v.getAllClassMainTypes(), function(r) {
        h(n.get(r), function(i) {
          i && (r !== "series" || !ge(i, e)) && i.restoreData();
        });
      });
    }, o.internalField = function() {
      S = function(e) {
        var n = e._seriesIndices = [];
        h(e._componentsMap.get("series"), function(t) {
          t && n.push(t.componentIndex);
        }), e._seriesIndicesMap = m(n);
      }, x = function(e) {
        if (process.env.NODE_ENV !== "production" && !e._seriesIndices)
          throw new Error("Option should contains series.");
      }, K = function(e, n) {
        e.option = {}, e.option[k] = Z, e._componentsMap = m({
          series: []
        }), e._componentsCount = m();
        var t = n.aria;
        j(t) && t.enabled == null && (t.enabled = !0), Ce(n, e._theme.option), L(n, se, !1), e._mergeOption(n, null);
      };
    }(), o;
  }(b)
);
function ge(u, o) {
  if (o) {
    var e = o.seriesIndex, n = o.seriesId, t = o.seriesName;
    return e != null && u.componentIndex !== e || n != null && u.id !== n || t != null && u.name !== t;
  }
}
function Ce(u, o) {
  var e = u.color && !u.colorLayer;
  h(o, function(n, t) {
    t === "colorLayer" && e || v.hasClass(t) || (typeof n == "object" ? u[t] = u[t] ? L(u[t], n, !1) : D(n) : u[t] == null && (u[t] = n));
  });
}
function q(u, o, e) {
  if (te(o)) {
    var n = m();
    return h(o, function(r) {
      if (r != null) {
        var i = T(r, null);
        i != null && n.set(r, !0);
      }
    }), g(e, function(r) {
      return r && n.get(r[u]);
    });
  } else {
    var t = T(o, null);
    return g(e, function(r) {
      return r && t != null && r[u] === t;
    });
  }
}
function Q(u, o) {
  return o.hasOwnProperty("subType") ? g(u, function(e) {
    return e && e.subType === o.subType;
  }) : u;
}
function W(u) {
  var o = m();
  return u && h(I(u.replaceMerge), function(e) {
    process.env.NODE_ENV !== "production" && w(v.hasClass(e), '"' + e + '" is not valid component main type in "replaceMerge"'), o.set(e, !0);
  }), {
    replaceMergeMainTypeMap: o
  };
}
ne(ve, le);
export {
  ve as default
};
//# sourceMappingURL=Global.mjs.map
