import { __extends as b } from "../../node_modules/tslib/tslib.es6.mjs";
import { assert as E, merge as g, isTypedArray as w, createHashMap as R, keys as x, isObject as C, mixin as A, each as k, curry as N, concatArray as B } from "../../../zrender/lib/core/util.mjs";
import L from "../../../zrender/lib/core/env.mjs";
import { defaultEmphasis as M, isNameSpecified as O, makeInner as F } from "../util/model.mjs";
import h from "./Component.mjs";
import { PaletteMixin as P } from "./mixin/palette.mjs";
import { DataFormatMixin as H } from "./mixin/dataFormat.mjs";
import { fetchLayoutMode as S, getLayoutParams as V, mergeLayoutParam as T } from "../util/layout.mjs";
import { createTask as j } from "../core/task.mjs";
import { mountExtend as U } from "../util/clazz.mjs";
import { SourceManager as z } from "../data/helper/sourceManager.mjs";
import { defaultSeriesFormatTooltip as G } from "../component/tooltip/seriesFormatTooltip.mjs";
var l = F();
function f(o, e) {
  return o.getName(e) || o.getId(e);
}
var K = "__universalTransitionEnabled", v = (
  /** @class */
  function(o) {
    b(e, o);
    function e() {
      var t = o !== null && o.apply(this, arguments) || this;
      return t._selectedDataIndicesMap = {}, t;
    }
    return e.prototype.init = function(t, a, r) {
      this.seriesIndex = this.componentIndex, this.dataTask = j({
        count: J,
        reset: Q
      }), this.dataTask.context = {
        model: this
      }, this.mergeDefaultAndTheme(t, r);
      var i = l(this).sourceManager = new z(this);
      i.prepareSource();
      var n = this.getInitialData(t, r);
      I(n, this), this.dataTask.context.data = n, process.env.NODE_ENV !== "production" && E(n, "getInitialData returned invalid data."), l(this).dataBeforeProcessed = n, _(this), this._initSelectedMapFromData(n);
    }, e.prototype.mergeDefaultAndTheme = function(t, a) {
      var r = S(this), i = r ? V(t) : {}, n = this.subType;
      h.hasClass(n) && (n += "Series"), g(t, a.getTheme().get(this.subType)), g(t, this.getDefaultOption()), M(t, "label", ["show"]), this.fillDataTextStyle(t.data), r && T(t, i, r);
    }, e.prototype.mergeOption = function(t, a) {
      t = g(this.option, t, !0), this.fillDataTextStyle(t.data);
      var r = S(this);
      r && T(this.option, t, r);
      var i = l(this).sourceManager;
      i.dirty(), i.prepareSource();
      var n = this.getInitialData(t, a);
      I(n, this), this.dataTask.dirty(), this.dataTask.context.data = n, l(this).dataBeforeProcessed = n, _(this), this._initSelectedMapFromData(n);
    }, e.prototype.fillDataTextStyle = function(t) {
      if (t && !w(t))
        for (var a = ["show"], r = 0; r < t.length; r++)
          t[r] && t[r].label && M(t[r], "label", a);
    }, e.prototype.getInitialData = function(t, a) {
    }, e.prototype.appendData = function(t) {
      var a = this.getRawData();
      a.appendData(t.data);
    }, e.prototype.getData = function(t) {
      var a = m(this);
      if (a) {
        var r = a.context.data;
        return t == null || !r.getLinkedData ? r : r.getLinkedData(t);
      } else
        return l(this).data;
    }, e.prototype.getAllData = function() {
      var t = this.getData();
      return t && t.getLinkedDataAll ? t.getLinkedDataAll() : [{
        data: t
      }];
    }, e.prototype.setData = function(t) {
      var a = m(this);
      if (a) {
        var r = a.context;
        r.outputData = t, a !== this.dataTask && (r.data = t);
      }
      l(this).data = t;
    }, e.prototype.getEncode = function() {
      var t = this.get("encode", !0);
      if (t)
        return R(t);
    }, e.prototype.getSourceManager = function() {
      return l(this).sourceManager;
    }, e.prototype.getSource = function() {
      return this.getSourceManager().getSource();
    }, e.prototype.getRawData = function() {
      return l(this).dataBeforeProcessed;
    }, e.prototype.getColorBy = function() {
      var t = this.get("colorBy");
      return t || "series";
    }, e.prototype.isColorBySeries = function() {
      return this.getColorBy() === "series";
    }, e.prototype.getBaseAxis = function() {
      var t = this.coordinateSystem;
      return t && t.getBaseAxis && t.getBaseAxis();
    }, e.prototype.formatTooltip = function(t, a, r) {
      return G({
        series: this,
        dataIndex: t,
        multipleSeries: a
      });
    }, e.prototype.isAnimationEnabled = function() {
      var t = this.ecModel;
      if (L.node && !(t && t.ssr))
        return !1;
      var a = this.getShallow("animation");
      return a && this.getData().count() > this.getShallow("animationThreshold") && (a = !1), !!a;
    }, e.prototype.restoreData = function() {
      this.dataTask.dirty();
    }, e.prototype.getColorFromPalette = function(t, a, r) {
      var i = this.ecModel, n = P.prototype.getColorFromPalette.call(this, t, a, r);
      return n || (n = i.getColorFromPalette(t, a, r)), n;
    }, e.prototype.coordDimToDataDim = function(t) {
      return this.getRawData().mapDimensionsAll(t);
    }, e.prototype.getProgressive = function() {
      return this.get("progressive");
    }, e.prototype.getProgressiveThreshold = function() {
      return this.get("progressiveThreshold");
    }, e.prototype.select = function(t, a) {
      this._innerSelect(this.getData(a), t);
    }, e.prototype.unselect = function(t, a) {
      var r = this.option.selectedMap;
      if (r) {
        var i = this.option.selectedMode, n = this.getData(a);
        if (i === "series" || r === "all") {
          this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
          return;
        }
        for (var s = 0; s < t.length; s++) {
          var u = t[s], c = f(n, u);
          r[c] = !1, this._selectedDataIndicesMap[c] = -1;
        }
      }
    }, e.prototype.toggleSelect = function(t, a) {
      for (var r = [], i = 0; i < t.length; i++)
        r[0] = t[i], this.isSelected(t[i], a) ? this.unselect(r, a) : this.select(r, a);
    }, e.prototype.getSelectedDataIndices = function() {
      if (this.option.selectedMap === "all")
        return [].slice.call(this.getData().getIndices());
      for (var t = this._selectedDataIndicesMap, a = x(t), r = [], i = 0; i < a.length; i++) {
        var n = t[a[i]];
        n >= 0 && r.push(n);
      }
      return r;
    }, e.prototype.isSelected = function(t, a) {
      var r = this.option.selectedMap;
      if (!r)
        return !1;
      var i = this.getData(a);
      return (r === "all" || r[f(i, t)]) && !i.getItemModel(t).get(["select", "disabled"]);
    }, e.prototype.isUniversalTransitionEnabled = function() {
      if (this[K])
        return !0;
      var t = this.option.universalTransition;
      return t ? t === !0 ? !0 : t && t.enabled : !1;
    }, e.prototype._innerSelect = function(t, a) {
      var r, i, n = this.option, s = n.selectedMode, u = a.length;
      if (!(!s || !u)) {
        if (s === "series")
          n.selectedMap = "all";
        else if (s === "multiple") {
          C(n.selectedMap) || (n.selectedMap = {});
          for (var c = n.selectedMap, d = 0; d < u; d++) {
            var y = a[d], p = f(t, y);
            c[p] = !0, this._selectedDataIndicesMap[p] = t.getRawIndex(y);
          }
        } else if (s === "single" || s === !0) {
          var D = a[u - 1], p = f(t, D);
          n.selectedMap = (r = {}, r[p] = !0, r), this._selectedDataIndicesMap = (i = {}, i[p] = t.getRawIndex(D), i);
        }
      }
    }, e.prototype._initSelectedMapFromData = function(t) {
      if (!this.option.selectedMap) {
        var a = [];
        t.hasItemOption && t.each(function(r) {
          var i = t.getRawDataItem(r);
          i && i.selected && a.push(r);
        }), a.length > 0 && this._innerSelect(t, a);
      }
    }, e.registerClass = function(t) {
      return h.registerClass(t);
    }, e.protoInitialize = function() {
      var t = e.prototype;
      t.type = "series.__base__", t.seriesIndex = 0, t.ignoreStyleOnData = !1, t.hasSymbolVisual = !1, t.defaultSymbol = "circle", t.visualStyleAccessPath = "itemStyle", t.visualDrawType = "fill";
    }(), e;
  }(h)
);
A(v, H);
A(v, P);
U(v, h);
function _(o) {
  var e = o.name;
  O(o) || (o.name = W(o) || e);
}
function W(o) {
  var e = o.getRawData(), t = e.mapDimensionsAll("seriesName"), a = [];
  return k(t, function(r) {
    var i = e.getDimensionInfo(r);
    i.displayName && a.push(i.displayName);
  }), a.join(" ");
}
function J(o) {
  return o.model.getRawData().count();
}
function Q(o) {
  var e = o.model;
  return e.setData(e.getRawData().cloneShallow()), X;
}
function X(o, e) {
  e.outputData && o.end > e.outputData.count() && e.model.getRawData().cloneShallow(e.outputData);
}
function I(o, e) {
  k(B(o.CHANGABLE_METHODS, o.DOWNSAMPLE_METHODS), function(t) {
    o.wrapMethod(t, N(Y, e));
  });
}
function Y(o, e) {
  var t = m(o);
  return t && t.setOutputEnd((e || this).count()), e;
}
function m(o) {
  var e = (o.ecModel || {}).scheduler, t = e && e.getPipeline(o.uid);
  if (t) {
    var a = t.currentTask;
    if (a) {
      var r = a.agentStubMap;
      r && (a = r.get(o.uid));
    }
    return a;
  }
}
export {
  K as SERIES_UNIVERSAL_TRANSITION_PROP,
  v as default
};
//# sourceMappingURL=Series.mjs.map
