import { __extends as re } from "../../node_modules/tslib/tslib.es6.mjs";
import { parseDate as H, nice as ne } from "../util/number.mjs";
import { format as ae, fullLeveledFormatter as X, getDefaultFormatPrecisionOfInterval as ue, getPrimaryTimeUnit as L, leveledFormat as ie, ONE_DAY as v, ONE_SECOND as W, ONE_MINUTE as Z, ONE_HOUR as F, ONE_YEAR as j, isPrimaryTimeUnit as se, timeUnits as oe, secondsSetterName as $, millisecondsSetterName as I, minutesSetterName as U, hoursSetterName as T, dateSetterName as C, monthSetterName as x, millisecondsGetterName as ce, secondsGetterName as fe, minutesGetterName as le, hoursGetterName as he, dateGetterName as ve, monthGetterName as me, fullYearGetterName as de, fullYearSetterName as ge, getUnitValue as J } from "../util/time.mjs";
import { contain as ye, normalize as Se, scale as _e } from "./helper.mjs";
import we from "./Interval.mjs";
import be from "./Scale.mjs";
import { warn as Ee } from "../util/log.mjs";
import { isNumber as Me, filter as K, map as De } from "../../../zrender/lib/core/util.mjs";
var Oe = function(r, n, e, t) {
  for (; e < t; ) {
    var a = e + t >>> 1;
    r[a][1] < n ? e = a + 1 : t = a;
  }
  return e;
}, Ne = (
  /** @class */
  function(r) {
    re(n, r);
    function n(e) {
      var t = r.call(this, e) || this;
      return t.type = "time", t;
    }
    return n.prototype.getLabel = function(e) {
      var t = this.getSetting("useUTC");
      return ae(e.value, X[ue(L(this._minLevelUnit))] || X.second, t, this.getSetting("locale"));
    }, n.prototype.getFormattedLabel = function(e, t, a) {
      var i = this.getSetting("useUTC"), s = this.getSetting("locale");
      return ie(e, t, a, s, i);
    }, n.prototype.getTicks = function() {
      var e = this._interval, t = this._extent, a = [];
      if (!e)
        return a;
      a.push({
        value: t[0],
        level: 0
      });
      var i = this.getSetting("useUTC"), s = Ye(this._minLevelUnit, this._approxInterval, i, t);
      return a = a.concat(s), a.push({
        value: t[1],
        level: 0
      }), a;
    }, n.prototype.calcNiceExtent = function(e) {
      var t = this._extent;
      if (t[0] === t[1] && (t[0] -= v, t[1] += v), t[1] === -1 / 0 && t[0] === 1 / 0) {
        var a = /* @__PURE__ */ new Date();
        t[1] = +new Date(a.getFullYear(), a.getMonth(), a.getDate()), t[0] = t[1] - v;
      }
      this.calcNiceTicks(e.splitNumber, e.minInterval, e.maxInterval);
    }, n.prototype.calcNiceTicks = function(e, t, a) {
      e = e || 10;
      var i = this._extent, s = i[1] - i[0];
      this._approxInterval = s / e, t != null && this._approxInterval < t && (this._approxInterval = t), a != null && this._approxInterval > a && (this._approxInterval = a);
      var g = k.length, y = Math.min(Oe(k, this._approxInterval, 0, g), g - 1);
      this._interval = k[y][1], this._minLevelUnit = k[Math.max(y - 1, 0)][0];
    }, n.prototype.parse = function(e) {
      return Me(e) ? e : +H(e);
    }, n.prototype.contain = function(e) {
      return ye(this.parse(e), this._extent);
    }, n.prototype.normalize = function(e) {
      return Se(this.parse(e), this._extent);
    }, n.prototype.scale = function(e) {
      return _e(e, this._extent);
    }, n.type = "time", n;
  }(we)
), k = [
  // Format                           interval
  ["second", W],
  ["minute", Z],
  ["hour", F],
  ["quarter-day", F * 6],
  ["half-day", F * 12],
  ["day", v * 1.2],
  ["half-week", v * 3.5],
  ["week", v * 7],
  ["month", v * 31],
  ["quarter", v * 95],
  ["half-year", j / 2],
  ["year", j]
  // 1Y
];
function Le(r, n, e, t) {
  var a = H(n), i = H(e), s = function(A) {
    return J(a, A, t) === J(i, A, t);
  }, g = function() {
    return s("year");
  }, y = function() {
    return g() && s("month");
  }, S = function() {
    return y() && s("day");
  }, l = function() {
    return S() && s("hour");
  }, _ = function() {
    return l() && s("minute");
  }, O = function() {
    return _() && s("second");
  }, u = function() {
    return O() && s("millisecond");
  };
  switch (r) {
    case "year":
      return g();
    case "month":
      return y();
    case "day":
      return S();
    case "hour":
      return l();
    case "minute":
      return _();
    case "second":
      return O();
    case "millisecond":
      return u();
  }
}
function Ae(r, n) {
  return r /= v, r > 16 ? 16 : r > 7.5 ? 7 : r > 3.5 ? 4 : r > 1.5 ? 2 : 1;
}
function ke(r) {
  var n = 30 * v;
  return r /= n, r > 6 ? 6 : r > 3 ? 3 : r > 2 ? 2 : 1;
}
function Fe(r) {
  return r /= F, r > 12 ? 12 : r > 6 ? 6 : r > 3.5 ? 4 : r > 2 ? 2 : 1;
}
function Q(r, n) {
  return r /= n ? Z : W, r > 30 ? 30 : r > 20 ? 20 : r > 15 ? 15 : r > 10 ? 10 : r > 5 ? 5 : r > 2 ? 2 : 1;
}
function Ge(r) {
  return ne(r);
}
function pe(r, n, e) {
  var t = new Date(r);
  switch (L(n)) {
    case "year":
    case "month":
      t[x(e)](0);
    case "day":
      t[C(e)](1);
    case "hour":
      t[T(e)](0);
    case "minute":
      t[U(e)](0);
    case "second":
      t[$(e)](0), t[I(e)](0);
  }
  return t.getTime();
}
function Ye(r, n, e, t) {
  var a = 1e4, i = oe, s = 0;
  function g(f, o, E, M, q, m, N) {
    for (var D = new Date(o), c = o, h = D[M](); c < E && c <= t[1]; )
      N.push({
        value: c
      }), h += f, D[q](h), c = D.getTime();
    N.push({
      value: c,
      notAdd: !0
    });
  }
  function y(f, o, E) {
    var M = [], q = !o.length;
    if (!Le(L(f), t[0], t[1], e)) {
      q && (o = [{
        // TODO Optimize. Not include so may ticks.
        value: pe(new Date(t[0]), f, e)
      }, {
        value: t[1]
      }]);
      for (var m = 0; m < o.length - 1; m++) {
        var N = o[m].value, D = o[m + 1].value;
        if (N !== D) {
          var c = void 0, h = void 0, d = void 0, V = !1;
          switch (f) {
            case "year":
              c = Math.max(1, Math.round(n / v / 365)), h = de(e), d = ge(e);
              break;
            case "half-year":
            case "quarter":
            case "month":
              c = ke(n), h = me(e), d = x(e);
              break;
            case "week":
            case "half-week":
            case "day":
              c = Ae(n), h = ve(e), d = C(e), V = !0;
              break;
            case "half-day":
            case "quarter-day":
            case "hour":
              c = Fe(n), h = he(e), d = T(e);
              break;
            case "minute":
              c = Q(n, !0), h = le(e), d = U(e);
              break;
            case "second":
              c = Q(n, !1), h = fe(e), d = $(e);
              break;
            case "millisecond":
              c = Ge(n), h = ce(e), d = I(e);
              break;
          }
          g(c, N, D, h, d, V, M), f === "year" && E.length > 1 && m === 0 && E.unshift({
            value: E[0].value - c
          });
        }
      }
      for (var m = 0; m < M.length; m++)
        E.push(M[m]);
      return M;
    }
  }
  for (var S = [], l = [], _ = 0, O = 0, u = 0; u < i.length && s++ < a; ++u) {
    var A = L(i[u]);
    if (se(i[u])) {
      y(i[u], S[S.length - 1] || [], l);
      var ee = i[u + 1] ? L(i[u + 1]) : null;
      if (A !== ee) {
        if (l.length) {
          O = _, l.sort(function(f, o) {
            return f.value - o.value;
          });
          for (var z = [], w = 0; w < l.length; ++w) {
            var G = l[w].value;
            (w === 0 || l[w - 1].value !== G) && (z.push(l[w]), G >= t[0] && G <= t[1] && _++);
          }
          var p = (t[1] - t[0]) / n;
          if (_ > p * 1.5 && O > p / 1.5 || (S.push(z), _ > p || r === i[u]))
            break;
        }
        l = [];
      }
    }
  }
  process.env.NODE_ENV !== "production" && s >= a && Ee("Exceed safe limit.");
  for (var Y = K(De(S, function(f) {
    return K(f, function(o) {
      return o.value >= t[0] && o.value <= t[1] && !o.notAdd;
    });
  }), function(f) {
    return f.length > 0;
  }), b = [], te = Y.length - 1, u = 0; u < Y.length; ++u)
    for (var R = Y[u], P = 0; P < R.length; ++P)
      b.push({
        value: R[P].value,
        level: te - u
      });
  b.sort(function(f, o) {
    return f.value - o.value;
  });
  for (var B = [], u = 0; u < b.length; ++u)
    (u === 0 || b[u].value !== b[u - 1].value) && B.push(b[u]);
  return B;
}
be.registerClass(Ne);
export {
  Ne as default
};
//# sourceMappingURL=Time.mjs.map
