import M, { TRANSFORMABLE_PROPS as V } from "./core/Transformable.mjs";
import U, { cloneValue as b } from "./animation/Animator.mjs";
import O from "./core/BoundingRect.mjs";
import j from "./core/Eventful.mjs";
import { calculateTextPosition as K, parsePercent as I } from "./contain/text.mjs";
import { reduce as k, extend as x, isObject as H, keys as W, indexOf as P, logError as F, mixin as Y, isArrayLike as R, isGradientObject as tt, filter as Z, guid as it, isTypedArray as rt } from "./core/util.mjs";
import { LIGHT_LABEL_COLOR as et, DARK_LABEL_COLOR as ot } from "./config.mjs";
import { parse as nt, stringify as st } from "./tool/color.mjs";
import { REDRAW_BIT as y } from "./graphic/constants.mjs";
var L = "__zr_normal__", N = V.concat(["ignore"]), at = k(V, function(e, t) {
  return e[t] = !0, e;
}, { ignore: !1 }), w = {}, ht = new O(0, 0, 0, 0), X = function() {
  function e(t) {
    this.id = it(), this.animators = [], this.currentStates = [], this.states = {}, this._init(t);
  }
  return e.prototype._init = function(t) {
    this.attr(t);
  }, e.prototype.drift = function(t, i, r) {
    switch (this.draggable) {
      case "horizontal":
        i = 0;
        break;
      case "vertical":
        t = 0;
        break;
    }
    var n = this.transform;
    n || (n = this.transform = [1, 0, 0, 1, 0, 0]), n[4] += t, n[5] += i, this.decomposeTransform(), this.markRedraw();
  }, e.prototype.beforeUpdate = function() {
  }, e.prototype.afterUpdate = function() {
  }, e.prototype.update = function() {
    this.updateTransform(), this.__dirty && this.updateInnerText();
  }, e.prototype.updateInnerText = function(t) {
    var i = this._textContent;
    if (i && (!i.ignore || t)) {
      this.textConfig || (this.textConfig = {});
      var r = this.textConfig, n = r.local, o = i.innerTransformable, s = void 0, f = void 0, h = !1;
      o.parent = n ? this : null;
      var v = !1;
      if (o.copyTransform(i), r.position != null) {
        var a = ht;
        r.layoutRect ? a.copy(r.layoutRect) : a.copy(this.getBoundingRect()), n || a.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(w, r, a) : K(w, r, a), o.x = w.x, o.y = w.y, s = w.align, f = w.verticalAlign;
        var p = r.origin;
        if (p && r.rotation != null) {
          var _ = void 0, m = void 0;
          p === "center" ? (_ = a.width * 0.5, m = a.height * 0.5) : (_ = I(p[0], a.width), m = I(p[1], a.height)), v = !0, o.originX = -o.x + _ + (n ? 0 : a.x), o.originY = -o.y + m + (n ? 0 : a.y);
        }
      }
      r.rotation != null && (o.rotation = r.rotation);
      var d = r.offset;
      d && (o.x += d[0], o.y += d[1], v || (o.originX = -d[0], o.originY = -d[1]));
      var l = r.inside == null ? typeof r.position == "string" && r.position.indexOf("inside") >= 0 : r.inside, c = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), u = void 0, g = void 0, C = void 0;
      l && this.canBeInsideText() ? (u = r.insideFill, g = r.insideStroke, (u == null || u === "auto") && (u = this.getInsideTextFill()), (g == null || g === "auto") && (g = this.getInsideTextStroke(u), C = !0)) : (u = r.outsideFill, g = r.outsideStroke, (u == null || u === "auto") && (u = this.getOutsideFill()), (g == null || g === "auto") && (g = this.getOutsideStroke(u), C = !0)), u = u || "#000", (u !== c.fill || g !== c.stroke || C !== c.autoStroke || s !== c.align || f !== c.verticalAlign) && (h = !0, c.fill = u, c.stroke = g, c.autoStroke = C, c.align = s, c.verticalAlign = f, i.setDefaultTextStyle(c)), i.__dirty |= y, h && i.dirtyStyle(!0);
    }
  }, e.prototype.canBeInsideText = function() {
    return !0;
  }, e.prototype.getInsideTextFill = function() {
    return "#fff";
  }, e.prototype.getInsideTextStroke = function(t) {
    return "#000";
  }, e.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? et : ot;
  }, e.prototype.getOutsideStroke = function(t) {
    var i = this.__zr && this.__zr.getBackgroundColor(), r = typeof i == "string" && nt(i);
    r || (r = [255, 255, 255, 1]);
    for (var n = r[3], o = this.__zr.isDarkMode(), s = 0; s < 3; s++)
      r[s] = r[s] * n + (o ? 0 : 255) * (1 - n);
    return r[3] = 1, st(r, "rgba");
  }, e.prototype.traverse = function(t, i) {
  }, e.prototype.attrKV = function(t, i) {
    t === "textConfig" ? this.setTextConfig(i) : t === "textContent" ? this.setTextContent(i) : t === "clipPath" ? this.setClipPath(i) : t === "extra" ? (this.extra = this.extra || {}, x(this.extra, i)) : this[t] = i;
  }, e.prototype.hide = function() {
    this.ignore = !0, this.markRedraw();
  }, e.prototype.show = function() {
    this.ignore = !1, this.markRedraw();
  }, e.prototype.attr = function(t, i) {
    if (typeof t == "string")
      this.attrKV(t, i);
    else if (H(t))
      for (var r = t, n = W(r), o = 0; o < n.length; o++) {
        var s = n[o];
        this.attrKV(s, t[s]);
      }
    return this.markRedraw(), this;
  }, e.prototype.saveCurrentToNormalState = function(t) {
    this._innerSaveToNormal(t);
    for (var i = this._normalState, r = 0; r < this.animators.length; r++) {
      var n = this.animators[r], o = n.__fromStateTransition;
      if (!(n.getLoop() || o && o !== L)) {
        var s = n.targetName, f = s ? i[s] : i;
        n.saveTo(f);
      }
    }
  }, e.prototype._innerSaveToNormal = function(t) {
    var i = this._normalState;
    i || (i = this._normalState = {}), t.textConfig && !i.textConfig && (i.textConfig = this.textConfig), this._savePrimaryToNormal(t, i, N);
  }, e.prototype._savePrimaryToNormal = function(t, i, r) {
    for (var n = 0; n < r.length; n++) {
      var o = r[n];
      t[o] != null && !(o in i) && (i[o] = this[o]);
    }
  }, e.prototype.hasState = function() {
    return this.currentStates.length > 0;
  }, e.prototype.getState = function(t) {
    return this.states[t];
  }, e.prototype.ensureState = function(t) {
    var i = this.states;
    return i[t] || (i[t] = {}), i[t];
  }, e.prototype.clearStates = function(t) {
    this.useState(L, !1, t);
  }, e.prototype.useState = function(t, i, r, n) {
    var o = t === L, s = this.hasState();
    if (!(!s && o)) {
      var f = this.currentStates, h = this.stateTransition;
      if (!(P(f, t) >= 0 && (i || f.length === 1))) {
        var v;
        if (this.stateProxy && !o && (v = this.stateProxy(t)), v || (v = this.states && this.states[t]), !v && !o) {
          F("State " + t + " not exists.");
          return;
        }
        o || this.saveCurrentToNormalState(v);
        var a = !!(v && v.hoverLayer || n);
        a && this._toggleHoverLayerFlag(!0), this._applyStateObj(t, v, this._normalState, i, !r && !this.__inHover && h && h.duration > 0, h);
        var p = this._textContent, _ = this._textGuide;
        return p && p.useState(t, i, r, a), _ && _.useState(t, i, r, a), o ? (this.currentStates = [], this._normalState = {}) : i ? this.currentStates.push(t) : this.currentStates = [t], this._updateAnimationTargets(), this.markRedraw(), !a && this.__inHover && (this._toggleHoverLayerFlag(!1), this.__dirty &= ~y), v;
      }
    }
  }, e.prototype.useStates = function(t, i, r) {
    if (!t.length)
      this.clearStates();
    else {
      var n = [], o = this.currentStates, s = t.length, f = s === o.length;
      if (f) {
        for (var h = 0; h < s; h++)
          if (t[h] !== o[h]) {
            f = !1;
            break;
          }
      }
      if (f)
        return;
      for (var h = 0; h < s; h++) {
        var v = t[h], a = void 0;
        this.stateProxy && (a = this.stateProxy(v, t)), a || (a = this.states[v]), a && n.push(a);
      }
      var p = n[s - 1], _ = !!(p && p.hoverLayer || r);
      _ && this._toggleHoverLayerFlag(!0);
      var m = this._mergeStates(n), d = this.stateTransition;
      this.saveCurrentToNormalState(m), this._applyStateObj(t.join(","), m, this._normalState, !1, !i && !this.__inHover && d && d.duration > 0, d);
      var l = this._textContent, c = this._textGuide;
      l && l.useStates(t, i, _), c && c.useStates(t, i, _), this._updateAnimationTargets(), this.currentStates = t.slice(), this.markRedraw(), !_ && this.__inHover && (this._toggleHoverLayerFlag(!1), this.__dirty &= ~y);
    }
  }, e.prototype.isSilent = function() {
    for (var t = this.silent, i = this.parent; !t && i; ) {
      if (i.silent) {
        t = !0;
        break;
      }
      i = i.parent;
    }
    return t;
  }, e.prototype._updateAnimationTargets = function() {
    for (var t = 0; t < this.animators.length; t++) {
      var i = this.animators[t];
      i.targetName && i.changeTarget(this[i.targetName]);
    }
  }, e.prototype.removeState = function(t) {
    var i = P(this.currentStates, t);
    if (i >= 0) {
      var r = this.currentStates.slice();
      r.splice(i, 1), this.useStates(r);
    }
  }, e.prototype.replaceState = function(t, i, r) {
    var n = this.currentStates.slice(), o = P(n, t), s = P(n, i) >= 0;
    o >= 0 ? s ? n.splice(o, 1) : n[o] = i : r && !s && n.push(i), this.useStates(n);
  }, e.prototype.toggleState = function(t, i) {
    i ? this.useState(t, !0) : this.removeState(t);
  }, e.prototype._mergeStates = function(t) {
    for (var i = {}, r, n = 0; n < t.length; n++) {
      var o = t[n];
      x(i, o), o.textConfig && (r = r || {}, x(r, o.textConfig));
    }
    return r && (i.textConfig = r), i;
  }, e.prototype._applyStateObj = function(t, i, r, n, o, s) {
    var f = !(i && n);
    i && i.textConfig ? (this.textConfig = x({}, n ? this.textConfig : r.textConfig), x(this.textConfig, i.textConfig)) : f && r.textConfig && (this.textConfig = r.textConfig);
    for (var h = {}, v = !1, a = 0; a < N.length; a++) {
      var p = N[a], _ = o && at[p];
      i && i[p] != null ? _ ? (v = !0, h[p] = i[p]) : this[p] = i[p] : f && r[p] != null && (_ ? (v = !0, h[p] = r[p]) : this[p] = r[p]);
    }
    if (!o)
      for (var a = 0; a < this.animators.length; a++) {
        var m = this.animators[a], d = m.targetName;
        m.getLoop() || m.__changeFinalValue(d ? (i || r)[d] : i || r);
      }
    v && this._transitionState(t, h, s);
  }, e.prototype._attachComponent = function(t) {
    if (t.__zr && !t.__hostTarget) {
      if (process.env.NODE_ENV !== "production")
        throw new Error("Text element has been added to zrender.");
      return;
    }
    if (t === this) {
      if (process.env.NODE_ENV !== "production")
        throw new Error("Recursive component attachment.");
      return;
    }
    var i = this.__zr;
    i && t.addSelfToZr(i), t.__zr = i, t.__hostTarget = this;
  }, e.prototype._detachComponent = function(t) {
    t.__zr && t.removeSelfFromZr(t.__zr), t.__zr = null, t.__hostTarget = null;
  }, e.prototype.getClipPath = function() {
    return this._clipPath;
  }, e.prototype.setClipPath = function(t) {
    this._clipPath && this._clipPath !== t && this.removeClipPath(), this._attachComponent(t), this._clipPath = t, this.markRedraw();
  }, e.prototype.removeClipPath = function() {
    var t = this._clipPath;
    t && (this._detachComponent(t), this._clipPath = null, this.markRedraw());
  }, e.prototype.getTextContent = function() {
    return this._textContent;
  }, e.prototype.setTextContent = function(t) {
    var i = this._textContent;
    if (i !== t) {
      if (i && i !== t && this.removeTextContent(), process.env.NODE_ENV !== "production" && t.__zr && !t.__hostTarget)
        throw new Error("Text element has been added to zrender.");
      t.innerTransformable = new M(), this._attachComponent(t), this._textContent = t, this.markRedraw();
    }
  }, e.prototype.setTextConfig = function(t) {
    this.textConfig || (this.textConfig = {}), x(this.textConfig, t), this.markRedraw();
  }, e.prototype.removeTextConfig = function() {
    this.textConfig = null, this.markRedraw();
  }, e.prototype.removeTextContent = function() {
    var t = this._textContent;
    t && (t.innerTransformable = null, this._detachComponent(t), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
  }, e.prototype.getTextGuideLine = function() {
    return this._textGuide;
  }, e.prototype.setTextGuideLine = function(t) {
    this._textGuide && this._textGuide !== t && this.removeTextGuideLine(), this._attachComponent(t), this._textGuide = t, this.markRedraw();
  }, e.prototype.removeTextGuideLine = function() {
    var t = this._textGuide;
    t && (this._detachComponent(t), this._textGuide = null, this.markRedraw());
  }, e.prototype.markRedraw = function() {
    this.__dirty |= y;
    var t = this.__zr;
    t && (this.__inHover ? t.refreshHover() : t.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
  }, e.prototype.dirty = function() {
    this.markRedraw();
  }, e.prototype._toggleHoverLayerFlag = function(t) {
    this.__inHover = t;
    var i = this._textContent, r = this._textGuide;
    i && (i.__inHover = t), r && (r.__inHover = t);
  }, e.prototype.addSelfToZr = function(t) {
    if (this.__zr !== t) {
      this.__zr = t;
      var i = this.animators;
      if (i)
        for (var r = 0; r < i.length; r++)
          t.animation.addAnimator(i[r]);
      this._clipPath && this._clipPath.addSelfToZr(t), this._textContent && this._textContent.addSelfToZr(t), this._textGuide && this._textGuide.addSelfToZr(t);
    }
  }, e.prototype.removeSelfFromZr = function(t) {
    if (this.__zr) {
      this.__zr = null;
      var i = this.animators;
      if (i)
        for (var r = 0; r < i.length; r++)
          t.animation.removeAnimator(i[r]);
      this._clipPath && this._clipPath.removeSelfFromZr(t), this._textContent && this._textContent.removeSelfFromZr(t), this._textGuide && this._textGuide.removeSelfFromZr(t);
    }
  }, e.prototype.animate = function(t, i, r) {
    var n = t ? this[t] : this;
    if (process.env.NODE_ENV !== "production" && !n) {
      F('Property "' + t + '" is not existed in element ' + this.id);
      return;
    }
    var o = new U(n, i, r);
    return t && (o.targetName = t), this.addAnimator(o, t), o;
  }, e.prototype.addAnimator = function(t, i) {
    var r = this.__zr, n = this;
    t.during(function() {
      n.updateDuringAnimation(i);
    }).done(function() {
      var o = n.animators, s = P(o, t);
      s >= 0 && o.splice(s, 1);
    }), this.animators.push(t), r && r.animation.addAnimator(t), r && r.wakeUp();
  }, e.prototype.updateDuringAnimation = function(t) {
    this.markRedraw();
  }, e.prototype.stopAnimation = function(t, i) {
    for (var r = this.animators, n = r.length, o = [], s = 0; s < n; s++) {
      var f = r[s];
      !t || t === f.scope ? f.stop(i) : o.push(f);
    }
    return this.animators = o, this;
  }, e.prototype.animateTo = function(t, i, r) {
    D(this, t, i, r);
  }, e.prototype.animateFrom = function(t, i, r) {
    D(this, t, i, r, !0);
  }, e.prototype._transitionState = function(t, i, r, n) {
    for (var o = D(this, i, r, n), s = 0; s < o.length; s++)
      o[s].__fromStateTransition = t;
  }, e.prototype.getBoundingRect = function() {
    return null;
  }, e.prototype.getPaintRect = function() {
    return null;
  }, e.initDefaultProps = function() {
    var t = e.prototype;
    t.type = "element", t.name = "", t.ignore = t.silent = t.isGroup = t.draggable = t.dragging = t.ignoreClip = t.__inHover = !1, t.__dirty = y;
    var i = {};
    function r(o, s, f) {
      i[o + s + f] || (console.warn("DEPRECATED: '" + o + "' has been deprecated. use '" + s + "', '" + f + "' instead"), i[o + s + f] = !0);
    }
    function n(o, s, f, h) {
      Object.defineProperty(t, o, {
        get: function() {
          if (process.env.NODE_ENV !== "production" && r(o, f, h), !this[s]) {
            var a = this[s] = [];
            v(this, a);
          }
          return this[s];
        },
        set: function(a) {
          process.env.NODE_ENV !== "production" && r(o, f, h), this[f] = a[0], this[h] = a[1], this[s] = a, v(this, a);
        }
      });
      function v(a, p) {
        Object.defineProperty(p, 0, {
          get: function() {
            return a[f];
          },
          set: function(_) {
            a[f] = _;
          }
        }), Object.defineProperty(p, 1, {
          get: function() {
            return a[h];
          },
          set: function(_) {
            a[h] = _;
          }
        });
      }
    }
    Object.defineProperty && (n("position", "_legacyPos", "x", "y"), n("scale", "_legacyScale", "scaleX", "scaleY"), n("origin", "_legacyOrigin", "originX", "originY"));
  }(), e;
}();
Y(X, j);
Y(X, M);
function D(e, t, i, r, n) {
  i = i || {};
  var o = [];
  q(e, "", e, t, i, r, o, n);
  var s = o.length, f = !1, h = i.done, v = i.aborted, a = function() {
    f = !0, s--, s <= 0 && (f ? h && h() : v && v());
  }, p = function() {
    s--, s <= 0 && (f ? h && h() : v && v());
  };
  s || h && h(), o.length > 0 && i.during && o[0].during(function(d, l) {
    i.during(l);
  });
  for (var _ = 0; _ < o.length; _++) {
    var m = o[_];
    a && m.done(a), p && m.aborted(p), i.force && m.duration(i.duration), m.start(i.easing);
  }
  return o;
}
function z(e, t, i) {
  for (var r = 0; r < i; r++)
    e[r] = t[r];
}
function ft(e) {
  return R(e[0]);
}
function ut(e, t, i) {
  if (R(t[i]))
    if (R(e[i]) || (e[i] = []), rt(t[i])) {
      var r = t[i].length;
      e[i].length !== r && (e[i] = new t[i].constructor(r), z(e[i], t[i], r));
    } else {
      var n = t[i], o = e[i], s = n.length;
      if (ft(n))
        for (var f = n[0].length, h = 0; h < s; h++)
          o[h] ? z(o[h], n[h], f) : o[h] = Array.prototype.slice.call(n[h]);
      else
        z(o, n, s);
      o.length = n.length;
    }
  else
    e[i] = t[i];
}
function pt(e, t) {
  return e === t || R(e) && R(t) && vt(e, t);
}
function vt(e, t) {
  var i = e.length;
  if (i !== t.length)
    return !1;
  for (var r = 0; r < i; r++)
    if (e[r] !== t[r])
      return !1;
  return !0;
}
function q(e, t, i, r, n, o, s, f) {
  for (var h = W(r), v = n.duration, a = n.delay, p = n.additive, _ = n.setToFinal, m = !H(o), d = e.animators, l = [], c = 0; c < h.length; c++) {
    var u = h[c], g = r[u];
    if (g != null && i[u] != null && (m || o[u]))
      if (H(g) && !R(g) && !tt(g)) {
        if (t) {
          f || (i[u] = g, e.updateDuringAnimation(t));
          continue;
        }
        q(e, u, i[u], g, n, o && o[u], s, f);
      } else
        l.push(u);
    else
      f || (i[u] = g, e.updateDuringAnimation(t), l.push(u));
  }
  var C = l.length;
  if (!p && C)
    for (var T = 0; T < d.length; T++) {
      var S = d[T];
      if (S.targetName === t) {
        var J = S.stopTracks(l);
        if (J) {
          var Q = P(d, S);
          d.splice(Q, 1);
        }
      }
    }
  if (n.force || (l = Z(l, function(B) {
    return !pt(r[B], i[B]);
  }), C = l.length), C > 0 || n.force && !s.length) {
    var A = void 0, G = void 0, E = void 0;
    if (f) {
      G = {}, _ && (A = {});
      for (var T = 0; T < C; T++) {
        var u = l[T];
        G[u] = i[u], _ ? A[u] = r[u] : i[u] = r[u];
      }
    } else if (_) {
      E = {};
      for (var T = 0; T < C; T++) {
        var u = l[T];
        E[u] = b(i[u]), ut(i, r, u);
      }
    }
    var S = new U(i, !1, !1, p ? Z(d, function($) {
      return $.targetName === t;
    }) : null);
    S.targetName = t, n.scope && (S.scope = n.scope), _ && A && S.whenWithKeys(0, A, l), E && S.whenWithKeys(0, E, l), S.whenWithKeys(v ?? 500, f ? G : r, l).delay(a || 0), e.addAnimator(S, t), s.push(S);
  }
}
export {
  L as PRESERVED_NORMAL_STATE,
  X as default
};
//# sourceMappingURL=Element.mjs.map
