import { isLinearGradient as $, isRadialGradient as H, round4 as W, normalizeColor as Z, getIdURL as R, isImagePattern as rr, getSRTTransformString as tr, getPathPrecision as ar, adjustTextY as nr, TEXT_ALIGN_TO_ANCHOR as ir, isGradient as er, isPattern as or, getMatrixStr as fr, hasShadow as sr, getShadowKey as vr, isAroundZero as T } from "./helper.mjs";
import hr from "../graphic/Path.mjs";
import dr from "../graphic/Image.mjs";
import { getLineHeight as ur } from "../contain/text.mjs";
import pr from "../graphic/TSpan.mjs";
import lr from "./SVGPathRebuilder.mjs";
import cr from "./mapStyleToAttrs.mjs";
import { vNodeToString as B, createVNode as y, META_DATA_PREFIX as j } from "./core.mjs";
import { retrieve2 as U, logError as gr, isString as G, assert as k, clone as yr, isFunction as mr, map as Sr } from "../core/util.mjs";
import { createOrUpdateImage as xr } from "../graphic/helper/image.mjs";
import { createCSSAnimation as O } from "./cssAnimation.mjs";
import { hasSeparateFont as Pr, parseFontSize as wr } from "../graphic/Text.mjs";
import { DEFAULT_FONT as Ar, DEFAULT_FONT_FAMILY as Tr } from "../core/platform.mjs";
import { createCSSEmphasis as br } from "./cssEmphasis.mjs";
import { getElementSSRData as Cr } from "../zrender.mjs";
var b = Math.round;
function q(r) {
  return r && G(r.src);
}
function J(r) {
  return r && mr(r.toDataURL);
}
function F(r, i, t, a) {
  cr(function(n, e) {
    var o = n === "fill" || n === "stroke";
    o && er(e) ? Fr(i, r, n, a) : o && or(e) ? Vr(t, r, n, a) : o && e === "none" ? r[n] = "transparent" : r[n] = e;
  }, i, t, !1), Or(t, r, a);
}
function V(r, i) {
  var t = Cr(i);
  t && (t.each(function(a, n) {
    a != null && (r[(j + n).toLowerCase()] = a + "");
  }), i.isSilent() && (r[j + "silent"] = "true"));
}
function K(r) {
  return T(r[0] - 1) && T(r[1]) && T(r[2]) && T(r[3] - 1);
}
function Dr(r) {
  return T(r[4]) && T(r[5]);
}
function I(r, i, t) {
  if (i && !(Dr(i) && K(i))) {
    var a = 1e4;
    r.transform = K(i) ? "translate(" + b(i[4] * a) / a + " " + b(i[5] * a) / a + ")" : fr(i);
  }
}
function X(r, i, t) {
  for (var a = r.points, n = [], e = 0; e < a.length; e++)
    n.push(b(a[e][0] * t) / t), n.push(b(a[e][1] * t) / t);
  i.points = n.join(" ");
}
function Y(r) {
  return !r.smooth;
}
function Rr(r) {
  var i = Sr(r, function(t) {
    return typeof t == "string" ? [t, t] : t;
  });
  return function(t, a, n) {
    for (var e = 0; e < i.length; e++) {
      var o = i[e], s = t[o[0]];
      s != null && (a[o[1]] = b(s * n) / n);
    }
  };
}
var Nr = {
  circle: [Rr(["cx", "cy", "r"])],
  polyline: [X, Y],
  polygon: [X, Y]
};
function Lr(r) {
  for (var i = r.animators, t = 0; t < i.length; t++)
    if (i[t].targetName === "shape")
      return !0;
  return !1;
}
function Q(r, i) {
  var t = r.style, a = r.shape, n = Nr[r.type], e = {}, o = i.animation, s = "path", f = r.style.strokePercent, v = i.compress && ar(r) || 4;
  if (n && !i.willUpdate && !(n[1] && !n[1](a)) && !(o && Lr(r)) && !(f < 1)) {
    s = r.type;
    var g = Math.pow(10, v);
    n[0](a, e, g);
  } else {
    var l = !r.path || r.shapeChanged();
    r.path || r.createPathProxy();
    var d = r.path;
    l && (d.beginPath(), r.buildPath(d, r.shape), r.pathUpdated());
    var h = d.getVersion(), p = r, u = p.__svgPathBuilder;
    (p.__svgPathVersion !== h || !u || f !== p.__svgPathStrokePercent) && (u || (u = p.__svgPathBuilder = new lr()), u.reset(v), d.rebuildPath(u, f), u.generateStr(), p.__svgPathVersion = h, p.__svgPathStrokePercent = f), e.d = u.getStr();
  }
  return I(e, r.transform), F(e, t, r, i), V(e, r), i.animation && O(r, e, i), i.emphasis && br(r, e, i), y(s, r.id + "", e);
}
function Ur(r, i) {
  var t = r.style, a = t.image;
  if (a && !G(a) && (q(a) ? a = a.src : J(a) && (a = a.toDataURL())), !!a) {
    var n = t.x || 0, e = t.y || 0, o = t.width, s = t.height, f = {
      href: a,
      width: o,
      height: s
    };
    return n && (f.x = n), e && (f.y = e), I(f, r.transform), F(f, t, r, i), V(f, r), i.animation && O(r, f, i), y("image", r.id + "", f);
  }
}
function Gr(r, i) {
  var t = r.style, a = t.text;
  if (a != null && (a += ""), !(!a || isNaN(t.x) || isNaN(t.y))) {
    var n = t.font || Ar, e = t.x || 0, o = nr(t.y || 0, ur(n), t.textBaseline), s = ir[t.textAlign] || t.textAlign, f = {
      "dominant-baseline": "central",
      "text-anchor": s
    };
    if (Pr(t)) {
      var v = "", g = t.fontStyle, l = wr(t.fontSize);
      if (!parseFloat(l))
        return;
      var d = t.fontFamily || Tr, h = t.fontWeight;
      v += "font-size:" + l + ";font-family:" + d + ";", g && g !== "normal" && (v += "font-style:" + g + ";"), h && h !== "normal" && (v += "font-weight:" + h + ";"), f.style = v;
    } else
      f.style = "font: " + n;
    return a.match(/\s/) && (f["xml:space"] = "preserve"), e && (f.x = e), o && (f.y = o), I(f, r.transform), F(f, t, r, i), V(f, r), i.animation && O(r, f, i), y("text", r.id + "", f, void 0, a);
  }
}
function $r(r, i) {
  if (r instanceof hr)
    return Q(r, i);
  if (r instanceof dr)
    return Ur(r, i);
  if (r instanceof pr)
    return Gr(r, i);
}
function Or(r, i, t) {
  var a = r.style;
  if (sr(a)) {
    var n = vr(r), e = t.shadowCache, o = e[n];
    if (!o) {
      var s = r.getGlobalScale(), f = s[0], v = s[1];
      if (!f || !v)
        return;
      var g = a.shadowOffsetX || 0, l = a.shadowOffsetY || 0, d = a.shadowBlur, h = Z(a.shadowColor), p = h.opacity, u = h.color, x = d / 2 / f, A = d / 2 / v, m = x + " " + A;
      o = t.zrId + "-s" + t.shadowIdx++, t.defs[o] = y("filter", o, {
        id: o,
        x: "-100%",
        y: "-100%",
        width: "300%",
        height: "300%"
      }, [
        y("feDropShadow", "", {
          dx: g / f,
          dy: l / v,
          stdDeviation: m,
          "flood-color": u,
          "flood-opacity": p
        })
      ]), e[n] = o;
    }
    i.filter = R(o);
  }
}
function Fr(r, i, t, a) {
  var n = r[t], e, o = {
    gradientUnits: n.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if ($(n))
    e = "linearGradient", o.x1 = n.x, o.y1 = n.y, o.x2 = n.x2, o.y2 = n.y2;
  else if (H(n))
    e = "radialGradient", o.cx = U(n.x, 0.5), o.cy = U(n.y, 0.5), o.r = U(n.r, 0.5);
  else {
    process.env.NODE_ENV !== "production" && gr("Illegal gradient type.");
    return;
  }
  for (var s = n.colorStops, f = [], v = 0, g = s.length; v < g; ++v) {
    var l = W(s[v].offset) * 100 + "%", d = s[v].color, h = Z(d), p = h.color, u = h.opacity, x = {
      offset: l
    };
    x["stop-color"] = p, u < 1 && (x["stop-opacity"] = u), f.push(y("stop", v + "", x));
  }
  var A = y(e, "", o, f), m = B(A), S = a.gradientCache, c = S[m];
  c || (c = a.zrId + "-g" + a.gradientIdx++, S[m] = c, o.id = c, a.defs[c] = y(e, c, o, f)), i[t] = R(c);
}
function Vr(r, i, t, a) {
  var n = r.style[t], e = r.getBoundingRect(), o = {}, s = n.repeat, f = s === "no-repeat", v = s === "repeat-x", g = s === "repeat-y", l;
  if (rr(n)) {
    var d = n.imageWidth, h = n.imageHeight, p = void 0, u = n.image;
    if (G(u) ? p = u : q(u) ? p = u.src : J(u) && (p = u.toDataURL()), typeof Image > "u") {
      var x = "Image width/height must been given explictly in svg-ssr renderer.";
      k(d, x), k(h, x);
    } else if (d == null || h == null) {
      var A = function(P, _) {
        if (P) {
          var L = P.elm, C = d || _.width, D = h || _.height;
          P.tag === "pattern" && (v ? (D = 1, C /= e.width) : g && (C = 1, D /= e.height)), P.attrs.width = C, P.attrs.height = D, L && (L.setAttribute("width", C), L.setAttribute("height", D));
        }
      }, m = xr(p, null, r, function(P) {
        f || A(N, P), A(l, P);
      });
      m && m.width && m.height && (d = d || m.width, h = h || m.height);
    }
    l = y("image", "img", {
      href: p,
      width: d,
      height: h
    }), o.width = d, o.height = h;
  } else
    n.svgElement && (l = yr(n.svgElement), o.width = n.svgWidth, o.height = n.svgHeight);
  if (l) {
    var S, c;
    f ? S = c = 1 : v ? (c = 1, S = o.width / e.width) : g ? (S = 1, c = o.height / e.height) : o.patternUnits = "userSpaceOnUse", S != null && !isNaN(S) && (o.width = S), c != null && !isNaN(c) && (o.height = c);
    var z = tr(n);
    z && (o.patternTransform = z);
    var N = y("pattern", "", o, [l]), E = B(N), M = a.patternCache, w = M[E];
    w || (w = a.zrId + "-p" + a.patternIdx++, M[E] = w, o.id = w, N = a.defs[w] = y("pattern", w, o, [l])), i[t] = R(w);
  }
}
function Hr(r, i, t) {
  var a = t.clipPathCache, n = t.defs, e = a[r.id];
  if (!e) {
    e = t.zrId + "-c" + t.clipPathIdx++;
    var o = {
      id: e
    };
    a[r.id] = e, n[e] = y("clipPath", e, o, [Q(r, t)]);
  }
  i["clip-path"] = R(e);
}
export {
  $r as brush,
  Ur as brushSVGImage,
  Q as brushSVGPath,
  Gr as brushSVGTSpan,
  Hr as setClipPath,
  Fr as setGradient,
  Vr as setPattern
};
//# sourceMappingURL=graphic.mjs.map
